subroutine E_emp_dist

use params
use mod_dp
USE olsroutines
USE Emax_approximation
USE probability
implicit none
LOGICAL ISNAN


REAL(DP) utility(2), income, ii_p, oop, check, rate_50
INTEGER count1
INTEGER i,j, n,m, k, t, ind_type, ed_type, health_type, hi_type, firm_index, health_shock, period, new_firm_index, med_care, next_health, count

REAL(DP) next_value1, next_value2, next_value3, next_value4, next_value5, next_value6, next_value7, next_value8, value_next(2), E_max_value, prob_health_next, &
prob_health_next1, prob_health_next2

REAL(DP) v_hi_new, v_ii_new, v_nhi_new, v_ehi_c, v_nhi_c, v_ii_c, v_u_nhi, v_u_ii, v_ump, v_current, v_new
REAL(DP) ex_v_hi_new, ex_v_nhi_new, ex_current 
REAL(DP), parameter:: const=1.0d0
INTEGER exp_next, work_exp

integer, parameter:: constreg=1

REAL(DP) denom
real(dp):: stats(5)
REAL(DP) ex_transit 

!$OMP PARALLEL NUM_THREADS(26) PRIVATE(work_exp, firm_index, hi_type, health_type, ed_type, ind_type  )
!$OMP DO
DO t=1, num_period 
DO work_exp=1, num_exp
DO firm_index=1, num_firm
DO hi_type=1, 2
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, t)=0.0d0
IF (work_exp<t+3) THEN
ex_v(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, t)= &

NORMCDF((value_emp(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, t)-value_unemp(ind_type, ed_type, health_type,work_exp, t))/pref_scale, 0.0d0, 1.0d0)
ELSE
ex_v(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, t)=0.0d0
END IF


END DO
END DO
END DO
END DO
END DO
END DO
END DO
!$OMP END DO
!$OMP END PARALLEL


DO t=1, num_period 
DO work_exp=1, num_exp
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
unemp_dist(ind_type, ed_type, health_type, work_exp, t)=0.0d0
END DO
END DO
END DO
END DO
END DO

unemp_dist(1, 1, 1, 1, 9)=frac_college*prob_type1(1)
unemp_dist(2, 1, 1, 1, 9)=frac_college*(1.0d0-prob_type1(1))
unemp_dist(1, 2, 1, 1, 1)=(1.0d0-frac_college)*prob_type1(2)
unemp_dist(2, 2, 1, 1, 1)=(1.0d0-frac_college)*(1.0d0-prob_type1(2))



DO period=1, num_period-1 

! start from employed workers

DO firm_index=1, num_firm
DO work_exp=1, num_exp !period+1
DO hi_type=1, 2
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type

IF (emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)>0.0d0) THEN

!start from employment
! by next period health status


DO next_health=1, num_health

!calculate the probability that the next period health is next_health
prob_health_next=(2.0d0-next_health)*exp(health_transit_emp(ind_type,ed_type,health_type,hi_type,firm_index,work_exp,period))/ &
(1.0d0+exp(health_transit_emp(ind_type,ed_type,health_type,hi_type,firm_index,work_exp,period)) ) &
+(next_health-1.0d0)*1.0d0/(1.0d0+exp(health_transit_emp(ind_type,ed_type,health_type,hi_type,firm_index,work_exp,period)) ) 


exp_next=min(work_exp+1,num_exp)


v_current=value_emp(ind_type,ed_type,next_health,hi_type,firm_index,exp_next, period+1)

v_ump=value_unemp(ind_type,ed_type,next_health,exp_next, period+1)

ex_current=ex_v(ind_type,ed_type,next_health,hi_type,firm_index,exp_next, period+1)

! MEETING 
DO new_firm_index=1, num_firm  
! next_value 2 is MEETING WITHOUT LAYOFF and MEET job with HI


!use following variables for simplifying the notation

v_hi_new=value_emp(ind_type,ed_type,next_health,2,new_firm_index,exp_next, period+1)
v_nhi_new=value_emp(ind_type,ed_type,next_health,1,new_firm_index,exp_next, period+1)

ex_v_hi_new=ex_v(ind_type,ed_type,next_health,2,new_firm_index,exp_next, period+1)
ex_v_nhi_new=ex_v(ind_type,ed_type,next_health,1,new_firm_index,exp_next, period+1)
! MEETING WITHOUT LAYOFF 

IF (v_hi_new==dmax1(v_hi_new, v_current)) THEN


ex_transit=ex_v_hi_new 


emp_dist(ind_type,ed_type,next_health,2,new_firm_index,exp_next, period+1)= &
emp_dist(ind_type,ed_type,next_health,2,new_firm_index,exp_next, period+1) &
+ex_transit*ehi_offer(new_firm_index)*(1.0d0-delta(ed_type))*lambda_e(ind_type, ed_type)*prob_meet(new_firm_index) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next

unemp_dist(ind_type,ed_type,next_health,exp_next, period+1)= &
unemp_dist(ind_type,ed_type,next_health,exp_next, period+1) &
+(1.0d0-ex_transit)*ehi_offer(new_firm_index)*(1.0d0-delta(ed_type))*lambda_e(ind_type, ed_type)*prob_meet(new_firm_index) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next


ELSE IF (v_current==dmax1(v_hi_new, v_current)) THEN

ex_transit=ex_current




emp_dist(ind_type,ed_type,next_health,hi_type,firm_index,exp_next, period+1)= &
emp_dist(ind_type,ed_type,next_health,hi_type,firm_index,exp_next, period+1) &
+ex_transit*ehi_offer(new_firm_index)*(1.0d0-delta(ed_type))*lambda_e(ind_type, ed_type)*prob_meet(new_firm_index) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next

unemp_dist(ind_type,ed_type,next_health,exp_next, period+1)= &
unemp_dist(ind_type,ed_type,next_health,exp_next, period+1) &
+(1.0d0-ex_transit)*ehi_offer(new_firm_index)*(1.0d0-delta(ed_type))*lambda_e(ind_type, ed_type)*prob_meet(new_firm_index) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next



END IF

IF (v_nhi_new==dmax1(v_nhi_new, v_current)) THEN

ex_transit=ex_v_nhi_new 



emp_dist(ind_type,ed_type,next_health,1,new_firm_index,exp_next, period+1)= &
emp_dist(ind_type,ed_type,next_health,1,new_firm_index,exp_next, period+1) &
+ex_transit*(1.0d0-ehi_offer(new_firm_index))*(1.0d0-delta(ed_type))*lambda_e(ind_type, ed_type)*prob_meet(new_firm_index) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next

unemp_dist(ind_type,ed_type,next_health,exp_next, period+1)= &
unemp_dist(ind_type,ed_type,next_health,exp_next, period+1) &
+(1.0d0-ex_transit)*(1.0d0-ehi_offer(new_firm_index))*(1.0d0-delta(ed_type))*lambda_e(ind_type, ed_type)*prob_meet(new_firm_index) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next



ELSE IF (v_current==dmax1(v_nhi_new, v_current)) THEN

ex_transit=ex_current 


emp_dist(ind_type,ed_type,next_health,hi_type,firm_index,exp_next, period+1)= &
emp_dist(ind_type,ed_type,next_health,hi_type,firm_index,exp_next, period+1) &
+ex_transit*(1.0d0-ehi_offer(new_firm_index))*(1.0d0-delta(ed_type))*lambda_e(ind_type, ed_type)*prob_meet(new_firm_index) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next

unemp_dist(ind_type,ed_type,next_health,exp_next, period+1)= &
unemp_dist(ind_type,ed_type,next_health,exp_next, period+1) &
+(1.0d0-ex_transit)*(1.0d0-ehi_offer(new_firm_index))*(1.0d0-delta(ed_type))*lambda_e(ind_type, ed_type)*prob_meet(new_firm_index) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next


END IF


! MEETING WITH LAYOFF


ex_transit=ex_v_hi_new 

emp_dist(ind_type,ed_type,next_health,2,new_firm_index,exp_next, period+1)= &
emp_dist(ind_type,ed_type,next_health,2,new_firm_index,exp_next, period+1) &
+ex_transit*ehi_offer(new_firm_index)*delta(ed_type)*lambda_e(ind_type, ed_type)*prob_meet(new_firm_index) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next

unemp_dist(ind_type,ed_type,next_health,exp_next, period+1)= &
unemp_dist(ind_type,ed_type,next_health,exp_next, period+1) &
+(1.0d0-ex_transit)*ehi_offer(new_firm_index)*delta(ed_type)*lambda_e(ind_type, ed_type)*prob_meet(new_firm_index) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next





ex_transit=ex_v_nhi_new 

emp_dist(ind_type,ed_type,next_health,1,new_firm_index,exp_next, period+1)= &
emp_dist(ind_type,ed_type,next_health,1,new_firm_index,exp_next, period+1) &
+ex_transit*(1.0d0-ehi_offer(new_firm_index))*delta(ed_type)*lambda_e(ind_type, ed_type)*prob_meet(new_firm_index) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next


unemp_dist(ind_type,ed_type,next_health,exp_next, period+1)= &
unemp_dist(ind_type,ed_type,next_health,exp_next, period+1) &
+(1.0d0-ex_transit)*(1.0d0-ehi_offer(new_firm_index))*delta(ed_type)*lambda_e(ind_type, ed_type)*prob_meet(new_firm_index) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next




!sum up all utility
END DO !new_firm_index


!NOT MEETING AND NO JOB DESTRUCTION

ex_transit=ex_current


emp_dist(ind_type,ed_type,next_health,hi_type,firm_index,exp_next, period+1)= &
emp_dist(ind_type,ed_type,next_health,hi_type,firm_index,exp_next, period+1) &
+ex_transit*(1.0d0-delta(ed_type))*(1.0d0-lambda_e(ind_type, ed_type)) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next


unemp_dist(ind_type,ed_type,next_health,exp_next, period+1)= &
unemp_dist(ind_type,ed_type,next_health,exp_next, period+1) &
+(1.0d0-ex_transit)*(1.0d0-delta(ed_type))*(1.0d0-lambda_e(ind_type, ed_type)) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next


!NOT MEETING AND JOB DESTRUCTION
unemp_dist(ind_type,ed_type,next_health,exp_next, period+1)= &
unemp_dist(ind_type,ed_type,next_health,exp_next, period+1) &
+delta(ed_type)*(1.0d0-lambda_e(ind_type, ed_type)) &
*emp_dist(ind_type, ed_type, health_type, hi_type, firm_index,work_exp, period)*prob_health_next

END DO !next_health





END IF !whether positive employment or not


END DO
END DO
END DO
END DO
END DO
END DO



! calculation for unemployed
IF (period<=8 ) THEN !8) THEN

DO work_exp=1, num_exp !period+1
DO health_type=1, num_health
DO ind_type=1, num_type


! NEXT PERIOD HEALTH 
DO next_health=1, num_health

prob_health_next=(2.0d0-next_health)*exp(health_transit_unemp(ind_type,2,health_type,work_exp,period))/ &
(1.0d0+exp(health_transit_unemp(ind_type,2,health_type,work_exp,period)) ) &
+(next_health-1.0d0)*1.0d0/(1.0d0+exp(health_transit_unemp(ind_type,2,health_type,work_exp,period)) ) 


v_ump=value_unemp(ind_type,2,next_health,work_exp, period+1)

DO new_firm_index=1, num_firm  

! next_value 2 is MEETING WITHOUT LAYOFF and MEET job with HI


!use following variables for simplifying the notation

v_hi_new=value_emp(ind_type,2,next_health,2,new_firm_index,work_exp, period+1)
v_nhi_new=value_emp(ind_type,2,next_health,1,new_firm_index,work_exp, period+1)

! MEETING WITH LAYOFF

ex_transit=ex_v(ind_type,2,next_health,2,new_firm_index,work_exp, period+1)

emp_dist(ind_type,2,next_health,2,new_firm_index,work_exp, period+1)= &
emp_dist(ind_type,2,next_health,2,new_firm_index,work_exp, period+1) &
+ex_transit*ehi_offer(new_firm_index)*lambda_u(ind_type,2)*prob_meet(new_firm_index) &
*unemp_dist(ind_type,2,health_type,work_exp, period)*prob_health_next


unemp_dist(ind_type,2,next_health,work_exp, period+1)= &
unemp_dist(ind_type,2,next_health,work_exp, period+1) &
+(1.0d0-ex_transit)*ehi_offer(new_firm_index)*lambda_u(ind_type,2)*prob_meet(new_firm_index) &
*unemp_dist(ind_type,2,health_type,work_exp, period)*prob_health_next


ex_transit=ex_v(ind_type,2,next_health,1,new_firm_index,work_exp, period+1)


emp_dist(ind_type,2,next_health,1,new_firm_index,work_exp, period+1)= &
emp_dist(ind_type,2,next_health,1,new_firm_index,work_exp, period+1) &
+ex_transit*(1.0d0-ehi_offer(new_firm_index))*lambda_u(ind_type,2)*prob_meet(new_firm_index) &
*unemp_dist(ind_type,2,health_type,work_exp, period)*prob_health_next



unemp_dist(ind_type,2,next_health,work_exp, period+1)= &
unemp_dist(ind_type,2,next_health,work_exp, period+1) &
+(1.0d0-ex_transit)*(1.0d0-ehi_offer(new_firm_index))*lambda_u(ind_type,2)*prob_meet(new_firm_index) &
*unemp_dist(ind_type,2,health_type,work_exp, period)*prob_health_next

 
END DO !new_firm_index

! NO MEETING

unemp_dist(ind_type,2,next_health,work_exp, period+1)= &
unemp_dist(ind_type,2,next_health,work_exp, period+1) &
+(1.0d0-lambda_u(ind_type,2) ) &
*unemp_dist(ind_type,2,health_type,work_exp, period)*prob_health_next

END DO !HEALTH


END DO
END DO
END DO


ELSE

DO work_exp=1, num_exp !period+1
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type


! NEXT PERIOD HEALTH
DO next_health=1, num_health

prob_health_next=(2.0d0-next_health)*exp(health_transit_unemp(ind_type,ed_type,health_type,work_exp,period))/ &
(1.0d0+exp(health_transit_unemp(ind_type,ed_type,health_type,work_exp,period)) ) &
+(next_health-1.0d0)*1.0d0/(1.0d0+exp(health_transit_unemp(ind_type,ed_type,health_type,work_exp,period)) ) 



v_ump=value_unemp(ind_type,ed_type,next_health,work_exp, period+1)

DO new_firm_index=1, num_firm  

! next_value 2 is MEETING WITHOUT LAYOFF and MEET job with HI


!use following variables for simplifying the notation

v_hi_new=value_emp(ind_type,ed_type,next_health,2,new_firm_index,work_exp, period+1)
v_nhi_new=value_emp(ind_type,ed_type,next_health,1,new_firm_index,work_exp, period+1)

! MEETING WITH LAYOFF

ex_transit=ex_v(ind_type,ed_type,next_health,2,new_firm_index,work_exp, period+1)

emp_dist(ind_type,ed_type,next_health,2,new_firm_index,work_exp, period+1)= &
emp_dist(ind_type,ed_type,next_health,2,new_firm_index,work_exp, period+1) &
+ex_transit*ehi_offer(new_firm_index)*lambda_u(ind_type,ed_type)*prob_meet(new_firm_index) &
*unemp_dist(ind_type,ed_type,health_type,work_exp, period)*prob_health_next


unemp_dist(ind_type,ed_type,next_health,work_exp, period+1)= &
unemp_dist(ind_type,ed_type,next_health,work_exp, period+1) &
+(1.0d0-ex_transit)*ehi_offer(new_firm_index)*lambda_u(ind_type,ed_type)*prob_meet(new_firm_index) &
*unemp_dist(ind_type,ed_type,health_type,work_exp, period)*prob_health_next


ex_transit=ex_v(ind_type,ed_type,next_health,1,new_firm_index,work_exp, period+1)


emp_dist(ind_type,ed_type,next_health,1,new_firm_index,work_exp, period+1)= &
emp_dist(ind_type,ed_type,next_health,1,new_firm_index,work_exp, period+1) &
+ex_transit*(1.0d0-ehi_offer(new_firm_index))*lambda_u(ind_type,ed_type)*prob_meet(new_firm_index) &
*unemp_dist(ind_type,ed_type,health_type,work_exp, period)*prob_health_next



unemp_dist(ind_type,ed_type,next_health,work_exp, period+1)= &
unemp_dist(ind_type,ed_type,next_health,work_exp, period+1) &
+(1.0d0-ex_transit)*(1.0d0-ehi_offer(new_firm_index))*lambda_u(ind_type,ed_type)*prob_meet(new_firm_index) &
*unemp_dist(ind_type,ed_type,health_type,work_exp, period)*prob_health_next

 
END DO !new_firm_index

! NO MEETING

unemp_dist(ind_type,ed_type,next_health,work_exp, period+1)= &
unemp_dist(ind_type,ed_type,next_health,work_exp, period+1) &
+(1.0d0-lambda_u(ind_type,ed_type) ) &
*unemp_dist(ind_type,ed_type,health_type,work_exp, period)*prob_health_next

END DO !HEALTH


END DO
END DO
END DO
END DO


END IF

END DO !period
 

DO firm_index=1, num_firm

DO ed_type=1, num_ed
premium_av(firm_index,ed_type)=0.0d0
size_worker_hi(firm_index,ed_type)=0.0d0
size_worker_nhi(firm_index,ed_type)=0.0d0
size_worker_hi_1(firm_index,ed_type)=0.0d0
size_worker_nhi_1(firm_index,ed_type)=0.0d0

DO period=1, num_period 
DO work_exp=1, num_exp !period
DO health_type=1, num_health
DO ind_type=1, num_type

DO hi_type=1, 2
emp_dist(ind_type,ed_type,health_type,hi_type,firm_index,work_exp, period)= &
emp_dist(ind_type,ed_type,health_type,hi_type,firm_index,work_exp, period)/ &
( prob_meet(firm_index)*((hi_type-1.0d0)*ehi_offer(firm_index)+(2.0d0-hi_type )*(1.0d0-ehi_offer(firm_index) ) ) ) &
    *cohort_weight(period, ed_type) 
END DO


size_worker_hi(firm_index,ed_type)=size_worker_hi(firm_index,ed_type)+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, period) &
*exp( alpha_w_1(ind_type)  +alpha_w_1_ed(ed_type) &
       +(alpha_w_4(ind_type)+alpha_w_4_ed(ed_type))*(work_exp-1) &
       +(alpha_w_5(ind_type)+alpha_w_5_ed(ed_type))*((work_exp-1)**2.0) & 
       +alpha_w_6(health_type) )

size_worker_hi_1(firm_index,ed_type)=size_worker_hi_1(firm_index,ed_type)+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, period) &
*exp( alpha_w_1(ind_type)  +alpha_w_1_ed(ed_type) &
       +(alpha_w_4(ind_type)+alpha_w_4_ed(ed_type))*(work_exp-1) &
       +(alpha_w_5(ind_type)+alpha_w_5_ed(ed_type))*((work_exp-1)**2.0) ) 


       
premium_av(firm_index,ed_type)=premium_av(firm_index,ed_type)+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, period) &
    *ex_med_f(ind_type, ed_type, health_type, 2, firm_index,work_exp, period)

size_worker_nhi(firm_index,ed_type)=size_worker_nhi(firm_index,ed_type)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, period) &
*exp( alpha_w_1(ind_type)  +alpha_w_1_ed(ed_type) &
       +(alpha_w_4(ind_type)+alpha_w_4_ed(ed_type))*(work_exp-1) &
       +(alpha_w_5(ind_type)+alpha_w_5_ed(ed_type))*((work_exp-1)**2.0) & 
       +alpha_w_6(health_type) )

size_worker_nhi_1(firm_index,ed_type)=size_worker_nhi_1(firm_index,ed_type)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, period) &
*exp( alpha_w_1(ind_type)  +alpha_w_1_ed(ed_type) &
       +(alpha_w_4(ind_type)+alpha_w_4_ed(ed_type))*(work_exp-1) &
       +(alpha_w_5(ind_type)+alpha_w_5_ed(ed_type))*((work_exp-1)**2.0) )


END DO
END DO
END DO
END DO


END DO

eq_size_nhi(firm_index,1)=sum(emp_dist(:, 1, :, 1, firm_index, :, :))
eq_size_hi(firm_index,1)=sum(emp_dist(:, 1, :, 2, firm_index,:, :))
eq_size_nhi(firm_index,2)=sum(emp_dist(:, 2, :, 1, firm_index, :, :))
eq_size_hi(firm_index,2)=sum(emp_dist(:, 2, :, 2, firm_index,:, :))



END DO










DO period=1, num_period 
DO work_exp=1, num_exp
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
unemp_dist(ind_type,ed_type,health_type,work_exp, period)=unemp_dist(ind_type,ed_type,health_type,work_exp, period)*cohort_weight(period, ed_type)
END DO
END DO
END DO
END DO
END DO

!!!!!!!! obtain size 50 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

DO i=1, num_50

size_50_all(i,1)=dble(i*1.0d0/num_50)*4.9d0/worker_size1
size_50_all(i,2)=4.9d0/worker_size1-size_50_all(i,1)

DO ed_type=1, num_ed

j=1
IF (eq_size_nhi(j,ed_type)<size_50_all(i,ed_type)  ) THEN
size_50_2(i,ed_type)=size_worker_nhi(j,ed_type)
size_50_3(i,ed_type)=size_worker_nhi_1(j,ed_type)
price_50(i,ed_type)=z_0(j,ed_type)
!calculate enployment distribution
DO period=1, num_period 
DO work_exp=1, num_exp
DO health_type=1, num_health
DO ind_type=1, num_type
emp_dist_50(ind_type,ed_type,health_type, i, work_exp, period)=emp_dist(ind_type,ed_type,health_type,1,j,work_exp, period)
END DO
END DO
END DO
END DO
END IF





DO j=1, num_firm-1

IF (eq_size_nhi(j,ed_type)<size_50_all(i,ed_type) .and. eq_size_nhi(j+1,ed_type)>size_50_all(i,ed_type) ) THEN
rate_50=(size_50_all(i,ed_type)-eq_size_nhi(j,ed_type))/(eq_size_nhi(j+1,ed_type)-eq_size_nhi(j,ed_type))
size_50_2(i,ed_type)=size_worker_nhi(j+1,ed_type)*rate_50+size_worker_nhi(j,ed_type)*(1.0d0-rate_50)
size_50_3(i,ed_type)=size_worker_nhi_1(j+1,ed_type)*rate_50+size_worker_nhi_1(j,ed_type)*(1.0d0-rate_50)
price_50(i,ed_type)=z_0(j+1,ed_type)*rate_50+z_0(j,ed_type)*(1.0d0-rate_50)
!calculate enployment distribution
DO period=1, num_period 
DO work_exp=1, num_exp
DO health_type=1, num_health
DO ind_type=1, num_type
emp_dist_50(ind_type,ed_type,health_type, i, work_exp, period)=emp_dist(ind_type, ed_type, health_type,1,j+1,work_exp, period)*rate_50 &
+emp_dist(ind_type,ed_type,health_type,1,j,work_exp, period)*(1.0d0-rate_50)
END DO
END DO
END DO
END DO

EXIT
END IF
END DO

END DO

END DO



end subroutine E_emp_dist