SUBROUTINE insurance_offer
! THIS SUBROUTINE WILL CALCULATE INSURANCE OFFERING AND PREMIUM AT EACH EMPLOYER

! 
use params
USE SIMULATED_ANNEALING1
USE SIMULATED_ANNEALING2
USE SIMULATED_ANNEALING3
! use minimization_fcn1
use mod_dp
use PROBABILITY

! need to specify next period value to be consistent with value

implicit none

LOGICAL ISNAN
LOGICAL     :: max

 
INTEGER ind_type, ed_type, health_type, hi_type, firm_index, hi_firm_index, period, ins_status, new_firm_index, work_exp
INTEGER med_care
INTEGER next_health
INTEGER i, j, k, m, t, x1, x2, x3
INTEGER prod_thres_1, prod_thres_0, prod_thres_0_50, prod_thres_0_50_1, max_profit_rank


REAL(DP) num_hi, num_nhi, value_hi, value_nhi, num_size, prof_hi(num_firm,2), prof_nhi(num_firm,2),size_hi(num_firm,2),size_nhi(num_firm,2), &
firm_size_1_hi(num_firm,2), firm_size_1_nhi(num_firm,2), prof_ratio, prof_sim(num_firm_sim)
!REAL(DP) premium_av(num_firm)
REAL(DP) max2, maxi
REAL(DP) prof_thres_0(2), prof_thres_1(2), integral, emp0, emp1, med1
! variable for simulated annealing
INTEGER, PARAMETER :: n = 1, neps = 4

REAL(DP)   :: lb(n), ub(n), xopt(n), c(n), vm(n), eps, rt, fopt, t1
INTEGER     :: ns, nt, nfcnev, ier, iseed1, iseed2, maxevl, iprint,  &
               nacc, nobds
REAL(DP), PARAMETER:: small_e=0.0001
INTEGER ifault
REAL(DP) var(1), step(1), solution(n), opt_solution(n)
REAL(DP) weight

INTERFACE
  SUBROUTINE prof_hi_s(n_n,wage_vec, profit_hi)
    USE mod_dp
    USE params
    IMPLICIT NONE
INTEGER, INTENT(IN):: n_n
REAL(DP), INTENT(IN):: wage_vec(n_n)
REAL(DP), INTENT(OUT):: profit_hi
  END SUBROUTINE prof_hi_s
END INTERFACE

INTERFACE
  SUBROUTINE prof_nhi_s(n_n,wage_vec, profit_nhi)
    USE mod_dp
    USE params
    IMPLICIT NONE
INTEGER, INTENT(IN):: n_n
REAL(DP), INTENT(IN):: wage_vec(n_n)
REAL(DP), INTENT(OUT):: profit_nhi
  END SUBROUTINE prof_nhi_s
END INTERFACE

INTERFACE
  SUBROUTINE prof_nhi_s_penalty(n_n,wage_vec, profit_nhi)
    USE mod_dp
    USE params
    IMPLICIT NONE
INTEGER, INTENT(IN):: n_n
REAL(DP), INTENT(IN):: wage_vec(n_n)
REAL(DP), INTENT(OUT):: profit_nhi
  END SUBROUTINE prof_nhi_s_penalty
END INTERFACE

! ASSIGN PARAMTER VALUE FOR SIMULATED ANNEALING
max = .false.
eps = 1.0D-6
rt = .5
iseed1 = 1
iseed2 = 2
ns = 20
nt = 100
maxevl = 100000
iprint = 0
vm(n) = 1.0d0
c(n) = 2.0d0
step=0.1
 t1 = 5.0d0  


! solve firm's problem until they hire positive measure of workers.
! nhi


firm_index_fix=1
j=firm_index_fix
lb(n) = z_sim(1)
ub(n) =  firm_prod(j)
solution(1)=0.5*(lb(n)+ub(n))

 t1 = 5.0d0 

DO ed_solve=1, 2
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!CALL sa2(n, solution, max, rt, eps, ns, nt, neps, maxevl, lb, ub, c, iprint, iseed1,  &
!        iseed2, t1, vm, opt_solution, prof_nhi(j,ed_solve), nacc, nfcnev, nobds, ier)                 
!                 
!
!IF (ISNAN(z_0_new(j,ed_solve))) THEN
!z_0_new(j,ed_solve)=z_0(j,ed_solve)
!prof_nhi(j,ed_solve)=0.0d0
!END IF
!                 
!z_0_new(j,ed_solve)=opt_solution(1)
!opt_solution(1)=0.0d0
!prof_nhi(j,ed_solve)=-prof_nhi(j,ed_solve)
!
!IF (ISNAN(z_0_new(j,ed_solve))) THEN
!z_0_new(j,ed_solve)=z_0(j,ed_solve)
!prof_nhi(j,ed_solve)=0.0d0
!END IF
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!  sppedy approach !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!! speedy approach !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
DO i=1, num_firm_sim
prof_sim(i)=firm_prod(1)*emp_dist_sim_1(i, 1,ed_solve)-(1.0d0+tax_f)*z_sim(i)*emp_dist_sim_2(i, 1,ed_solve)
prof_sim(i)=prof_sim(i)*worker_size1
END DO
max_profit_rank=MAXLOC(prof_sim, dim=1)
z_0_new(1,ed_solve)=z_sim(max_profit_rank)
prof_nhi(1,ed_solve)=prof_sim(max_profit_rank)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


!calculate equilibrium firm size and associated size variable used later
firm_size_1_nhi(j,ed_solve)=0.0d0
    x1=1
    x3=num_firm_sim    
    do while (x3-x1>1)
        x2=(x1+x3)/2
        if( z_sim(x2) > z_0_new(j,ed_solve) ) then
            x3=x2
        else
            x1=x2
        endif
    enddo

weight=(z_sim(x1+1)-z_0_new(j,ed_solve))/(z_sim(x1+1)-z_sim(x1))


DO t=1, num_period
DO work_exp=1,num_exp 
DO health_type=1, num_health
DO ind_type=1, num_type


firm_size_1_nhi(j,ed_solve)=firm_size_1_nhi(j,ed_solve)+(weight*emp_dist_sim(ind_type, ed_solve, health_type, 1, x1,work_exp, t) &
+(1.0d0-weight)*emp_dist_sim(ind_type, ed_solve, health_type, 1, x1+1,work_exp, t))

END DO
END DO
END DO
END DO

size_nhi(j,ed_solve)=size_worker_nhi(j,ed_solve)*firm_prod(j)


END DO !ed_solve


prod_thres_0=1


! hi
firm_index_fix=1
j=firm_index_fix
lb(n) = z_sim(1)
ub(n) =  firm_prod(j)
solution(1)=0.5*(lb(n)+ub(n))

 t1 = 5.0d0 
 
DO ed_solve=1,2 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!CALL sa1(n, solution, max, rt, eps, ns, nt, neps, maxevl, lb, ub, c, iprint, iseed1,  &
!        iseed2, t1, vm, opt_solution, prof_hi(j,ed_solve), nacc, nfcnev, nobds, ier)                 
!                  
!                  
!z_1_new(j,ed_solve)=opt_solution(1)
!opt_solution(1)=0.0d0
!prof_hi(j,ed_solve)=-prof_hi(j,ed_solve)
!
!IF (ISNAN(z_1_new(j,ed_solve))) THEN
!z_1_new(j,ed_solve)=z_1(j,ed_solve)
!prof_hi(j,ed_solve)=0.0d0
!END IF
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!  speedy approach !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
DO i=1, num_firm_sim
prof_sim(i)=firm_prod(1)*emp_dist_sim_1(i, 2,ed_solve)-(1.0d0+tax_f)*z_sim(i)*emp_dist_sim_2(i, 2,ed_solve)-med_dist_sim_1(i,ed_solve)
prof_sim(i)=prof_sim(i)*worker_size1
END DO
max_profit_rank=MAXLOC(prof_sim, dim=1)
z_1_new(1,ed_solve)=z_sim(max_profit_rank)
prof_hi(1,ed_solve)=prof_sim(max_profit_rank)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


firm_size_1_hi(j,ed_solve)=0.0d0
    x1=1
    x3=num_firm_sim    
    do while (x3-x1>1)
        x2=(x1+x3)/2
        if( z_sim(x2) > z_1_new(j,ed_solve) ) then
            x3=x2
        else
            x1=x2
        endif
    enddo

weight=(z_sim(x1+1)-z_1_new(j,ed_solve))/(z_sim(x1+1)-z_sim(x1))

DO t=1, num_period
DO work_exp=1,num_exp 
DO health_type=1, num_health
DO ind_type=1, num_type



firm_size_1_hi(j,ed_solve)=firm_size_1_hi(j,ed_solve)+(weight*emp_dist_sim(ind_type, ed_solve, health_type, 2, x1,work_exp, t) &
+(1.0d0-weight)*emp_dist_sim(ind_type, ed_solve, health_type, 2, x1+1,work_exp, t))*cohort_weight(t,ed_solve)



END DO
END DO
END DO
END DO

size_hi(j,ed_solve)=size_worker_hi(j,ed_solve)*firm_prod(j)
premium_av(j,ed_solve)=premium_av(j,ed_solve)/eq_size_hi(j,ed_solve)

END DO !ed_solve
  
ehi_premium_new(j)=premium_av(j,1)+premium_av(j,2)



prod_thres_1=1

DO ed_type=1, 2
prof_thres_0(ed_type)=prof_nhi(prod_thres_0,ed_type) /worker_size1
prof_thres_1(ed_type)=prof_hi(prod_thres_1,ed_type)/worker_size1
END DO

prof_thres_0=0
prof_thres_1=0

!!!!!!!!!!!!!!!!!!!!! Solve no ESHI firm's problem !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


DO j=prod_thres_0+1, num_firm

IF (sum(eq_size_nhi(j,:))<penalty_size   ) THEN

DO ed_type=1, 2

size_nhi(j,ed_type)=size_worker_nhi(j,ed_type) !*firm_prod(j)

integral=0.0d0
DO i=prod_thres_0, j-1
integral=integral+(size_worker_nhi(i,ed_type)+size_worker_nhi(i+1,ed_type))*(firm_prod(i+1)-firm_prod(i))*0.50d0
END DO

prof_thres_0(ed_type)=0.0d0

 
z_0_new(j,ed_type)=(firm_prod(j)*size_worker_nhi(j,ed_type)- (prof_thres_0(ed_type)+integral))/size_worker_nhi_1(j,ed_type)
z_0_new(j,ed_type)=z_0_new(j,ed_type)/(1.0d0+tax_f)
IF (z_0_new(j,ed_type)<0.0d0) THEN
! print*, z_0_new(j,ed_type), j, 'nhi'
z_0_new(j,ed_type)=z_0_new(j-1,ed_type)
END IF
IF (z_0_new(j-1,ed_type)>=z_0_new(j,ed_type)) THEN
! print*, z_0_new(j,ed_type), j, 'nhi'
z_0_new(j,ed_type)=z_0_new(j-1,ed_type)
END IF


prof_nhi(j,ed_type)=size_worker_nhi(j,ed_type)*firm_prod(j)- (1.0d0+tax_f)*size_worker_nhi_1(j,ed_type)*z_0_new(j,ed_type)
prof_nhi(j,ed_type)=prof_nhi(j,ed_type)*worker_size1


END DO !ed_type

ELSE
prod_thres_0_50=j
EXIT
END IF

END DO



!!!! calculate the potential wage combination generating size 50

DO j=prod_thres_0_50, num_firm

DO i=1, num_50
prof_50(i)=0.0d0
DO ed_type=1, num_ed
prof_50(i)=prof_50(i)+size_50_2(i,ed_type)*firm_prod(j)- (1.0d0+tax_f)*size_50_3(i,ed_type)*price_50(i,ed_type)
END DO
prof_50(i)=prof_50(i)*worker_size1
END DO

max_profit_rank=MAXLOC(prof_50, dim=1)

DO ed_type=1, num_ed
prof_50_temp(1,ed_type)=0.50d0*MAXVAL(prof_50)
z_50(1,ed_type)=price_50(max_profit_rank,ed_type)
eq_size_50(1,ed_type)=size_50_all(max_profit_rank, ed_type)
END DO

DO ed_solve=1, num_ed
!compare interior solution
firm_index_fix=j
lb(n) = z_0(prod_thres_0_50-1, ed_solve) 
ub(n) =  firm_prod(j)
solution(1)=lb(n)+0.02

 t1 = 5.0d0 


!CALL sa3(n, solution, max, rt, eps, ns, nt, neps, maxevl, lb, ub, c, iprint, iseed1,  &
!        iseed2, t1, vm, opt_solution, prof_50_temp(2,ed_solve), nacc, nfcnev, nobds, ier)                 
!                 
!z_50(2,ed_solve)=opt_solution(1)
!opt_solution(1)=0.0d0
!prof_50_temp(2,ed_solve)=-prof_50_temp(2,ed_solve)
 
!!!!!!!!!!!!!!!!!!!!  speedy approach !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
DO i=1, num_firm_sim
prof_sim(i)=firm_prod(j)*emp_dist_sim_1(i, 2,ed_solve)-(1.0d0+tax_f)*z_sim(i)*emp_dist_sim_2(i, 2,ed_solve)
prof_sim(i)=prof_sim(i)*worker_size1-worker_size1*(sum(emp_dist_sim(:, :, :, 1, i,:, :))-penalty_count)*emp_penalty
END DO
max_profit_rank=MAXLOC(prof_sim, dim=1)
z_50(2,ed_solve)=z_sim(max_profit_rank)
prof_50_temp(2,ed_solve)=prof_sim(max_profit_rank) 
 
 
END DO


IF (sum(prof_50_temp(1,:))> sum(prof_50_temp(2,:))   )   THEN
DO ed_type=1, num_ed
z_0_new(j,ed_type)=z_50(1,ed_type)
eq_size_nhi(j,ed_type)=eq_size_50(1,ed_type)
prof_nhi(j,ed_type)=prof_50_temp(1,ed_type)
emp_dist(:,ed_type,:,1,j,:,:)=emp_dist_50(:,ed_type,:,max_profit_rank,:,:)
END DO
ELSE
DO ed_type=1, num_ed
z_0_new(j,ed_type)=z_50(2,ed_type)
prof_nhi(j,ed_type)=prof_50_temp(2,ed_type)
END DO
prod_thres_0_50_1=j
EXIT
END IF
END DO

DO ed_type=1, 2
prof_thres_0(ed_type)=prof_nhi(prod_thres_0_50_1,ed_type) /worker_size1
prof_thres_1(ed_type)=prof_hi(prod_thres_0_50_1,ed_type)/worker_size1
END DO

! print*, prod_thres_0_50, prod_thres_0_50_1

DO j=prod_thres_0_50_1+1, num_firm

DO ed_type=1, 2

size_nhi(j,ed_type)=size_worker_nhi(j,ed_type) !*firm_prod(j)

integral=0.0d0
DO i=prod_thres_0_50_1, j-1
integral=integral+(size_worker_nhi(i,ed_type)+size_worker_nhi(i+1,ed_type))*(firm_prod(i+1)-firm_prod(i))*0.50d0
END DO


 
z_0_new(j,ed_type)=(firm_prod(j)*size_worker_nhi(j,ed_type)- (prof_thres_0(ed_type)+integral))/size_worker_nhi_1(j,ed_type) &
-(eq_size_nhi(j,ed_type)-0.5*penalty_count)*emp_penalty/size_worker_nhi_1(j,ed_type)
z_0_new(j,ed_type)=z_0_new(j,ed_type)/(1.0d0+tax_f)

IF (z_0_new(j,ed_type)<0.0d0) THEN
!print*, z_0_new(j,ed_type), j, 'nhi'
z_0_new(j,ed_type)=z_0_new(j-1,ed_type)
END IF
IF (z_0_new(j-1,ed_type)>=z_0_new(j,ed_type)) THEN
!print*, z_0_new(j,ed_type), j, 'nhi'
z_0_new(j,ed_type)=z_0_new(j-1,ed_type)
END IF


prof_nhi(j,ed_type)=size_worker_nhi(j,ed_type)*firm_prod(j)- (1.0d0+tax_f)*size_worker_nhi_1(j,ed_type)*z_0_new(j,ed_type)
prof_nhi(j,ed_type)=prof_nhi(j,ed_type)*worker_size1



END DO !ed_type






END DO


!!!!!!!!!!!!!!! SOLVE ESHI firm's problem



DO j=prod_thres_1+1, num_firm

DO ed_type=1, 2

size_hi(j,ed_type)=size_worker_hi(j,ed_type)

!derive optimal z_1 and z_0
premium_av(j,ed_type)=premium_av(j,ed_type)


integral=0.0d0
DO i=prod_thres_1, j-1
integral=integral+(size_worker_hi(i+1,ed_type)+size_worker_hi(i,ed_type))*(firm_prod(i+1)-firm_prod(i))*0.50d0

END DO

prof_thres_1(ed_type)=0.0d0

z_1_new(j,ed_type)=(firm_prod(j)*size_worker_hi(j,ed_type)- (prof_thres_1(ed_type)+integral+(1.0d0+tax_f*(1.0d0-ehi_tax_regime))*premium_av(j,ed_type))) /size_worker_hi_1(j,ed_type)
z_1_new(j,ed_type)=z_1_new(j,ed_type)/(1.0d0+tax_f)


IF (z_1_new(j,ed_type)<0.0d0) THEN
!print*, z_1_new(j,ed_type), j, 'hi'
z_1_new(j,ed_type)=z_1_new(j-1,ed_type)
END IF
IF (z_1_new(j-1,ed_type)>=z_1_new(j,ed_type)) THEN
!print*, z_1_new(j,ed_type), j, 'hi'
z_1_new(j,ed_type)=z_1_new(j-1,ed_type)
END IF


prof_hi(j,ed_type)=size_worker_hi(j,ed_type)*firm_prod(j)-(1.0d0+tax_f)*size_worker_hi_1(j,ed_type)*z_1_new(j,ed_type)-(1.0d0+tax_f*(1.0d0-ehi_tax_regime))*premium_av(j,ed_type)
prof_hi(j,ed_type)=prof_hi(j,ed_type)*worker_size1



END DO !ed_type

ehi_premium_new(j)=(premium_av(j,1)+premium_av(j,2) )/(eq_size_hi(j,1)+eq_size_hi(j,2) )

END DO
  
 

DO j=1, num_firm
!ehi_offer_new(j)=exp(prof_hi(j)/scale_prof)/(exp(prof_hi(j)/scale_prof)+exp(prof_nhi(j)/scale_prof))
IF (eq_size_nhi(j,1)+eq_size_nhi(j,2)<penalty_size) THEN
!IF (j<=prod_thres_0_50_1) THEN
prof_ratio=(-(prof_hi(j,1)+prof_hi(j,2)-loading_ehi)+prof_nhi(j,1)+prof_nhi(j,2))/scale_prof
ELSE
prof_ratio=(-(prof_hi(j,1)+prof_hi(j,2)-loading_ehi)+(prof_nhi(j,1)+prof_nhi(j,2)-worker_size1*(eq_size_nhi(j,1)+eq_size_nhi(j,2)-penalty_count)*emp_penalty))/scale_prof
END IF
IF (prof_ratio>-10.0d0 ) THEN
ehi_offer_new(j)=1.0d0/(1.0d0+exp(prof_ratio))
ELSE
ehi_offer_new(j)=0.99999999d0
END IF


END DO !firm type

IF (data_mode==2) THEN 


OPEN(100, file="eq_profit.txt")
DO i=1, num_firm
 write(100, *) prof_nhi(i,1)+prof_nhi(i,2), prof_hi(i,1)+prof_hi(i,2)-loading_ehi
! print*, ehi_offer_new(i), ehi_offer(i)
END DO 
CLOSE (100)

OPEN(100, file="z_function.txt")
DO i=1, num_firm
 write(100, *) z_0_new(i,1),z_0_new(i,2), z_1_new(i,1),z_1_new(i,2)
! print*, ehi_offer_new(i), ehi_offer(i)
END DO 
CLOSE (100)

OPEN(100, file="alpha_function.txt")
DO i=1, num_firm
 write(100, *) alpha_rate_0_new(i,1),alpha_rate_0_new(i,2), alpha_rate_1_new(i,1), alpha_rate_1_new(i,2)
! print*, ehi_offer_new(i), ehi_offer(i)
END DO 
CLOSE (100)


OPEN(100, file="ehi_offer_new.txt")
DO i=1, num_firm
 write(100, *) ehi_offer_new(i), ehi_offer(i)
! print*, ehi_offer_new(i), ehi_offer(i)
END DO 
CLOSE (100)

OPEN(100, file="ehi_premium.txt")
DO i=1, num_firm
 write(100, *) ehi_premium_new(i) 
! print*, ehi_premium_new(i), ehi_premium(i)
END DO 
CLOSE (100)

OPEN(100, file="z_1_comparison.txt")
DO i=1, num_firm
 write(100, *) z_1_new(i,1), z_1(i,1), z_1_new(i,2), z_1(i,2)
! print*, ehi_offer_new(i), ehi_offer(i)
END DO 
CLOSE (100)
 
OPEN(100, file="z_0_comparison.txt")
DO i=1, num_firm
 write(100, *) z_0_new(i,1), z_0(i,1), z_0_new(i,2), z_0(i,2)
! print*, ehi_offer_new(i), ehi_offer(i)
END DO 
CLOSE (100)
 


END IF
  
END SUBROUTINE