subroutine welfare

use params
use mod_dp
use PROBABILITY


implicit none

LOGICAL ISNAN

!integer num_param
REAL(DP) objective_value, obj_value, income_tax_revenue, im_revenue, premium_exp, income(2), ind_tax, ind_subsidy, utility(3), g_bb, utility_u(2), ins_cost
INTEGER ind_type, ed_type, health_type, hi_type, firm_index, hi_firm_index, age, period, health_shock, ins_status, new_firm_index
integer i, t, work_exp, j
REAL(DP) emp_mandate, em_revenue, productivity, gdp, emp_denom, pop_health, pop_health_emp, firm_prod_eq_dist(num_firm, 2)
REAL(DP) medical_exp, av_wage, wage_hi, wage_nhi, emp_denom_hi, emp_denom_nhi, unins_age(104), denom, prod_half, prod_half_age(104), prod_half_ed(104,2)
REAL(DP) unins_age_ed(104, num_ed), denom_ed(num_ed), hix_age_ed(104, num_ed), takeup_ed(104, num_ed), hix_age(104), takeup(104), hix_age2(num_period)
REAL(DP) unins_firm(num_firm), ind_subsidy1, pop_health_unins, denom_health_unins, eshi_age_ed(104, num_ed), eshi_age(104),denom_eshi, denom_eshi_ed(num_ed) 
REAL(DP) social_welfare
REAL(DP) pop_denom, uncomp_spend, pop_health_ii, denom_health_ii

CALL solve_eq

CALL firm_prod_est

pop_denom=0.0d0
productivity=0.0d0
gdp=0.0d0
emp_denom=0.0d0
av_wage=0.0d0
wage_hi=0.0d0
wage_nhi=0.0d0
medical_exp=0.0d0
emp_denom_hi=0.0d0
emp_denom_nhi=0.0d0

DO firm_index=1, num_firm
firm_prod_eq_dist(firm_index, 1)=0.0d0
firm_prod_eq_dist(firm_index, 2)=0.0d0
END DO

pop_health_ii=0.0d0
pop_health=0.0d0
pop_health_unins=0.0d0
social_welfare=0.0d0
income_tax_revenue=0.0d0
 im_revenue=0.0d0
 premium_exp=0.0d0
 em_revenue=0.0d0
 eshi_credit=0.0d0
 uncomp_spend=0.0d0
!evaluate welfare and government budget balance
DO t=19, num_period-6 
DO work_exp=1, t
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
!evaluate utility in consumption equivalent value
DO firm_index=1, num_firm
 

!! income tax, subsidies, and penalty 
income(1)=exp(alpha_w_1(ind_type)+alpha_w_1_ed(ed_type) &
       +(alpha_w_4(ind_type)+alpha_w_4_ed(ed_type))*(work_exp-1) &
       +(alpha_w_5(ind_type)+alpha_w_5_ed(ed_type))*((work_exp-1)**2.0)  )
income(2)=income(1)

wage_nhi=wage_nhi+income(1)*z_0_new(firm_index, ed_type)*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)

wage_hi=wage_hi+income(1)*z_1_new(firm_index, ed_type)*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)

emp_denom_hi=emp_denom_hi+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)
emp_denom_nhi=emp_denom_nhi+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)


pop_denom=pop_denom+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)
pop_denom=pop_denom+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)




av_wage=av_wage+income(1)*z_0_new(firm_index, ed_type)*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
av_wage=av_wage+income(1)*z_1_new(firm_index, ed_type)*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)

gdp=gdp+income(1)*firm_prod(firm_index)*exp(alpha_w_6(health_type))*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
gdp=gdp+income(2)*firm_prod(firm_index)*exp(alpha_w_6(health_type))*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)

emp_denom=emp_denom+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
emp_denom=emp_denom+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)

medical_exp=medical_exp+ex_med(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) &
*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)


medical_exp=medical_exp+ex_med(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)
medical_exp=medical_exp+ex_med_f(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)

firm_prod_eq_dist(firm_index, 1)=firm_prod_eq_dist(firm_index, 1)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) &
*income(1)*firm_prod(firm_index)*exp(alpha_w_6(health_type))
firm_prod_eq_dist(firm_index, 2)=firm_prod_eq_dist(firm_index, 2)+(emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)) &
*income(2)*firm_prod(firm_index)*exp(alpha_w_6(health_type))




income(1)=income(1)*z_0_new(firm_index, ed_type)
income(2)=income(2)*z_1_new(firm_index, ed_type)


IF (ehi_tax_regime==1) THEN


income_tax_revenue=income_tax_revenue+(income(1)-(-ltax0/30000.0d0+(ltax1*(income(1)*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0)  ) &
*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
income_tax_revenue=income_tax_revenue+(income(2)-(-ltax0/30000.0d0+(ltax1*(income(2)*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0)  ) &
* emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)

income_tax_revenue=income_tax_revenue+income(1)*tax_f*(emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) )*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
income_tax_revenue=income_tax_revenue+income(2)*tax_f*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)

ELSE IF (ehi_tax_regime==0) THEN
income_tax_revenue=income_tax_revenue+(income(1)-(-ltax0/30000.0d0+(ltax1*(income(1)*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0)  ) &
*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)

ins_cost=ehi_premium(firm_index)


income_tax_revenue=income_tax_revenue+(income(2)-(-ltax0/30000.0d0+(ltax1*((income(2)+ins_cost)*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0-ins_cost)  ) &
* emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)


income_tax_revenue=income_tax_revenue+income(1)*tax_f*(emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) )*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
income_tax_revenue=income_tax_revenue+income(2)*tax_f*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)
!income_tax_revenue=income_tax_revenue+ins_cost*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)


END IF


IF (uncomp==1) THEN
uncomp_spend=uncomp_spend+ex_uncomp(ind_type, ed_type, health_type, firm_index,work_exp, t)*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index) &
*choice_ii(ind_type, ed_type, health_type, firm_index, work_exp, t)
END IF



IF (optimal_dummy== 5) THEN ! optimal version 5
ind_tax=im_p(1)+im_p(2)*income(1)+im_p(3)*(income(1)**2.0d0)+im_p(4)*t+im_p(5)*(t**2.0d0)

!ind_tax=(1.0d0-ind_penalty_rate)*(income(1)-tax_thres)



ind_subsidy=alpha_s_0+alpha_s_1*income(1)+alpha_s_2*(income(1)**2.0d0)+beta_s_1*t+beta_s_2*(t**2.0d0)
ind_subsidy=1.0d0/(1.0d0/exp(ind_subsidy)+1.0d0)*hie_premium(t)

IF (ehi_tax_regime==0) THEN

        ind_subsidy1=alpha_s_0_e+alpha_s_1_e*income(2)+alpha_s_2_e*(income(2)**2.0d0)+beta_s_1_e*t+beta_s_2_e*(t**2.0d0)
        ind_subsidy1=1.0d0/(1.0d0/exp(ind_subsidy1)+1.0d0)*ehi_premium(firm_index)


eshi_credit=eshi_credit+ind_subsidy1 &
* emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)
END IF

!im_revenue=im_revenue+dmax1(ind_tax, ind_penalty)*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) &
im_revenue=im_revenue+ind_tax*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) &
*choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
premium_exp=premium_exp+ind_subsidy*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) & 
*(1.0d0-choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, t))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)


ELSE ! other optimal version
ind_tax=alpha_im_0+alpha_im_1*income(1)+alpha_im_2*(income(1)**2.0d0)+beta_im_1*t+beta_im_2*(t**2.0d0)
ind_tax=1.0d0/(1.0d0/exp(ind_tax)+1.0d0)*hie_premium(t)
im_revenue=im_revenue+ind_tax*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) &
*choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)


ind_subsidy=alpha_s_0+alpha_s_1*income(1)+alpha_s_2*(income(1)**2.0d0)+beta_s_1*t+beta_s_2*(t**2.0d0)
ind_subsidy=1.0d0/(1.0d0/exp(ind_subsidy)+1.0d0)*hie_premium(t)

IF (ehi_tax_regime==0) THEN
eshi_credit=eshi_credit+(eshi_weight*ind_subsidy+fixed_sub) &
* emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)
END IF

 


!im_revenue=im_revenue+ind_tax*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
premium_exp=premium_exp+ind_subsidy*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) & 
*(1.0d0-choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, t))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)



END IF




END DO
END DO
END DO
END DO
END DO
END DO

DO firm_index=1, num_firm
firm_prod_eq_dist(firm_index, 1)=firm_prod_eq_dist(firm_index, 1)/sum(emp_dist(:,:,:,1, firm_index,:, :))
firm_prod_eq_dist(firm_index, 2)=firm_prod_eq_dist(firm_index, 2)/sum(emp_dist(:,:,:,2, firm_index,:, :))
END DO


DO t=19, num_period-6
DO work_exp=1, num_exp
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
!evaluate utility in consumption equivalent value

medical_exp=medical_exp+ex_med_u(ind_type, ed_type, health_type, work_exp, t)*unemp_dist(ind_type, ed_type, health_type, work_exp, t)




IF (medicaid==0) THEN
ind_subsidy=0.0d0
ELSE
!ind_subsidy=hie_premium(t)
ind_subsidy=ex_med_u(ind_type, ed_type, health_type, work_exp, t)
END IF 

premium_exp=premium_exp+ind_subsidy*unemp_dist(ind_type, ed_type, health_type, work_exp, t)*(1.0d0-choice_ii_u(ind_type, ed_type, health_type, work_exp, t))


ind_tax=im_p(1)+im_p(4)*t+im_p(5)*(t**2.0d0)

!im_revenue=im_revenue+ind_penalty*unemp_dist(ind_type, ed_type, health_type, work_exp, t)*choice_ii_u(ind_type, ed_type, health_type, work_exp, t)
im_revenue=im_revenue+ind_tax*unemp_dist(ind_type, ed_type, health_type, work_exp, t)*choice_ii_u(ind_type, ed_type, health_type, work_exp, t)

END DO
END DO
END DO
END DO
END DO

social_welfare=social_welfare/pop_denom
income_tax_revenue=income_tax_revenue/pop_denom
premium_exp=premium_exp/pop_denom
im_revenue=im_revenue/pop_denom
medical_exp=medical_exp/pop_denom
eshi_credit=eshi_credit/pop_denom

! print*, social_welfare

! firm profit and em_mandate
DO i=1, num_firm
!social_welfare=social_welfare+ehi_offer_new(i)*prob_meet(i)*(eq_prof_hi(i,1)+eq_prof_hi(i,2))
!social_welfare=social_welfare+(1.0d0-ehi_offer_new(i))*prob_meet(i)*(eq_prof_nhi(i,1)+eq_prof_nhi(i,2))
em_revenue=em_revenue+NORMCDF(eq_size_nhi(i,1)+eq_size_nhi(i,2),penalty_size,scale_emp_penalty)*(eq_size_nhi(i,1)+eq_size_nhi(i,2)-penalty_count)*emp_penalty &
*(1.0d0-ehi_offer_new(i))*prob_meet(i)
END DO
em_revenue=em_revenue*worker_size1*pop_denom
! calculate government budget balance
! revenue
 
!expenditure
g_bb=im_revenue+income_tax_revenue+em_revenue-premium_exp-eshi_credit


social_welfare=frac_college*prob_type1(1)*value_unemp(1, 1, 1, 1, 1) &
+frac_college*(1.0d0-prob_type1(1))*value_unemp(2, 1, 1, 1, 1) &
+(1.0d0-frac_college)*prob_type1(2)*value_unemp(1, 2, 1, 1, 1) &
+(1.0d0-frac_college)*(1.0d0-prob_type1(2))*value_unemp(2, 2, 1, 1, 1)



productivity=gdp/emp_denom


pop_health=sum(unemp_dist(:, :, 2, :, 19:num_period-6))

DO firm_index=1, num_firm
pop_health=pop_health+sum(emp_dist(:, :, 2, 1, firm_index,:, 19:num_period-6)) *(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
pop_health=pop_health+sum(emp_dist(:, :, 2, 2, firm_index,:, 19:num_period-6))*ehi_offer(firm_index)*prob_meet(firm_index)
END DO


DO t=19, num_period-6
DO work_exp=1, num_exp
DO ed_type=1, num_ed
DO ind_type=1, num_type
pop_health_unins=pop_health_unins+unemp_dist(ind_type, ed_type, 2, work_exp, t)*choice_ii_u(ind_type, ed_type, 2, work_exp, t)
DO j=1, num_health
denom_health_unins=denom_health_unins+unemp_dist(ind_type, ed_type, j, work_exp, t)*choice_ii_u(ind_type, ed_type, j, work_exp, t)
END DO
DO firm_index=1, num_firm
pop_health_ii=pop_health_ii+emp_dist(ind_type, ed_type, 2, 1, firm_index,work_exp, t)*(1.0d0-choice_ii(ind_type, ed_type, 2, firm_index,work_exp, t))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
pop_health_unins=pop_health_unins+emp_dist(ind_type, ed_type, 2, 1, firm_index,work_exp, t)*choice_ii(ind_type, ed_type, 2, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
DO j=1, num_health
denom_health_ii=denom_health_ii+emp_dist(ind_type, ed_type, j, 1, firm_index,work_exp, t)*(1.0d0-choice_ii(ind_type, ed_type, j, firm_index,work_exp, t))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
denom_health_unins=denom_health_unins+emp_dist(ind_type, ed_type, j, 1, firm_index,work_exp, t)*choice_ii(ind_type, ed_type, j, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
END DO
END DO

END DO
END DO
END DO
END DO

pop_health=pop_health/pop_denom

pop_health_emp=pop_health/emp_denom

pop_health_unins=pop_health_unins/denom_health_unins

pop_health_ii=pop_health_ii/denom_health_ii


av_wage=av_wage/emp_denom
wage_hi=wage_hi/emp_denom_hi
wage_nhi=wage_nhi/emp_denom_nhi

prod_half=0.0d0
DO t=19, num_period-6 
DO work_exp=1, num_exp
DO firm_index=num_firm/2, num_firm
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
prod_half=prod_half+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) *(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
prod_half=prod_half+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)
END DO
END DO
END DO
END DO
END DO
END DO

prod_half=prod_half/emp_denom

DO i=1, 104
prod_half_age(i)=0.0d0
unins_age(i)=0.0d0
denom=0.0d0
hix_age(i)=0.0d0
takeup(i)=0.0d0
eshi_age(i)=0.0d0
DO ed_type=1, 2
unins_age_ed(i, ed_type)=0.0d0
denom_ed(ed_type)=0.0d0
hix_age_ed(i, ed_type)=0.0d0
takeup_ed(i, ed_type)=0.0d0
eshi_age_ed(i, ed_type)=0.0d0
denom_eshi_ed(ed_type)=0.0d0
END DO
 

DO firm_index=1, num_firm
DO work_exp=1, num_exp 
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
unins_age(i)=unins_age(i)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, i+18) &
*choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, i+18)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)




denom=denom+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, i+18)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index) & 
+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, i+18)*ehi_offer(firm_index)*prob_meet(firm_index)
hix_age(i)=hix_age(i)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, i+18) &
*(1.0d0-choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, i+18))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
takeup(i)=takeup(i)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, i+18)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
eshi_age(i)=eshi_age(i)+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, i+18)*ehi_offer(firm_index)*prob_meet(firm_index)

unins_age_ed(i, ed_type)=unins_age_ed(i, ed_type)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, i+18) &
*choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, i+18)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
denom_ed(ed_type)=denom_ed(ed_type)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, i+18)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index) & 
+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, i+18)*ehi_offer(firm_index)*prob_meet(firm_index)
hix_age_ed(i, ed_type)=hix_age_ed(i, ed_type)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, i+18) &
*(1.0d0-choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, i+18))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
takeup_ed(i, ed_type)=takeup_ed(i, ed_type)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, i+18)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
eshi_age_ed(i, ed_type)=eshi_age_ed(i, ed_type)+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, i+18)*ehi_offer(firm_index)*prob_meet(firm_index)
denom_eshi_ed(ed_type)=denom_eshi_ed(ed_type)+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, i+18)*ehi_offer(firm_index)*prob_meet(firm_index)



END DO
END DO
END DO
END DO
END DO

!unins_age(i)=unins_age(i)+sum(unemp_dist(:, :, :, 1, :, i+18))
!denom=denom+sum(unemp_dist(:, :, :, :, :, i+18))
eshi_age(i)=eshi_age(i)/denom
unins_age(i)=unins_age(i)/denom
takeup(i)=hix_age(i)/takeup(i)
DO ed_type=1, 2
unins_age_ed(i, ed_type)=unins_age_ed(i, ed_type)/denom_ed(ed_type)
takeup_ed(i, ed_type)=hix_age_ed(i, ed_type)/takeup_ed(i, ed_type)
eshi_age_ed(i, ed_type)=eshi_age_ed(i, ed_type)/denom_eshi_ed(ed_type)
END DO

hix_age(i)=hix_age(i)/sum(cohort_weight(i+18,:))

DO work_exp=1, num_exp 
DO firm_index=num_firm/2, num_firm
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
prod_half_age(i)=prod_half_age(i)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, i+18) *(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
prod_half_age(i)=prod_half_age(i)+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, i+18)*ehi_offer(firm_index)*prob_meet(firm_index)
END DO
END DO
END DO
END DO
END DO




!denom=denom-sum(unemp_dist(:, :, :, :, :, i+18))

prod_half_age(i)=prod_half_age(i)/denom

! by education
DO ind_type=1, num_type
prod_half_ed(i, ind_type)=0.0d0 
denom=0.0d0
DO firm_index=1, num_firm
denom=denom+sum(emp_dist(ind_type, :, :, 1, firm_index,:, i+18))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index) & 
+sum(emp_dist(ind_type, :, :, 2, firm_index,:, i+18))*ehi_offer(firm_index)*prob_meet(firm_index)
END DO

DO work_exp=1, num_exp
DO firm_index=num_firm/2, num_firm
DO health_type=1, num_health
DO ed_type=1, num_ed
prod_half_ed(i, ind_type)=prod_half_ed(i, ind_type)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, i+18)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
prod_half_ed(i, ind_type)=prod_half_ed(i, ind_type)+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, i+18)*ehi_offer(firm_index)*prob_meet(firm_index)
END DO
END DO
END DO
END DO

prod_half_ed(i, ind_type)=prod_half_ed(i, ind_type)/denom

END DO !ind_type

 
END DO 

DO t=1, 104
hix_age2(t)=0.0d0
DO firm_index=1, num_firm
DO work_exp=1, num_exp
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
hix_age2(t)=hix_age2(t)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) &
*(1.0d0-choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, t))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
END DO
END DO
END DO
END DO
END DO
hix_age2(t)=hix_age2(t)/sum(cohort_weight(t,:))
END DO




DO i=1, num_firm
unins_firm(i)=0.0d0
DO t=19, num_period-6
DO work_exp=1, num_exp 
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
unins_firm(i)=unins_firm(i)+ emp_dist(ind_type,ed_type, health_type, 1, i,work_exp, t)*choice_ii(ind_type,ed_type, health_type, i,work_exp, t)
END DO
END DO
END DO
END DO
END DO
unins_firm(i)=unins_firm(i)/sum(emp_dist(:, :, :, 1, i,:, :))
END DO

IF (data_mode==2) THEN 

OPEN(100, file="unins_firm.txt")
DO i=1, num_firm
write(100, *) unins_firm(i)
END DO
CLOSE (100)
 
OPEN(100, file="unins_age.txt")
DO i=1, 104
write(100, *) unins_age(i)
END DO
CLOSE (100)

OPEN(100, file="eshi_age_ed.txt")
DO i=1, 104
write(100, *) eshi_age_ed(i,1), eshi_age_ed(i,2)
END DO
CLOSE (100) 

OPEN(100, file="eshi_age.txt")
DO i=1, 104
write(100, *) eshi_age(i)
END DO
CLOSE (100) 

OPEN(100, file="unins_age_ed.txt")
DO i=1, 104
write(100, *) unins_age_ed(i,1), unins_age_ed(i,2)
END DO
CLOSE (100) 

OPEN(100, file="hix_age_ed.txt")
DO i=1, 104
write(100, *) hix_age_ed(i,1), hix_age_ed(i,2)
END DO
CLOSE (100) 

OPEN(100, file="hix_age2.txt")
DO i=1, num_period
write(100, *) hix_age2(i)
END DO
CLOSE (100) 



OPEN(100, file="takeup_ed.txt")
DO i=1, 104
write(100, *) takeup_ed(i,1), takeup_ed(i,2)
END DO
CLOSE (100) 

OPEN(100, file="hix_age.txt")
DO i=1, 104
write(100, *) hix_age(i)
END DO
CLOSE (100) 

OPEN(100, file="takeup.txt")
DO i=1, 104
write(100, *) takeup(i)
END DO
CLOSE (100) 


OPEN(100, file="prod_age.txt")
DO i=1, 104
write(100, *) prod_half_age(i)
END DO
CLOSE (100)

OPEN(100, file="prod_college.txt")
DO i=1, 104
write(100, *) prod_half_ed(i,1)
END DO
CLOSE (100)

OPEN(100, file="prod_noncollege.txt")
DO i=1, 104
write(100, *) prod_half_ed(i,2)
END DO
CLOSE (100)

OPEN(100, file="firm_prod_eq_dist.txt")
DO i=1, num_firm
write(100, *) firm_prod_eq_dist(i,1), firm_prod_eq_dist(i,2)
END DO
CLOSE (100)

END IF

OPEN(100, file="welfare.txt")
write(100, *) social_welfare
CLOSE (100)



IF (data_mode==2) THEN 

OPEN(100, file="summary_result.txt")
write(100, *) social_welfare, 'social welfare' 
write(100, *) g_bb, 'total expendiure'
write(100, *) im_revenue, 'im total'
write(100, *) em_revenue, 'em total'
write(100, *) income_tax_revenue, 'income_tax_revenue'
write(100, *) premium_exp, 'premium_exp'
write(100, *) eshi_credit, 'ESHI_credit'
write(100, *) productivity, 'productivity'
write(100, *) gdp, 'gdp'
write(100, *) prod_half, 'prod_half'
write(100, *) entry_cost, 'entry_cost(profit)'
write(100, *) pop_health, 'pop_health'
write(100, *) pop_health_emp, 'pop_health_emp'
write(100, *) pop_health_unins, 'pop_health_emp'
write(100, *) pop_health_ii, 'pop_health_ii'
write(100, *) av_wage, 'av_wage'
write(100, *) wage_hi, 'wage_hi'
write(100, *) wage_nhi, 'wage_nhi'
write(100, *) medical_exp, 'medical_exp'
write(100, *) uncomp_spend, 'uncomp_spend'
write(100, *) g_bb-uncomp_spend, 'net expenditure'
CLOSE (100)

OPEN(100, file="budget.txt")
write(100, *) g_bb/worker_size1
CLOSE (100)

END IF
end subroutine