subroutine draw_rn


use params
use random
use mod_dp
use probability


implicit none

LOGICAL ISNAN


real(dp) quitter
integer:: i,j,k,n,m,t, tt, nump !index
integer maxi
real(DP):: max2, denom
INTEGER	   :: iseed(2),isize,in
INTEGER index_sim, index_sim_ed

!initial condition for simulated individual
! GIVE INITIAL CONDITION
DO i=1, num_sim
emp_sim(i, 1)=0
firm_sim(i,1)=0
health_sim(i,1)=1
hi_sim(i,1)=1
exp_sim(i,1)=1 ! 1 is zero experience
END DO

index_sim_ed=floor(frac_college*num_sim)

DO i=1,index_sim_ed
ed_sim(i)=1
END DO

DO i=index_sim_ed+1,num_sim
ed_sim(i)=2
END DO

index_sim=floor(prob_type1(1)*index_sim_ed)
DO i=1, index_sim
ind_type_sim(i)=1
END DO

DO i=index_sim+1, index_sim_ed
ind_type_sim(i)=2 
END DO

index_sim=floor(prob_type1(2)*(num_sim-index_sim_ed))
DO i=index_sim_ed+1, index_sim+index_sim_ed
ind_type_sim(i)=1
END DO

DO i=index_sim+1+index_sim_ed, num_sim
ind_type_sim(i)=2 
END DO

!assign prob_meet and cum_meet


!set random number seed
isize = 2
iseed(1) = 7755
iseed(2) = 7744
CALL RANDOM_SEED(size = isize)
CALL RANDOM_SEED(put = iseed)

!feed in productivtiy


DO i = 1,num_firm
	firm_prod(i) = random_normal()
END DO



!SORT PRODUCTIVITY
  DO i = 1, num_firm - 1
    max2 = firm_prod(i)
    maxi = i
    DO j = i + 1, num_firm
      IF ( firm_prod(j) < max2 ) THEN
        max2 = firm_prod(j)
        maxi = j
      END IF
    END DO
    IF ( maxi /= i ) THEN
      firm_prod(maxi) = firm_prod(i)
      firm_prod(i) = max2
    END IF
  END DO



firm_prod(1)=0.10d0 !exp(-0.50d0)
firm_prod(num_firm)=exp(2.00d0)  !20.00d0
 
DO i=2, num_firm-1
firm_prod(i)=firm_prod(1)+(i-1)*(firm_prod(num_firm)-firm_prod(1))/(num_firm-1)
END DO


!probability
denom=0.0d0 
DO i=1, num_firm
prob_meet(i)= LOGNORMPDF(firm_prod(i),0.00d0,(sigma_prod)**2.0d0)
denom=denom+prob_meet(i)
END DO
 
DO i=1, num_firm
prob_meet(i)=prob_meet(i)/denom
!!
END DO
  

!create cum_meet
cum_meet(1)=prob_meet(1)
DO k=2, num_firm
cum_meet(k)=cum_meet(k-1)+prob_meet(k)
END DO

IF (data_mode==2) THEN 

OPEN(100, file="firm_prod.txt")
DO i=1, num_firm
 write(100, *) firm_prod(i)
END DO 
CLOSE (100)



!
OPEN(100, file="prob_meet.txt")
DO i=1, num_firm
 write(100, *) cum_meet(i), prob_meet(i)
END DO 
CLOSE (100)

END IF

!!!!!!!!!!!!!!! discretize z_sim grid !!!!!!!!!!!!!!!!!!!!!!!!!!
z_sim(1)=0.01d0
z_sim(num_firm_sim)=firm_prod(1)

DO i=2, num_firm_sim-1
z_sim(i)=z_sim(1)+(i-1)*(z_sim(num_firm_sim)-z_sim(1))/(num_firm_sim-1.0d0)
END DO
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


!! some of codes below were used for an interpolation method (Keane and Wolpin) in the early stage of this project.  

!simulate random number to select state space
CALL RANDOM_SEED(size = isize)
CALL RANDOM_SEED(put = iseed)
call random_number(state_ind_e)
call random_number(state_ind_u)
call random_number(state_health_e)
call random_number(state_health_u)
call random_number(state_firm_e)
call random_number(state_exp_e)
call random_number(state_exp_u)
!isize = 2
!iseed(1) = 7722
!iseed(2) = 7711
!CALL RANDOM_SEED(size = isize)
!CALL RANDOM_SEED(put = iseed)
call random_number(state_ed_e)
call random_number(state_ed_u)
!isize = 2
!iseed(1) = 7700
!iseed(2) = 7699
!CALL RANDOM_SEED(size = isize)
!CALL RANDOM_SEED(put = iseed)
call random_number(state_ins_e)
call random_number(state_ins_u)



DO t=1, num_period
DO i=1, num_emax_e
emax_ind_e(i,t)=floor(num_type*state_ind_e(i,t))+1
emax_health_e(i,t)=floor(num_health*state_health_e(i,t))+1
emax_ed_e(i,t)=floor(num_ed*state_ed_e(i,t))+1
emax_ins_e(i,t)=floor(2*state_ins_e(i,t))+1
emax_firm_e(i,t)=floor(num_firm_sim*state_firm_e(i,t))+1
IF (t>num_exp-10) THEN
emax_exp_e(i,t)=floor(num_exp*state_exp_e(i,t))+1
ELSE 
emax_exp_e(i,t)=floor((t+9)*state_exp_e(i,t))+1
END IF
END DO
!DO i=1, num_emax_e_ed
!emax_ed_e(i,t)=1
!END DO
!DO i=num_emax_e_ed+1, num_emax_e
!emax_ed_e(i,t)=2
!END DO
END DO

DO t=1, num_period
DO i=1, num_emax_u
emax_ind_u(i,t)=floor(num_type*state_ind_u(i,t))+1
emax_ed_u(i,t)=floor(num_ed*state_ed_u(i,t))+1
emax_health_u(i,t)=floor(num_health*state_health_u(i,t))+1
IF (t>num_exp-10) THEN
emax_exp_u(i,t)=floor(num_exp*state_exp_u(i,t))+1
ELSE 
emax_exp_u(i,t)=floor((t+9)*state_exp_u(i,t))+1
END IF
END DO

!DO i=1, num_emax_u_ed
!emax_ed_u(i,t)=1
!END DO
!DO i=num_emax_u_ed+1, num_emax_u
!emax_ed_u(i,t)=2
!END DO


END DO




CALL RANDOM_SEED(size = isize)
CALL RANDOM_SEED(put = iseed)
call random_number(prob_firm)
call random_number(prob_lambda_u)
call random_number(prob_lambda_e)
call random_number(prob_delta)
call random_number(prob_health_shock)
call random_number(prob_health_change)
call random_number(prob_hi_offer)
call random_number(pref_work)
call random_number(ii_shock)
!draw integer based on rando number draw

DO t=1, num_period
DO i=1, num_sim




IF (lambda_u(ind_type_sim(i),ed_sim(i))>prob_lambda_u(i,t)) THEN
offer_u_sim(i,t)=1
ELSE 
offer_u_sim(i,t)=0
END IF
IF (delta(ed_sim(i))>prob_delta(i,t)) THEN
layoff_sim(i,t)=1
ELSE 
layoff_sim(i,t)=0
END IF
IF (lambda_e(ind_type_sim(i),ed_sim(i))>prob_lambda_e(i,t)) THEN
offer_e_sim(i,t)=1
ELSE 
offer_e_sim(i,t)=0
END IF

IF (prob_firm(i,t)<=cum_meet(1)) THEN
offer_firm_sim(i, t)=1
END IF
DO k=1, num_firm-1
IF (prob_firm(i,t)>cum_meet(k) .and. prob_firm(i,t)<=cum_meet(k+1)) THEN
offer_firm_sim(i, t)=k+1
EXIT
END IF
END DO

END DO !i
END DO !t

!new_health_sim(:,:)

! draw health shock: both for value function and for simulation 

DO i = 1,num_health_shock
	health_draw(i) = random_normal()
	ind_prod_draw(i)=random_normal()
END DO
!OPEN(100, file="simulation_draw.txt")
!DO i=1, num_health_shock
! write(100, *) 	health_draw(i)
!END DO
!CLOSE(1)



DO t=1, num_period
DO i=1, num_sim
health_draw_sim(i,t)=random_normal()
ind_prod_draw_sim(i,t)=random_normal()
END DO
END DO

std_ind_prod=0.0d0

DO i=1, num_health_shock
health_draw(i)=health_draw(i) !*sigma_m
ind_prod_draw(i)=ind_prod_draw(i)*std_ind_prod
END DO

! first, simulate to the vector and then recreate matrix for health_draw_sim
DO t=1, num_period
DO i=1, num_sim
health_draw_sim(i,t)=health_draw_sim(i,t) !*sigma_m
ind_prod_draw_sim(i,t)=ind_prod_draw_sim(i,t)*std_ind_prod
END DO
END DO

! create matrix for regression
rank_reg_e=41
rank_reg_u=17
 

ALLOCATE (reg_e(num_emax_e,rank_reg_e-1,num_period), reg_u(num_emax_u,rank_reg_u-1,num_period), &
coeff_emax_u(rank_reg_u,num_period), coeff_emax_e(rank_reg_e,num_period),& 
ste_emax_u(rank_reg_u,num_period), ste_emax_e(rank_reg_e,num_period), &
coeff_health_u(rank_reg_u,num_period), coeff_health_e(rank_reg_e,num_period),& 
ste_health_u(rank_reg_u,num_period), ste_health_e(rank_reg_e,num_period), coeff_ehi_e(rank_reg_e,num_period), ste_ehi_e(rank_reg_e,num_period) )

!

DO t=1, num_period

DO i=1, num_emax_e
DO j=1, rank_reg_e-1
reg_e(i,j,t)=0.0d0
END DO


IF (emax_ind_e(i,t)==2) THEN
reg_e(i,1,t)=1
reg_e(i,2,t)=z_sim(emax_firm_e(i,t))
reg_e(i,3,t)=emax_exp_e(i,t)
END IF
IF (emax_health_e(i,t)==2) THEN
reg_e(i,4,t)=1
reg_e(i,5,t)=z_sim(emax_firm_e(i,t))
reg_e(i,6,t)=emax_exp_e(i,t)
END IF
IF (emax_ins_e(i,t)==2) THEN
reg_e(i,7,t)=1
reg_e(i,8,t)=z_sim(emax_firm_e(i,t))
reg_e(i,9,t)=emax_exp_e(i,t)
reg_e(i,10,t)=z_sim(emax_firm_e(i,t))**2.0d0
reg_e(i,11,t)=z_sim(emax_firm_e(i,t))**3.0d0

END IF



IF (emax_ind_e(i,t)==2 .and. emax_health_e(i,t)==2) THEN
reg_e(i,12,t)=1
reg_e(i,13,t)=z_sim(emax_firm_e(i,t))
reg_e(i,14,t)=emax_exp_e(i,t)
END IF

IF (emax_ind_e(i,t)==2 .and. emax_ins_e(i,t)==2) THEN
reg_e(i,15,t)=1
reg_e(i,16,t)=z_sim(emax_firm_e(i,t))
reg_e(i,17,t)=emax_exp_e(i,t)
END IF




IF (emax_health_e(i,t)==2 .and. emax_ins_e(i,t)==2) THEN
reg_e(i,18,t)=1
reg_e(i,19,t)=z_sim(emax_firm_e(i,t))
reg_e(i,20,t)=emax_exp_e(i,t)
END IF


!
!
reg_e(i,21,t)=z_sim(emax_firm_e(i,t))
reg_e(i,22,t)=z_sim(emax_firm_e(i,t))**2.0d0
reg_e(i,23,t)=z_sim(emax_firm_e(i,t))**3.0d0
reg_e(i,24,t)=z_sim(emax_firm_e(i,t))**4.0d0
reg_e(i,25,t)=emax_exp_e(i,t)
reg_e(i,26,t)=emax_exp_e(i,t)**2.0d0
reg_e(i,27,t)=emax_exp_e(i,t)**3.0d0
reg_e(i,28,t)=emax_exp_e(i,t)**4.0d0

IF (emax_ed_e(i,t)==2) THEN
reg_e(i,29,t)=1
reg_e(i,30,t)=z_sim(emax_firm_e(i,t))
reg_e(i,31,t)=emax_exp_e(i,t)
END IF

IF (emax_ed_e(i,t)==2 .and. emax_health_e(i,t)==2) THEN
reg_e(i,32,t)=1
reg_e(i,33,t)=z_sim(emax_firm_e(i,t))
reg_e(i,34,t)=emax_exp_e(i,t)
END IF

IF (emax_ed_e(i,t)==2 .and. emax_ind_e(i,t)==2) THEN
reg_e(i,35,t)=1
reg_e(i,36,t)=z_sim(emax_firm_e(i,t))
reg_e(i,37,t)=emax_exp_e(i,t)
END IF

IF (emax_ed_e(i,t)==2 .and. emax_ins_e(i,t)==2) THEN
reg_e(i,38,t)=1
reg_e(i,39,t)=z_sim(emax_firm_e(i,t))
reg_e(i,40,t)=emax_exp_e(i,t)
END IF


END Do !i



DO i=1, num_emax_u
DO j=1, rank_reg_u-1
reg_u(i,j,t)=0.0d0
END DO
IF (emax_ind_u(i,t)==2) THEN
reg_u(i,1,t)=1
reg_u(i,2,t)=emax_exp_u(i,t)
END IF
IF (emax_health_u(i,t)==2) THEN
reg_u(i,3,t)=1
reg_u(i,4,t)=emax_exp_u(i,t)
END IF

IF (emax_ind_u(i,t)==2 .and. emax_health_u(i,t)==2) THEN
reg_u(i,5,t)=1
reg_u(i,6,t)=emax_exp_u(i,t)
END IF

reg_u(i,7,t)=emax_exp_u(i,t)
reg_u(i,8,t)=emax_exp_u(i,t)**2.0d0
reg_u(i,9,t)=emax_exp_u(i,t)**3.0d0
reg_u(i,10,t)=emax_exp_u(i,t)**4.0d0

IF (emax_ed_u(i,t)==2) THEN
reg_u(i,11,t)=1
reg_u(i,12,t)=emax_exp_u(i,t)
END IF

IF (emax_ed_u(i,t)==2 .and. emax_health_u(i,t)==2) THEN
reg_u(i,13,t)=1
reg_u(i,14,t)=emax_exp_u(i,t)
END IF

IF (emax_ed_u(i,t)==2 .and. emax_ind_u(i,t)==2) THEN
reg_u(i,15,t)=1
reg_u(i,16,t)=emax_exp_u(i,t)
END IF


END Do !i

END DO !t


! NOT USED (discretize health shock) !!!!!!!!!!!!!!!!!!!

!call sub_qnwnorm1(medical_shock,prob_med_shock,nm)



END SUBROUTINE