SUBROUTINE insurance_offer
! THIS SUBROUTINE WILL CALCULATE INSURANCE OFFERING AND PREMIUM AT EACH EMPLOYER

! 
use params
USE SIMULATED_ANNEALING1
USE SIMULATED_ANNEALING2
! use minimization_fcn1
use mod_dp



implicit none

LOGICAL ISNAN
LOGICAL     :: max


INTEGER ind_type, ed_type, health_type, hi_type, firm_index, hi_firm_index, period, ins_status, new_firm_index, work_exp
INTEGER med_care
INTEGER next_health
INTEGER i, j, k, m, t, x1, x2, x3
INTEGER prod_thres_1, prod_thres_0, max_profit_rank, grid_exp, skill_exp

REAL(DP) num_hi, num_nhi, value_hi, value_nhi, num_size, prof_hi(num_firm,num_ed,num_wage_exp), prof_nhi(num_firm,num_ed,num_wage_exp),size_hi(num_firm,2),size_nhi(num_firm,2), &
firm_size_1_hi(num_firm,num_ed,num_wage_exp), firm_size_1_nhi(num_firm,num_ed,num_wage_exp), prof_ratio
!REAL(DP) premium_av(num_firm)
REAL(DP) max2, maxi
REAL(DP) prof_thres_0(num_ed,num_wage_exp), prof_thres_1(num_ed,num_wage_exp), integral, emp0, emp1, med1, prof_sim(num_firm_sim)
! variable for simulated annealing
INTEGER, PARAMETER :: n = 1, neps = 4

REAL(DP)   :: lb(n), ub(n), xopt(n), c(n), vm(n), eps, rt, fopt, t1
INTEGER     :: ns, nt, nfcnev, ier, iseed1, iseed2, maxevl, iprint,  &
               nacc, nobds
REAL(DP), PARAMETER:: small_e=0.0001
INTEGER ifault
REAL(DP) var(1), step(1), solution(n), opt_solution(n)
REAL(DP) weight

INTERFACE
  SUBROUTINE prof_hi_s(n_n,wage_vec, profit_hi)
    USE mod_dp
    USE params
    IMPLICIT NONE
INTEGER, INTENT(IN):: n_n
REAL(DP), INTENT(IN):: wage_vec(n_n)
REAL(DP), INTENT(OUT):: profit_hi
  END SUBROUTINE prof_hi_s
END INTERFACE

INTERFACE
  SUBROUTINE prof_nhi_s(n_n,wage_vec, profit_nhi)
    USE mod_dp
    USE params
    IMPLICIT NONE
INTEGER, INTENT(IN):: n_n
REAL(DP), INTENT(IN):: wage_vec(n_n)
REAL(DP), INTENT(OUT):: profit_nhi
  END SUBROUTINE prof_nhi_s
END INTERFACE



! ASSIGN PARAMTER VALUE FOR SIMULATED ANNEALING
max = .false.
eps = 1.0D-1
rt = .5
iseed1 = 1
iseed2 = 2
ns = 20
nt = 100
maxevl = 1000000
iprint = 0
vm(n) = 1.0d0
c(n) = 2.0d0
step=0.1
 t1 = 5.0d0  


! solve firm's problem until they hire positive measure of workers.
! nhi

!DO firm_index_fix=1, num_firm
firm_index_fix=1
j=firm_index_fix
lb(n) = z_sim(1)
ub(n) =  firm_prod(j)
solution(1)=0.5*(lb(n)+ub(n))

 t1 = 5.0d0 

DO skill_solve=1, num_wage_exp 
 
DO ed_solve=1, 2

opt_solution(1)=0.0d0

!!!!!!!!!!!   full solution approach !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!CALL sa2(n, solution, max, rt, eps, ns, nt, neps, maxevl, lb, ub, c, iprint, iseed1,  &
!        iseed2, t1, vm, opt_solution, prof_nhi(j,ed_solve), nacc, nfcnev, nobds, ier)                 
!
!z_0_new(j,ed_solve)=opt_solution(1)
!prof_nhi(j,ed_solve)=-prof_nhi(j,ed_solve)
!        
!        
!IF (ISNAN(opt_solution(1)) .or. opt_solution(1)==0.0d0 ) THEN
!z_0_new(j,ed_solve)=z_0(j,ed_solve)
!prof_nhi(j,ed_solve)=0.0d0
!END IF
!                 
!
!IF (ISNAN(z_0_new(j,ed_solve)) ) THEN
!z_0_new(j,ed_solve)=z_0(j,ed_solve)
!prof_nhi(j,ed_solve)=0.0d0
!END IF
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!! speedy approach !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
DO i=1, num_firm_sim
prof_sim(i)=firm_prod(1)*emp_dist_sim_1(i, 1,ed_solve,skill_solve)-(1.0d0+tax_f)*z_sim(i)*emp_dist_sim_2(i, 1,ed_solve, skill_solve)
prof_sim(i)=prof_sim(i)*worker_size1
END DO
max_profit_rank=MAXLOC(prof_sim, dim=1)
z_0_new(1,ed_solve,skill_solve)=z_sim(max_profit_rank)
prof_nhi(1,ed_solve, skill_solve)=prof_sim(max_profit_rank)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

firm_size_1_nhi(j,ed_solve, skill_exp)=0.0d0
    x1=1
    x3=num_firm_sim    
 !       IF (wage>=wage_grid(1)) THEN
    do while (x3-x1>1)
        x2=(x1+x3)/2
        if( z_sim(x2) > z_0_new(j,ed_solve, skill_exp) ) then
            x3=x2
        else
            x1=x2
        endif
    enddo

weight=(z_sim(x1+1)-z_0_new(j,ed_solve, skill_solve))/(z_sim(x1+1)-z_sim(x1))


DO t=1, num_period
DO work_exp=1,num_exp 
DO health_type=1, num_health
DO ind_type=1, num_type

grid_exp=(work_exp-1)/num_wage_rank+1

IF (grid_exp==skill_solve) THEN

firm_size_1_nhi(j,ed_solve, skill_solve)=firm_size_1_nhi(j,ed_solve, skill_solve)+(weight*emp_dist_sim(ind_type, ed_solve, health_type, 1, x1,work_exp, t) &
+(1.0d0-weight)*emp_dist_sim(ind_type, ed_solve, health_type, 1, x1+1,work_exp, t))


END IF

END DO
END DO
END DO
END DO

! size_nhi(j,ed_solve)=size_worker_nhi(j,ed_solve)*firm_prod(j)


END DO !ed_solve

END DO !skill_exp


prod_thres_0=1



! hi
!DO firm_index_fix=1, num_firm
firm_index_fix=1
j=firm_index_fix
lb(n) = z_sim(1)
ub(n) =  firm_prod(j)

solution(1)=0.5*(lb(n)+ub(n))

 t1 = 5.0d0 
 
DO ed_solve=1,2 

DO skill_solve=1, num_wage_exp
!!!!!!!!!!!   full solution approach !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!        opt_solution(1)=0.0d0
!
!CALL sa1(n, solution, max, rt, eps, ns, nt, neps, maxevl, lb, ub, c, iprint, iseed1,  &
!        iseed2, t1, vm, opt_solution, prof_hi(j,ed_solve), nacc, nfcnev, nobds, ier)                 
!
!
!z_1_new(j,ed_solve)=opt_solution(1)
!prof_hi(j,ed_solve)=-prof_hi(j,ed_solve)
!
!        
!        
!IF (ISNAN(opt_solution(1)) .or. opt_solution(1)==0.0d0 ) THEN
!z_1_new(j,ed_solve)=z_1(j,ed_solve)
!prof_nhi(j,ed_solve)=0.0d0
!END IF        
!        
!        
!
!IF (ISNAN(z_1_new(j,ed_solve))) THEN
!z_1_new(j,ed_solve)=z_1(j,ed_solve)
!prof_hi(j,ed_solve)=0.0d0
!END IF
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!! speedy approach !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
DO i=1, num_firm_sim
prof_sim(i)=firm_prod(1)*emp_dist_sim_1(i, 2,ed_solve,skill_solve)-(1.0d0+tax_f)*z_sim(i)*emp_dist_sim_2(i, 2,ed_solve,skill_solve)-(1.0+tax_f*(1.0d0-ehi_tax_regime))*med_dist_sim_1(i,ed_solve,skill_solve)
prof_sim(i)=prof_sim(i)*worker_size1
END DO
max_profit_rank=MAXLOC(prof_sim, dim=1)
z_1_new(1,ed_solve,skill_solve)=z_sim(max_profit_rank)
prof_hi(1,ed_solve,skill_solve)=prof_sim(max_profit_rank)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


firm_size_1_hi(j,ed_solve,skill_solve)=0.0d0
    x1=1
    x3=num_firm_sim    
    do while (x3-x1>1)
        x2=(x1+x3)/2
        if( z_sim(x2) > z_1_new(j,ed_solve,skill_solve) ) then
            x3=x2
        else
            x1=x2
        endif
    enddo

weight=(z_sim(x1+1)-z_1_new(j,ed_solve,skill_solve))/(z_sim(x1+1)-z_sim(x1))

DO t=1, num_period
DO work_exp=1,num_exp 
DO health_type=1, num_health
DO ind_type=1, num_type

grid_exp=(work_exp-1)/num_wage_rank+1

IF (grid_exp==skill_solve) THEN

firm_size_1_hi(j,ed_solve,skill_solve)=firm_size_1_hi(j,ed_solve,skill_solve)+(weight*emp_dist_sim(ind_type, ed_solve, health_type, 2, x1,work_exp, t) &
+(1.0d0-weight)*emp_dist_sim(ind_type, ed_solve, health_type, 2, x1+1,work_exp, t))*cohort_weight(t,ed_solve)

END IF

END DO
END DO
END DO
END DO



END DO !ed_solve

END DO !skill_exp
ehi_premium(j)=sum(premium_av(j,:,:)) /sum(eq_size_hi(j,:)) 


prod_thres_1=1

DO ed_type=1, 2

DO skill_exp=1, num_wage_exp

prof_thres_0(ed_type,skill_solve)=prof_nhi(prod_thres_0,ed_type,skill_solve) /worker_size1
prof_thres_1(ed_type,skill_solve)=prof_hi(prod_thres_1,ed_type,skill_solve)/worker_size1

END DO
 
END DO
! complete the remaining
! nhi 

DO j=prod_thres_0+1, num_firm

DO ed_type=1, 2

DO skill_exp=1, num_wage_exp


! size_nhi(j,ed_type)=size_worker_nhi(j,ed_type) !*firm_prod(j)

integral=0.0d0
DO i=prod_thres_0, j-1

integral=integral+(size_worker_nhi(i,ed_type, skill_exp)+size_worker_nhi(i+1,ed_type, skill_exp))*(firm_prod(i+1)-firm_prod(i))*0.50d0

END DO

! prof_thres_0(ed_type)=0.0d0

 
z_0_new(j,ed_type, skill_exp)=(firm_prod(j)*size_worker_nhi(j,ed_type, skill_exp)- (prof_thres_0(ed_type, skill_exp)+integral))/size_worker_nhi_1(j,ed_type, skill_exp)
z_0_new(j,ed_type, skill_exp)=z_0_new(j,ed_type, skill_exp)/(1.0d0+tax_f)
IF (z_0_new(j,ed_type, skill_exp)<0.0d0) THEN
!print*, z_0_new(j,ed_type, skill_exp), j, 'nhi'
z_0_new(j,ed_type, skill_exp)=z_0_new(j-1,ed_type, skill_exp)
END IF
IF (z_0_new(j-1,ed_type, skill_exp)>=z_0_new(j,ed_type, skill_exp)) THEN
!print*, z_0_new(j,ed_type, skill_exp), j, 'nhi'
z_0_new(j,ed_type, skill_exp)=z_0_new(j-1,ed_type, skill_exp)
END IF



prof_nhi(j,ed_type, skill_exp)=size_worker_nhi(j,ed_type, skill_exp)*firm_prod(j)- (1.0d0+tax_f)*size_worker_nhi_1(j,ed_type, skill_exp)*z_0_new(j,ed_type, skill_exp)
prof_nhi(j,ed_type, skill_exp)=prof_nhi(j,ed_type, skill_exp)*worker_size1




END DO !ed_type

END DO


END DO


DO j=prod_thres_1+1, num_firm

DO skill_exp=1, num_wage_exp

DO ed_type=1, 2


integral=0.0d0
DO i=prod_thres_1, j-1

integral=integral+(size_worker_hi(i+1,ed_type, skill_exp)+size_worker_hi(i,ed_type, skill_exp))*(firm_prod(i+1)-firm_prod(i))*0.50d0


END DO


z_1_new(j,ed_type, skill_exp)=(firm_prod(j)*size_worker_hi(j,ed_type, skill_exp)- (prof_thres_1(ed_type, skill_exp)+integral+(1.0+tax_f*(1.0d0-ehi_tax_regime))*premium_av(j,ed_type, skill_exp))) /size_worker_hi_1(j,ed_type, skill_exp)
z_1_new(j,ed_type, skill_exp)=z_1_new(j,ed_type, skill_exp)/(1.0d0+tax_f)
IF (z_1_new(j,ed_type, skill_exp)<0.0d0) THEN
!print*, z_1_new(j,ed_type, skill_exp), j, 'hi'
z_1_new(j,ed_type, skill_exp)=z_1_new(j-1,ed_type, skill_exp)
END IF
IF (z_1_new(j-1,ed_type, skill_exp)>=z_1_new(j,ed_type, skill_exp)) THEN
!print*, z_1_new(j,ed_type, skill_exp), j, 'hi'
z_1_new(j,ed_type, skill_exp)=z_1_new(j-1,ed_type, skill_exp)
END IF


prof_hi(j,ed_type, skill_exp)=size_worker_hi(j,ed_type, skill_exp)*firm_prod(j)-(1.0d0+tax_f)*size_worker_hi_1(j,ed_type, skill_exp)*z_1_new(j,ed_type, skill_exp)-(1.0+tax_f*(1.0d0-ehi_tax_regime))*premium_av(j,ed_type, skill_exp)
prof_hi(j,ed_type, skill_exp)=prof_hi(j,ed_type, skill_exp)*worker_size1



END DO !ed_type

END DO

ehi_premium(j)=sum(premium_av(j,:,:)) /sum(eq_size_hi(j,:))  

END DO
  
 

DO j=1, num_firm
!ehi_offer_new(j)=exp(prof_hi(j)/scale_prof)/(exp(prof_hi(j)/scale_prof)+exp(prof_nhi(j)/scale_prof))
prof_ratio=(-(sum(prof_hi(j,:,:))-loading_ehi)+(sum(prof_nhi(j,:,:))))/scale_prof
IF (prof_ratio>-10.0d0 ) THEN
ehi_offer_new(j)=1.0d0/(1.0d0+exp(prof_ratio))
ELSE
ehi_offer_new(j)=0.99999999d0
END IF


END DO !firm type

IF (data_mode==2) THEN 


OPEN(100, file="eq_profit.txt")
DO i=1, num_firm
 write(100, *) sum(prof_nhi(i,:,:)), sum(prof_hi(i,:,:))-loading_ehi
! print*, ehi_offer_new(i), ehi_offer(i)
 END DO 
CLOSE (100)

OPEN(100, file="z_function.txt")
DO i=1, num_firm
DO skill_exp=1, num_wage_exp
 write(100, *) z_0_new(i,1,skill_exp),z_0_new(i,2,skill_exp), z_1_new(i,1,skill_exp),z_1_new(i,2,skill_exp)
! print*, ehi_offer_new(i), ehi_offer(i)
END DO
 END DO 
CLOSE (100)

OPEN(100, file="alpha_function.txt")
DO i=1, num_firm
DO skill_exp=1, num_wage_exp
write(100, *) alpha_rate_0_new(i,1,skill_exp),alpha_rate_0_new(i,2,skill_exp), alpha_rate_1_new(i,1,skill_exp), alpha_rate_1_new(i,2,skill_exp)
! print*, ehi_offer_new(i), ehi_offer(i)
END DO
END DO 
CLOSE (100)


OPEN(100, file="ehi_offer_new.txt")
DO i=1, num_firm
 write(100, *) ehi_offer_new(i), ehi_offer(i)
! print*, ehi_offer_new(i), ehi_offer(i)
END DO 
CLOSE (100)

OPEN(100, file="ehi_premium.txt")
DO i=1, num_firm
 write(100, *) ehi_premium_new(i) 
! print*, ehi_premium_new(i), ehi_premium(i)
END DO 
CLOSE (100)

OPEN(100, file="z_1_comparison.txt")
DO i=1, num_firm
DO skill_exp=1, num_wage_exp
 write(100, *) z_1_new(i,1,skill_exp), z_1(i,1,skill_exp), z_1_new(i,2,skill_exp), z_1(i,2,skill_exp)
! print*, ehi_offer_new(i), ehi_offer(i)
END DO
 END DO 
CLOSE (100)
 
OPEN(100, file="z_0_comparison.txt")
DO i=1, num_firm
DO skill_exp=1, num_wage_exp
 write(100, *) z_0_new(i,1,skill_exp), z_0(i,1,skill_exp), z_0_new(i,2,skill_exp), z_0(i,2,skill_exp)
! print*, ehi_offer_new(i), ehi_offer(i)
END DO
END DO 
CLOSE (100)
 


END IF
  
END SUBROUTINE