module params

use mod_dp

implicit none
 
!!!!!!!!!!!!!  Insurance product !!!!!!!!!!!!!!!!!!!!!!!!
REAL(DP), parameter::coins=0.18d0, deduc=0.023d0
REAL(DP), parameter::coins_ii=0.25d0, deduc_ii=0.025d0
!REAL(DP), parameter::coins_ii=0.00025d0, deduc_ii=0.00025d0 !0.075/3.0d0 !, max_ii=0.4d0/3.0d0
!REAL(DP), parameter::coins_ii=0.25d0, deduc_ii=0.0d0
REAL(DP), allocatable:: reject(:)
REAL(DP)  cons_floor
INTEGER ehi_tax_regime
REAL(DP), parameter:: tax_f=0.0765d0
!!!!!!!!!!!!!! data read dummy !!!!!!!!!!!!!!!!!!!!!!!!!!
integer, parameter:: num_wage_exp=1
integer num_wage_rank, moment_vector
integer data_mode, omp_mode, non_converge, cons_mode
integer, parameter:: sample_size=8352, sample_size_meps=17952, sample_size_firm=18782
INTEGER ESHI_offer_sample(sample_size_firm)
REAL(DP) firm_size_sample(sample_size_firm), weight_firm_sample(sample_size_firm)
REAL(DP) wage_error(sample_size,12)
REAL(dp), allocatable:: var_est(:), step_est(:)
INTEGER age_data_meps(sample_size_meps),  health_data_meps(sample_size_meps), hi_data_meps(sample_size_meps), ed_data_meps(sample_size_meps)
INTEGER ue_data(sample_size,11), eu_data(sample_size,11), emp_data(sample_size,12), & 
hi_data(sample_size,12), health_data(sample_size,2), age_data(sample_size,4),jj_data(sample_size,11), hi_u_data(sample_size, 12)  
REAL(DP) wage_data(sample_size,12),  cohort_data(40), ed(sample_size, 4), health_taransition_denom(2,5,2)
INTEGER health_1_data_meps(sample_size_meps), hi_emp_data_meps(sample_size_meps), emp_data_meps(sample_size_meps), ins_1_data_meps(sample_size_meps)
REAL(DP) med_exp_sample(sample_size_meps)
INTEGER, parameter:: num_data_period=12, num_data_period_1=11
REAL(DP), allocatable:: residual_mat_1(:,:), residual_mat_2(:,:), residual_mat_3(:,:), residual_mat_4(:,:), Hessian_inv_all(:,:)
REAL(DP), allocatable:: ind_moments(:,:,:,:,:), ind_moments1(:,:,:,:), ind_moments3(:,:,:), firm_moment_value(:,:)
REAL(DP), allocatable:: ind_a_moments(:,:,:), ind_a_moments1(:,:,:), ind_a_moments3(:,:), Sens_mat(:,:)

!!!!!!!!!!!! estimator !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer num_param_est, param_number_est
real(dp) moment_value_est
real(dp), allocatable:: param_est(:), v_cv_weight(:,:,:), v_cv_weight1(:,:), v_firm(:), residual_mat(:,:)
integer num_moment1, num_moment2, num_moment3, num_moment4

integer:: num_sim, num_type, num_ed, num_health, num_firm, num_health_shock, num_period, num_emax_e, num_emax_u , num_exp, num_firm_sim, num_ins, num_emax_e_ed, num_emax_u_ed 
integer:: maxit 
!paramters
 !PREFERENCE PARAMETER
REAL(dp) eta, disutilwork, ump_flow, beta, eta_u, pref_scale, pref_ii
REAL(dp), allocatable:: theta(:,:), gamma(:)
!HEALTH SHOCK PARAMTERS
REAL(DP), allocatable:: alpha_m(:)
REAL(DP) beta_m(2), gamma_m(2), sigma_m(2), kappa(2), eta1_m(2), eta2_m(2)
!LABOR MARKET FRICTION PARAMETER
REAL(DP) delta(2), lambda_u(2,2), lambda_e(2,2)    
!WAGE PARAMETER 
REAL(dp), allocatable :: alpha_w_1(:), alpha_w_1_ed(:), alpha_w_2(:),  alpha_w_2_ed(:), & 
        alpha_w_3(:), alpha_w_3_ed(:), alpha_w_4(:), alpha_w_4_ed(:), alpha_w_5(:), alpha_w_5_ed(:), &
        term_type(:), term_ed(:), term_health(:), alpha_w_6(:) !WAGE PARAMETER TYPE SPECIFIC
REAL(dp) std_ind_prod, sigma_wage_error        
!PARAMTER IN INDIVIDUAL INSURANCE
REAL(DP), ALLOCATABLE:: alpha_m_i(:),p_ii(:,:) 
REAL(DP) beta_m_i, gamma_m_i, sigma_m_i   
!PARAMETER IN HEALTH TRANSITION FUNCTION
REAL(DP), allocatable::  alpha_1_k(:,:), alpha_2_k(:,:), alpha_3_k(:,:), alpha_4_k(:,:), alpha_5_k(:,:),alpha_6_k(:,:),alpha_7_k(:)  
! PARAMTER FOR employers
REAL(DP), ALLOCATABLE:: prob_meet(:), cum_meet(:), firm_prod(:)
REAL(DP) sigma_prod
! LOADING FACTOR
REAL(DP) loading_ehi
!TYPE PARAMETER
REAL(DP), ALLOCATABLE:: prob_type1(:)
! FIRM SIDE PARAMETER
REAL(DP) shape_prod, shift_prod, worker_size1, scale_prof
! SIMULATION IN E_MAX
REAL(DP), ALLOCATABLE:: state_ind_e(:,:), state_ind_u(:,:), state_ed_e(:,:), state_ed_u(:,:)
REAL(DP), ALLOCATABLE:: state_health_e(:,:), state_health_u(:,:), state_firm_e(:,:)
REAL(DP), ALLOCATABLE:: state_ins_e(:,:), state_ins_u(:,:)
REAL(DP), ALLOCATABLE:: state_exp_e(:,:), state_exp_u(:,:)
INTEGER, allocatable:: emax_ind_e(:,:), emax_ind_u(:,:), emax_ed_e(:,:), emax_ed_u(:,:)
INTEGER, allocatable:: emax_health_e(:,:), emax_health_u(:,:), emax_firm_e(:,:)
INTEGER, allocatable:: emax_ins_e(:,:), emax_ins_u(:,:)
INTEGER, allocatable:: emax_exp_e(:,:), emax_exp_u(:,:)
REAL(DP), allocatable:: E_max_value_e(:),E_max_value_u(:), E_health_transit_e(:), E_health_transit_u(:), E_ehi_e(:) 
! E_MAX regression
REAL(DP) SST, SSE
INTEGER rank_reg_e, rank_reg_u
REAL(DP), ALLOCATABLE:: reg_e(:,:,:), reg_u(:,:,:), coeff_emax_u(:,:), coeff_emax_e(:,:), ste_emax_u(:,:), ste_emax_e(:,:), & 
coeff_health_u(:,:), coeff_health_e(:,:), ste_health_u(:,:), ste_health_e(:,:), coeff_ehi_e(:,:), ste_ehi_e(:,:)

!EQUILIBRIUM OBJECTS
INTEGER firm_index_fix, ed_solve, skill_solve
REAL(DP), ALLOCATABLE:: ehi_premium(:), ehi_offer(:), ehi_premium_new(:), ehi_offer_new(:)
REAL(DP), allocatable:: ex_v(:,:,:,:,:,:,:), value_emp(:,:,:,:,:,:,:), value_emp_sim(:,:,:,:,:,:,:), value_unemp(:,:,:,:,:), emp_dist(:,:,:,:,:,:,:), unemp_dist(:,:,:,:,:), emp_dist_sim(:,:,:,:,:,:,:)
REAL(DP), allocatable:: health_transit_emp(:,:,:,:,:,:,:), health_transit_unemp(:,:,:,:,:), ex_med(:,:,:,:,:,:,:), ex_med_sim(:,:,:,:,:,:,:), ex_med_sim_f(:,:,:,:,:,:,:)
REAL(DP), allocatable:: emp_dist_sim_1(:,:,:,:), emp_dist_sim_2(:,:,:,:), med_dist_sim_1(:,:,:), size_worker_hi(:,:,:), size_worker_nhi(:,:,:), size_worker_hi_1(:,:,:), size_worker_nhi_1(:,:,:), premium_av(:,:,:)
REAL(DP), ALLOCATABLE:: alpha_rate_0(:,:,:), alpha_rate_1(:,:,:), alpha_rate_0_new(:,:,:), alpha_rate_1_new(:,:,:)
REAL(DP), ALLOCATABLE:: z_0(:,:,:), z_1(:,:,:), z_0_new(:,:,:), z_1_new(:,:,:)
REAL(DP), ALLOCATABLE:: z_sim(:), ex_med_u(:, :, :, :, :)
REAL(DP), ALLOCATABLE:: eq_size_hi(:,:), eq_size_nhi(:,:)
REAL(DP), ALLOCATABLE:: emp_dist_hi(:,:,:,:,:,:,:), emp_dist_nhi(:,:,:,:,:,:,:), & 
unemp_dist_f(:,:,:,:,:,:,:), & 
emp_dist_u(:,:,:,:,:,:,:), unemp_dist_u(:,:,:,:,:), ex_med_f(:,:,:,:,:,:,:) 



!random number
REAL(DP), ALLOCATABLE:: prob_firm(:,:), prob_lambda_u(:,:), prob_lambda_e(:,:), prob_delta(:,:), &
prob_health_shock(:,:), prob_health_change(:,:), prob_hi_offer(:,:), pref_work(:,:)
! simulated state variable
INTEGER, ALLOCATABLE:: emp_sim(:,:), hi_sim(:,:), ed_sim(:), firm_sim(:,:), ind_type_sim(:), health_sim(:,:), exp_sim(:,:) 
! simulated choice variable
INTEGER, ALLOCATABLE:: ue_sim(:,:), ee_sim(:,:), eu_sim(:,:), med_care_sim(:,:), ins_gain_sim(:,:), ins_loss_sim(:,:)
! health shock
REAL(DP), ALLOCATABLE:: health_draw(:), health_draw_sim(:,:), health_draw_sim_all(:), ind_prod_draw(:), ind_prod_draw_sim(:,:)
INTEGER, ALLOCATABLE:: offer_u_sim(:,:), offer_e_sim(:,:), layoff_sim(:,:), new_health_sim(:,:), hi_offer_sim(:,:), &
                        offer_firm_sim(:, :), prob_health_draw(:)
                        !hi_offer_sim takes 0 or 1
INTEGER, ALLOCATABLE:: ii_sim(:,:)
REAL(DP), ALLOCATABLE:: ii_shock(:,:)


real(dp):: ltax0, ltax1, ltax2
REAL(DP), parameter:: age_dis=69.0d0
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!firm side moments
REAL(DP) mean_offer_rate, m_mean_size, m_hioffer_s, m_hioffer_l , m_size_hi, m_size_nhi, size_frac_50, wage_size_50(2), & 
firm_mean_wage_hi, firm_mean_wage_nhi, firm_std_wage_hi, firm_std_wage_nhi, firm_mean_wage_all, firm_std_wage_all
REAL(DP) emp_mean_wage_all, emp_mean_wage_hi, emp_mean_wage_nhi, emp_std_wage_all
REAL(DP) emp_std_wage_hi, emp_std_wage_nhi, emp_age_s, emp_age_l , emp_age_hi, emp_age_nhi
!VARIABLES FOR FIRM DISTRIBUTION
REAL(DP), ALLOCATABLE:: emp_dist_f(:,:), firm_size(:), firm_prod_dens(:)
REAL(DP), parameter:: size_50=5.0d0
! DATA MOMENTS
REAL(DP) sample_mean_offer_rate, w_sample_mean_offer_rate, emp_size_mean_data, sample_frac_small_firm, sample_wage_ratio, sample_firm_size_hi, &
sample_firm_size_nhi, sample_ehi_small, sample_ehi_large, w_emp_size_mean_data, &
w_sample_frac_small_firm, w_sample_wage_ratio, w_sample_firm_size_hi, &
w_sample_firm_size_nhi, w_sample_ehi_small, w_sample_ehi_large
REAL(DP) sample_wage_50s, sample_wage_50l, w_sample_wage_50s, w_sample_wage_50l
REAL(DP), ALLOCATABLE:: w_firm_mat(:), mat_weight(:,:)
REAL(DP) sample_firm_mean_wage_hi, sample_firm_mean_wage_nhi, sample_firm_std_wage_hi, sample_firm_std_wage_nhi
REAL(DP) w_sample_firm_mean_wage_hi, w_sample_firm_mean_wage_nhi, w_sample_firm_std_wage_hi, w_sample_firm_std_wage_nhi

REAL(DP) sample_emp_mean_wage_all, sample_emp_mean_wage_hi, sample_emp_mean_wage_nhi, sample_emp_std_wage_all
REAL(DP) sample_emp_std_wage_hi, sample_emp_std_wage_nhi, sample_emp_age_s, sample_emp_age_l, sample_emp_age_hi, sample_emp_age_nhi
REAL(DP) w_sample_emp_age_s, w_sample_emp_age_l, w_sample_emp_age_hi, w_sample_emp_age_nhi

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


! VARIABLES FOR REPORTING STATISTICS
REAL(DP), ALLOCATABLE:: health_sim_mean(:,:), health_sim_var(:,:), emp_hinsured(:,:), emp_uninsured(:,:),  emp_rate(:,:), med_care_sim_hi(:,:,:), firm_age(:)
REAL(DP), ALLOCATABLE:: emp_hinsured_s(:,:),emp_rate_s(:,:), firm_s(:,:), wage_sim(:,:)


! aggregate medical expenditure
REAL(DP) sim_med_exp_sample_h_hi_1(5,2,2), sim_count_sample_h_hi_1(5,2,2), sim_positive_sample_h_hi_1(5,2,2), sim_std_med_exp_sample_h_hi_1(5,2,2)

!worker side data moments
REAL(DP) wage_average_sample(5,2)
REAL(DP) med_exp_sample_h_hi(5,2,2,2), w_med_exp_sample_h_hi(5,2,2,2), count_sample_h_hi(5,2,2,2), positive_sample_h_hi(5,2,2,2), std_med_exp_sample_h_hi(5,2,2,2), w_std_med_exp_sample_h_hi(5,2,2,2), w_positive_sample_h_hi(5,2,2,2)
REAL(DP) med_exp_sample_h_hi_1(5,2,2), w_med_exp_sample_h_hi_1(5,2,2), count_sample_h_hi_1(5,2,2), positive_sample_h_hi_1(5,2,2), std_med_exp_sample_h_hi_1(5,2,2), w_std_med_exp_sample_h_hi_1(5,2,2), w_positive_sample_h_hi_1(5,2,2)
REAL(DP) emp_sample(5,2), ump_rate_sample(5,2), emp_rate_sample(5,2), hi_rate_sample(5,2), wage_hi_sample(5,2), wage_nhi_sample(5,2)
REAL(DP) std_wage_hi_sample(5,2), std_wage_nhi_sample(5,2), ue_sample(5,2), ue_hi_sample(5,2), ue_nhi_sample(5,2)
REAL(DP) eu_sample(5,2), jj_sample(5,2), jj_hihi_sample(5,2), jj_nhihi_sample(5,2), jj_hinhi_sample(5,2), jj_nhinhi_sample(5,2)
REAL(DP) wage_change_jj_hihi_sample(5,2), wage_change_jj_nhinhi_sample(5,2), wage_change_jj_hinhi_sample(5,2), wage_change_jj_nhihi_sample(5,2)
REAL(DP) wage_change_stay_sample(5,2), wage_change_stay_hi_sample(5,2), wage_change_stay_nhi_sample(5,2), wage_change_stay_sample_count(5,2)
REAL(DP) wage_change_stay_hi_sample_count(5,2), wage_change_stay_nhi_sample_count(5,2), wage_ue_hi_sample(5,2), wage_ue_nhi_sample(5,2)
REAL(DP) std_wage_change_jj_hihi_sample(5,2), std_wage_change_jj_nhinhi_sample(5,2), std_wage_change_jj_hinhi_sample(5,2), std_wage_change_jj_nhihi_sample(5,2)
REAL(DP) std_wage_change_stay_sample(5,2), std_wage_change_stay_hi_sample(5,2), std_wage_change_stay_nhi_sample(5,2), std_wage_ue_hi_sample(5,2)
REAL(DP) std_wage_ue_nhi_sample(5,2), health_sample_all(5,2), health_sample(5,2), health_transition_hh_sample(5,2), health_transition_uu_sample(5,2), health_transition_hh_emp_sample(5,2,3), health_transition_uu_emp_sample(5,2,3)
REAL(DP) med_exp_sample_h_sample(5,2), med_exp_sample_u_sample(5,2), health_sample_meps(5,2), health_sample_all_meps(5,2)
REAL(DP) std_med_exp_sample_h_sample(5,2), std_med_exp_sample_u_sample(5,2)
REAL(DP), ALLOCATABLE:: cohort_weight(:,:)
REAL(DP) ue_sample_count(5,2), ue_hi_sample_count(5,2),ue_nhi_sample_count(5,2),eu_sample_count(5,2)
REAL(DP) jj_sample_count(5,2),jj_hihi_sample_count(5,2),jj_nhihi_sample_count(5,2),jj_hinhi_sample_count(5,2), jj_nhinhi_sample_count(5,2)
REAL(DP) emp_rate_sample_count(5,2), hi_rate_sample_count(5,2)
! weight moments
REAL(DP) w_emp_rate_sample(5,2), w_hi_rate_sample(5,2), w_wage_hi_sample(5,2), w_wage_nhi_sample(5,2), w_std_wage_hi_sample(5,2) , w_ump_rate_sample(5,2)
REAL(DP) w_std_wage_nhi_sample(5,2), w_ue_sample(5,2), w_ue_hi_sample(5,2), w_ue_nhi_sample(5,2), w_eu_sample(5,2), &
w_jj_sample(5,2), w_jj_hihi_sample(5,2), w_jj_nhihi_sample(5,2), w_jj_hinhi_sample(5,2), w_jj_nhinhi_sample(5,2), &
w_wage_change_jj_hihi_sample(5,2), w_wage_change_jj_nhinhi_sample(5,2), w_wage_change_jj_hinhi_sample(5,2), w_wage_change_jj_nhihi_sample(5,2), &
w_wage_change_stay_sample(5,2), w_wage_change_stay_hi_sample(5,2), w_wage_change_stay_nhi_sample(5,2), w_wage_ue_hi_sample(5,2), &
w_wage_ue_nhi_sample(5,2), w_std_wage_change_jj_hihi_sample(5,2), w_std_wage_change_jj_nhinhi_sample(5,2), w_std_wage_change_jj_hinhi_sample(5,2), &
w_std_wage_change_jj_nhihi_sample(5,2), w_std_wage_change_stay_sample(5,2), w_std_wage_change_stay_hi_sample(5,2), w_std_wage_change_stay_nhi_sample(5,2), &
w_std_wage_ue_hi_sample(5,2), w_std_wage_ue_nhi_sample(5,2), w_health_sample(5,2), w_health_transition_hh_sample(5,2), w_health_transition_uu_sample(5,2), w_health_transition_hh_emp_sample(5,2,3), w_health_transition_uu_emp_sample(5,2,3), &
w_med_exp_sample_h_sample(5,2), w_med_exp_sample_u_sample(5,2), w_std_med_exp_sample_h_sample(5,2), w_std_med_exp_sample_u_sample(5,2) 
REAL(DP) wage_ii_sample(5,2), w_wage_ii_sample(5,2), w_std_wage_ii_sample(5,2), eshi_rate_sample(5,2), std_wage_ii_sample(5,2)
REAL(DP) ii_rate_sample(5,2), ii_u_rate_sample(5,2), w_eshi_rate_sample(5,2), w_ii_rate_sample(5,2), w_ii_u_rate_sample(5,2)
REAL(DP) ii_rate_all_sample(5,2), w_ii_rate_all_sample(5,2)
REAL(DP) eshi_rate_sample_count(5,2), ii_rate_sample_count(5,2), nhi_rate_sample_count(5,2), ii_u_rate_sample_count(5,2)
REAL(DP) health_hi(2), &
health_nhi(2), &
health_unemp(2), &
w_health_hi(2), &
w_health_nhi(2), &
w_health_unemp(2)
REAL(DP) health_hi_sim(2), &
health_nhi_sim(2), &
health_unemp_sim(2)
! simulation moments
REAL(DP), ALLOCATABLE:: ump_rate(:,:), & 
ue_hi(:,:), & 
ue_nhi(:,:), & 
jj_hihi(:,:), & 
jj_hinhi(:,:), & 
jj_nhinhi(:,:), & 
jj_nhihi(:,:), & 
jj_rate(:,:), & 
eu(:,:), & 
wage_ue_hi(:,:), & 
wage_ue_nhi(:,:), & 
wage_average(:,:), & 
wage_average_hi(:,:), & 
wage_average_nhi(:,:), & 
wage_stay_hi(:,:), & 
wage_stay_nhi(:,:), & 
wage_stay_hi_count(:,:), & 
wage_stay_nhi_count(:,:), & 
wage_jj_hihi(:,:), & 
wage_jj_hinhi(:,:), & 
wage_jj_nhinhi(:,:), & 
wage_jj_nhihi(:,:), & 
std_wage_ue_hi(:,:), & 
std_wage_ue_nhi(:,:), & 
std_wage_average(:,:), & 
std_wage_average_hi(:,:), & 
std_wage_average_nhi(:,:), & 
std_wage_stay_hi(:,:), & 
std_wage_stay_nhi(:,:), & 
std_wage_jj_hihi(:,:), & 
std_wage_jj_hinhi(:,:), & 
std_wage_jj_nhihi(:,:), & 
std_wage_jj_nhinhi(:,:), & 
health_transit_hh(:,:), & 
health_transit_uu(:,:), &
health_transit_h_count(:,:), &
health_transit_u_count(:,:), & 
med_exp_h(:,:), & 
med_exp_u(:,:), & 
med_exp_h_hi(:,:,:,:), &
positive_h_hi(:,:,:,:), &
count_sim_h_hi(:,:,:,:), &
std_med_exp_h_hi(:,:,:,:), &
std_med_exp_h(:,:), &
std_med_exp_u(:,:), &
emp_hi_healthy(:,:), &
emp_nhi_healthy(:,:), &
unemp_healthy(:,:), &
wage_average_ii(:,:), & 
std_wage_average_ii(:,:), & 
emp_iinsured(:,:), &
unemp_iinsured(:,:)

REAL(DP), ALLOCATABLE:: ump_rate_c(:,:), & 
ue_hi_c(:,:), & 
ue_nhi_c(:,:), & 
jj_hihi_c(:,:), & 
jj_hinhi_c(:,:), & 
jj_nhinhi_c(:,:), & 
jj_nhihi_c(:,:), & 
jj_rate_c(:,:), & 
eu_c(:,:), &
wage_average_ii_c(:,:), &
eshi_rate_c(:,:), &
ii_rate_c(:,:), &
ii_u_rate_c(:,:), &
std_wage_average_ii_c(:,:), &
wage_ue_hi_c(:,:), & 
emp_hinsured_c(:,:), &
wage_ue_nhi_c(:,:), & 
wage_average_c(:,:), & 
wage_average_hi_c(:,:), & 
wage_average_nhi_c(:,:), & 
wage_stay_hi_c(:,:), & 
wage_stay_nhi_c(:,:), & 
wage_stay_hi_count_c(:,:), & 
wage_stay_nhi_count_c(:,:), & 
wage_jj_hihi_c(:,:), & 
wage_jj_hinhi_c(:,:), & 
wage_jj_nhinhi_c(:,:), & 
wage_jj_nhihi_c(:,:), & 
std_wage_ue_hi_c(:,:), & 
std_wage_ue_nhi_c(:,:), & 
std_wage_average_c(:,:), & 
std_wage_average_hi_c(:,:), & 
std_wage_average_nhi_c(:,:), & 
std_wage_stay_hi_c(:,:), & 
std_wage_stay_nhi_c(:,:), & 
std_wage_jj_hihi_c(:,:), & 
std_wage_jj_hinhi_c(:,:), & 
std_wage_jj_nhihi_c(:,:), & 
std_wage_jj_nhinhi_c(:,:), & 
health_transit_hh_c(:,:), & 
health_transit_uu_c(:,:), & 
health_transit_hh_emp_c(:,:,:), & 
health_transit_uu_emp_c(:,:,:), & 
med_exp_h_c(:,:), & 
med_exp_u_c(:,:), &
med_exp_h_hi_c(:,:,:,:), & 
std_med_exp_h_hi_c(:,:,:,:), & 
positive_h_hi_c(:,:,:,:), & 
hi_rate_c(:,:), & 
std_med_exp_h_c(:,:), &
std_med_exp_u_c(:,:), &
health_c(:,:), &
choice_ii(:,:,:,:, :, :), &
choice_ii_sim(:,:,:,:, :, :), &
choice_ii_u(:,:,:,:,:)

!!!!!! cohort size
REAL(DP), parameter::frac_college=0.4926d0
!REAL(DP), parameter::frac_college=0.8926d0

contains 
subroutine reading



 

!integer:: j

 

! assign number 
num_sim=5000					!num_sim !- the number of simulation
num_period=132					!num_period !- total number of periods
num_type=2					!num_type !- the number of individual unobserved type
num_ed=2					!num_ed !- the number of education type
num_firm=40			!num_firm !- the number of firm grids
num_health=2					!num_health !- the number of health status
num_health_shock=30					!num_health_shock !- the number of simulations for health shock	
num_emax_e=2000					!num_emax_e   ! the number of evaluation points for emax approximation for employed
num_emax_e_ed=1000
num_emax_u=100					!num_emax_u   ! the number of evaluation points for emax approximation for u
num_exp=132
num_firm_sim=10
num_ins=2
num_emax_u_ed=50 
  
! allocate the size of arrays
! allocate the size of variables
allocate (reject(num_period))
allocate (prob_type1(num_ed))
allocate (prob_firm(num_sim, num_period), prob_lambda_u(num_sim, num_period), prob_lambda_e(num_sim, num_period), prob_delta(num_sim, num_period), &
prob_health_shock(num_sim, num_period), prob_health_change(num_sim, num_period), prob_hi_offer(num_sim, num_period),pref_work(num_sim, num_period)  )

allocate(offer_u_sim(num_sim, num_period), offer_e_sim(num_sim, num_period), layoff_sim(num_sim, num_period), & 
        hi_offer_sim(num_sim, num_period), new_health_sim(num_sim, num_period), offer_firm_sim(num_sim, num_period))

allocate (emp_sim(num_sim, num_period), health_sim(num_sim, num_period), hi_sim(num_sim, num_period), ed_sim(num_sim), firm_sim(num_sim, num_period), ind_type_sim(num_sim), &
ue_sim(num_sim, num_period), ee_sim(num_sim, num_period), eu_sim(num_sim, num_period), med_care_sim(num_sim, num_period), ins_gain_sim(num_sim, num_period), ins_loss_sim(num_sim, num_period))

allocate(health_draw(num_health_shock),prob_health_draw(num_health_shock), health_draw_sim(num_sim,num_period), health_draw_sim_all(num_sim*num_period))
allocate(ind_prod_draw(num_health_shock), ind_prod_draw_sim(num_sim,num_period))
allocate ( alpha_w_1(num_type), alpha_w_1_ed(num_ed), alpha_w_2(num_type),  alpha_w_2_ed(num_ed), & 
alpha_w_3(num_type), alpha_w_3_ed(num_ed),alpha_w_4(num_type), alpha_w_4_ed(num_ed), alpha_w_5(num_type), alpha_w_5_ed(num_ed),  & 
term_type(num_type), term_ed(num_ed), term_health(num_health),alpha_w_6(num_health), &
alpha_m_i(num_health),alpha_m(num_health), theta(num_health, num_ed),gamma(num_ed), & 
prob_meet(num_firm), cum_meet(num_firm), firm_prod(num_firm), &
state_ind_e(num_emax_e,num_period), state_ind_u(num_emax_u,num_period), state_ed_e(num_emax_e,num_period), &
 state_ed_u(num_emax_u,num_period), &
state_health_e(num_emax_e,num_period), state_health_u(num_emax_u,num_period), state_firm_e(num_emax_e,num_period), &
state_ins_e(num_emax_e,num_period), state_ins_u(num_emax_u,num_period), &
state_exp_e(num_emax_e,num_period), state_exp_u(num_emax_u,num_period), &
emax_ind_e(num_emax_e,num_period), emax_ind_u(num_emax_u,num_period), emax_ed_e(num_emax_e,num_period),&
emax_ed_u(num_emax_u,num_period), &
emax_health_e(num_emax_e,num_period), emax_health_u(num_emax_u,num_period), emax_firm_e(num_emax_e,num_period), &
emax_ins_e(num_emax_e,num_period), emax_ins_u(num_emax_u,num_period), &
emax_exp_e(num_emax_e,num_period), emax_exp_u(num_emax_u,num_period), &
E_max_value_e(num_emax_e),E_max_value_u(num_emax_u), &
E_health_transit_e(num_emax_e), E_health_transit_u(num_emax_u),E_ehi_e(num_emax_e), & 
ehi_premium(num_firm), ehi_offer(num_firm), &
ehi_premium_new(num_firm), ehi_offer_new(num_firm), &
alpha_rate_0(num_firm,num_ed,num_wage_exp), alpha_rate_1(num_firm,num_ed,num_wage_exp), alpha_rate_0_new(num_firm,num_ed,num_wage_exp), alpha_rate_1_new(num_firm,num_ed,num_wage_exp), &
z_0(num_firm,num_ed,num_wage_exp), z_1(num_firm,num_ed,num_wage_exp), z_0_new(num_firm,num_ed,num_wage_exp), z_1_new(num_firm,num_ed,num_wage_exp),z_sim(num_firm_sim), &
eq_size_hi(num_firm,2), eq_size_nhi(num_firm,2), &
value_emp(num_type,num_ed,num_health,2,num_firm, num_exp, num_period), value_unemp(num_type,num_ed,num_health,num_exp,num_period), &
ex_v(num_type,num_ed,num_health,2,num_firm, num_exp, num_period), ex_med_u(num_type,num_ed,num_health,num_exp,num_period), &
health_transit_emp(num_type,num_ed,num_health,2,num_firm, num_exp, num_period), health_transit_unemp(num_type,num_ed,num_health,num_exp,num_period), &
ex_med(num_type,num_ed,num_health,2,num_firm, num_exp, num_period),ex_med_sim(num_type,num_ed,num_health,2,num_firm_sim, num_exp, num_period), &
value_emp_sim(num_type,num_ed,num_health,2,num_firm_sim, num_exp, num_period), &
emp_dist(num_type,num_ed,num_health,2,num_firm, num_exp, num_period), unemp_dist(num_type,num_ed,num_health,num_exp, num_period), &
emp_dist_sim(num_type,num_ed,num_health,2,num_firm_sim, num_exp, num_period), &
emp_dist_sim_1(num_firm_sim,2,num_ed,num_wage_exp), emp_dist_sim_2(num_firm_sim,2,num_ed,num_wage_exp), med_dist_sim_1(num_firm_sim,num_ed,num_wage_exp), &
choice_ii(num_type,num_ed,num_health,num_firm, num_exp, num_period),choice_ii_sim(num_type,num_ed,num_health,num_firm_sim, num_exp, num_period),choice_ii_u(num_type,num_ed,num_health,num_exp, num_period) )

allocate(ex_med_f(num_type,num_ed,num_health,2,num_firm, num_exp, num_period),ex_med_sim_f(num_type,num_ed,num_health,2,num_firm_sim, num_exp, num_period)   )

allocate(p_ii(num_period,num_health))

allocate(alpha_1_k(num_health,num_health), alpha_2_k(num_health,num_health), alpha_3_k(num_health,num_health), alpha_4_k(num_health,num_health), alpha_5_k(num_health,num_type), & 
alpha_6_k(num_health,num_health),alpha_7_k(num_health))

allocate(exp_sim(num_sim, num_period))

allocate ( cohort_weight(num_period,num_ed))

allocate(health_sim_mean(num_period,2), health_sim_var(num_period,2), emp_hinsured(num_period,2), emp_uninsured(num_period,2), emp_iinsured(num_period,2), & 
emp_rate(num_period,2), med_care_sim_hi(2, num_period,2), firm_age(num_firm), unemp_iinsured(num_period, num_ed))
 

allocate(emp_hinsured_s(num_period,2),emp_rate_s(num_period,2), firm_s(num_period,2), wage_sim(num_sim,num_period))

allocate(size_worker_hi(num_firm,num_ed,num_wage_exp), size_worker_nhi(num_firm,num_ed,num_wage_exp), size_worker_hi_1(num_firm,num_ed,num_wage_exp), size_worker_nhi_1(num_firm,num_ed,num_wage_exp), premium_av(num_firm,num_ed,num_wage_exp))

ALLOCATE(ii_sim(num_sim,num_period), ii_shock(num_sim,num_period))

ALLOCATE(wage_average_ii(num_period,2), std_wage_average_ii(num_period,2) )

ALLOCATE( ump_rate_c(5,2), & 
ue_hi_c(5,2), & 
ue_nhi_c(5,2), & 
jj_hihi_c(5,2), & 
jj_hinhi_c(5,2), & 
jj_nhinhi_c(5,2), & 
jj_nhihi_c(5,2), & 
jj_rate_c(5,2), & 
eu_c(5,2), & 
wage_ue_hi_c(5,2), & 
wage_ue_nhi_c(5,2), & 
wage_average_c(5,2), & 
wage_average_hi_c(5,2), & 
wage_average_nhi_c(5,2), & 
wage_stay_hi_c(5,2), & 
wage_stay_nhi_c(5,2), & 
wage_stay_hi_count_c(5,2), & 
wage_stay_nhi_count_c(5,2), & 
wage_jj_hihi_c(5,2), & 
wage_jj_hinhi_c(5,2), & 
wage_jj_nhinhi_c(5,2), & 
wage_jj_nhihi_c(5,2), & 
std_wage_ue_hi_c(5,2), & 
std_wage_ue_nhi_c(5,2), & 
std_wage_average_c(5,2), & 
std_wage_average_hi_c(5,2), & 
std_wage_average_nhi_c(5,2), & 
std_wage_stay_hi_c(5,2), & 
std_wage_stay_nhi_c(5,2), & 
std_wage_jj_hihi_c(5,2), & 
std_wage_jj_hinhi_c(5,2), & 
std_wage_jj_nhihi_c(5,2), & 
std_wage_jj_nhinhi_c(5,2), & 
health_transit_hh_c(5,2), & 
health_transit_uu_c(5,2), & 
health_transit_hh_emp_c(5,2,3), & 
health_transit_uu_emp_c(5,2,3), & 
med_exp_h_c(5,2), & 
med_exp_u_c(5,2), hi_rate_c(5,2), &
std_med_exp_h_c(5,2), &
std_med_exp_u_c(5,2), &
med_exp_h_hi_c(5,2,2,2), & 
std_med_exp_h_hi_c(5,2,2,2), & 
positive_h_hi_c(5,2,2,2), & 
health_c(5,2), &
emp_hinsured_c(5,2), &
wage_average_ii_c(5,2), &
eshi_rate_c(5,2), &
ii_rate_c(5,2), &
ii_u_rate_c(5,2), &
std_wage_average_ii_c(5,2) )

ALLOCATE (ump_rate(num_period-1,2), & 
ue_hi(num_period-1,2), & 
ue_nhi(num_period-1,2), & 
jj_hihi(num_period-1,2), & 
jj_hinhi(num_period-1,2), & 
jj_nhinhi(num_period-1,2), & 
jj_nhihi(num_period-1,2), & 
jj_rate(num_period-1,2), & 
eu(num_period-1,2), & 
wage_ue_hi(num_period-1,2), & 
wage_ue_nhi(num_period-1,2), & 
wage_average(num_period-1,2), & 
wage_average_hi(num_period-1,2), & 
wage_average_nhi(num_period-1,2), & 
wage_stay_hi(num_period-1,2), & 
wage_stay_nhi(num_period-1,2), & 
wage_stay_hi_count(num_period-1,2), & 
wage_stay_nhi_count(num_period-1,2), & 
wage_jj_hihi(num_period-1,2), & 
wage_jj_hinhi(num_period-1,2), & 
wage_jj_nhinhi(num_period-1,2), & 
wage_jj_nhihi(num_period-1,2), & 
std_wage_ue_hi(num_period-1,2), & 
std_wage_ue_nhi(num_period-1,2), & 
std_wage_average(num_period-1,2), & 
std_wage_average_hi(num_period-1,2), & 
std_wage_average_nhi(num_period-1,2), & 
std_wage_stay_hi(num_period-1,2), & 
std_wage_stay_nhi(num_period-1,2), & 
std_wage_jj_hihi(num_period-1,2), & 
std_wage_jj_hinhi(num_period-1,2), & 
std_wage_jj_nhihi(num_period-1,2), & 
std_wage_jj_nhinhi(num_period-1,2), & 
health_transit_hh(39,2), & 
health_transit_uu(39,2), & 
health_transit_h_count(39,2), &
health_transit_u_count(39,2), & 
med_exp_h(40,2), & 
med_exp_u(40,2), & 
med_exp_h_hi(40,2,2,2), &
positive_h_hi(40,2,2,2), &
count_sim_h_hi(40,2,2,2), &
std_med_exp_h_hi(40,2,2,2), &
std_med_exp_h(40,2), &
std_med_exp_u(40,2), &
emp_hi_healthy(num_period,2), &
emp_nhi_healthy(num_period,2), &
unemp_healthy(num_period,2) )

ALLOCATE(emp_dist_f(num_firm,2), firm_size(num_firm), firm_prod_dens(num_firm))

!ALLOCATE(emp_dist_hi(num_type,num_ed,num_health,num_firm,num_firm, num_exp, num_period), emp_dist_nhi(num_type,num_ed,num_health,num_firm,num_firm, num_exp, num_period), & 
!unemp_dist_f(num_type,num_ed,num_health,num_ins,num_firm,num_exp, num_period), & 
!emp_dist_u(num_type,num_ed,num_health,num_ins,num_firm, num_exp, num_period), unemp_dist_u(num_type,num_ed,num_health,num_exp, num_period) )

open (unit=9, file='params.inp', status='old')
!externaly calibrated parameters

read (9,*)	prob_type1(1) !probability that individuals are type 1 for ed1
read (9,*)	prob_type1(2) !probability that individuals are type 1 for ed2
read (9,*)	gamma(1)	!-CARA high educated
read (9,*)	gamma(2)	!-CARA high educated
read (9,*)  theta(1,1)    !  -disutlity from good health, high educated
read (9,*)  theta(2,1)    !  -disutlity from bad health, high educated
read (9,*)  theta(1,2)    !  -disutlity from good health, high educated
read (9,*)  theta(2,2)    !  -disutlity from bad health, high educated
read (9,*)  eta  !, 	-disutility from labor
read (9,*)  eta_u  !, 	-disutility from labor for unhealthy workers
read (9,*)	disutilwork !, -disutility from working
read (9,*)	ump_flow !, -disutility from working
read (9,*)   beta	!	-discount factor
read (9,*)	 alpha_m(1) !, 	-the coeff. in med_need shock: good health
read (9,*)	 alpha_m(2) !, 	-the coeff. in med_need shock: bad health
read (9,*)	 beta_m(1) !, 	-the coeff. in med_need shock 
read (9,*)	gamma_m(1)  !, 	-the coeff. in med_need shock 
read (9,*)  sigma_m(1)	 !-std. dev for medical needs shock
read (9,*)  kappa(1)	 !the medical expenditure shifter
read (9,*)  sigma_prod !std of prodctuvitiy dist.
read (9,*)	 delta(1) !, & 	-layoff probability (Kaplan, 20 year experience)
read (9,*)   lambda_u(1,1)	!	arrival rate of job offer to unemployed
read (9,*)   lambda_e(1,1)	!	arrival rate of job offer to employed
read (9,*)	 delta(2) !, & 	-layoff probability (Kaplan, 20 year experience)
read (9,*)   lambda_u(1,2)	!	arrival rate of job offer to unemployed
read (9,*)   lambda_e(2,1)	!	arrival rate of job offer to employed
read (9,*)	 alpha_w_1(1) ! 	-coeff. in const. term wage equation for type 1
read (9,*)	 alpha_w_1(2) ! 	-coeff. in const. term wage equation for type 2
read (9,*)	 alpha_w_1_ed(1) ! 	-coeff. in const. term wage equation for high skilled
read (9,*)	 alpha_w_1_ed(2) ! 	-coeff. in const. term wage equation for low skilled 
read (9,*)	 alpha_w_4(1) ! 	-coeff. in exp term wage equation for type 1
read (9,*)	 alpha_w_4(2) ! 	-coeff. in exp term wage equation for type 2
read (9,*)	 alpha_w_4_ed(1) ! 	-coeff. in exp term wage equation for high skilled
read (9,*)	 alpha_w_4_ed(2) ! 	-coeff. in exp term wage equation for low skilled
read (9,*)	 alpha_w_5(1) ! 	-coeff. in exp**2 term wage equation for type 1
read (9,*)	 alpha_w_5(2) ! 	-coeff. in exp**2 term wage equation for type 2
read (9,*)	 alpha_w_5_ed(1) ! 	-coeff. in exp**2 term wage equation for high skilled
read (9,*)	 alpha_w_5_ed(2) ! 	-coeff. in exp**2 term wage equation for low skilled 
read (9,*)	 alpha_w_6(1)    !  -ceoff for healthy
read (9,*)	 alpha_w_6(2)    !  -ceoff for unhealthy
read (9,*)  alpha_1_k(1,1)  ! the coeff in health transition where current health is 1 and tomorrow is 1
read (9,*)  alpha_1_k(2,1)  ! the coeff in health transition where current health is 1 and tomorrow is 2
read (9,*)  alpha_1_k(1,2)  ! the coeff in health transition where current health is 2 and tomorrow is 1
read (9,*)  alpha_1_k(2,2)  ! the coeff in health transition where current health is 2 and tomorrow is 2
read (9,*)  alpha_2_k(1,1)  ! the coeff in health transition: medical care dummy
read (9,*)  alpha_2_k(2,1)  ! the coeff in health transition: medical care dummy
read (9,*)  alpha_3_k(1,1)  ! the coeff in health transition: idiosyncratic shock
read (9,*)  alpha_3_k(2,1)  ! the coeff in health transition: idiosyncratic shock
read (9,*)  alpha_4_k(1,1)  ! the coeff in health transition: age
read (9,*)  alpha_4_k(2,1)  ! the coeff in health transition: age
read (9,*)  alpha_5_k(1,1)  ! the coeff in health transition: type=1
read (9,*)  alpha_5_k(2,1)  ! the coeff in health transition: type=1
read (9,*)  alpha_5_k(1,2)  ! the coeff in health transition: type=1
read (9,*)  alpha_5_k(2,2)  ! the coeff in health transition: type=1
read (9,*)  alpha_6_k(1,1)    !interaction between shock and care
read (9,*)  alpha_6_k(2,1)    !interaction between shock and care
read (9,*)  alpha_7_k(1)    !the coeff. for interaction between age and bad health for tomorrow's good health
read (9,*)  alpha_7_k(2)    !the coeff. for interaction between age and bad health for tomorrow's bad health
read (9,*)  term_type(1)    ! the coeff for terminal value for type 1
read (9,*)  term_type(2)    ! the coeff for terminal value for type 2
read (9,*)  term_ed(1)    ! the coeff for terminal value for ed 1
read (9,*)  term_ed(2)    ! the coeff for terminal value for ed 2
read (9,*)  term_health(1)    ! the coeff for terminal value for healthy
read (9,*)  term_health(2)    ! the coeff for terminal value for unhealthy
read (9,*)  loading_ehi   ! loading factor for EHI
read (9,*)  worker_size1   ! worker size1
read (9,*)  shape_prod   ! shape parameter affecting firm productivity dist.
read (9,*)  shift_prod   ! shift parameter affecting firm productivity dist.
read (9,*)  scale_prof   ! shift parameter affecting firm productivity dist.
read (9,*)  pref_scale   ! preference shock to working
read (9,*)   ltax0              != transfer at zero income
read (9,*)   ltax1              != 1-marginal tax rate at earnings=1
read (9,*)   ltax2              ! amount of progressivity	   
	  
close(9)


alpha_2_k(1,1)=0.0d0
alpha_2_k(1,2)=0.0d0
alpha_3_k(1,1)=0.0d0
alpha_3_k(1,2)=0.0d0
alpha_4_k(1,1)=0.0d0
alpha_4_k(1,2)=0.0d0

alpha_6_k(1,1)=0.0d0
alpha_6_k(1,2)=0.0d0

ltax0=-1309.69
ltax1=1.4541
ltax2=-0.0827d0
!ltax2=-0.1027d0
! ASSIGN PARAMETERS FROM HOPSPACK
num_wage_rank=num_period/num_wage_exp

!worker_size1=worker_size1/(num_sim*num_period)
!
!worker_size1=worker_size1*1000.0d0

end subroutine reading


real(dp) function after_tax_income(income)
real(dp):: income

!kaplan's specification
after_tax_income=-ltax0/30000.0d0+(ltax1*(income*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0
!Krueger's specification
!after_tax_income=income-(ltax0*(income-(income**(-ltax1)+ltax2)**(-1.0/ltax1)))
!after_tax_income=income
end function after_tax_income





end module params 