SUBROUTINE simulate_data

! this file is for creating simuldated data for worker side 
use params
use mod_dp
USE olsroutines
USE Emax_approximation
USE probability 

implicit none
LOGICAL ISNAN

REAL(DP) utility(2), income, ii_p, oop, cons, total_worker
INTEGER count1
INTEGER i,j, n,m, k, t, ind_type, ed_type, health_type, hi_type, firm_index, health_shock, period, new_firm_index, med_care, next_health, count, med_pos_dummy

REAL(DP) next_value1, next_value2, next_value3, next_value4, next_value5, next_value6, next_value7, next_value8, value_next(2), E_max_value, prob_health_next, &
prob_health_next1, prob_health_next2

REAL(DP) v_hi_new, v_ii_new, v_nhi_new, v_ehi_c, v_nhi_c, v_ii_c, v_u_nhi, v_u_ii, v_ump, v_current, v_new, med_shock
REAL(DP), parameter:: const=1.0d0
INTEGER exp_next, work_exp, grid_exp

REAL(DP) emp_dist_dash(num_type,num_ed,num_health,2,num_firm, num_exp, num_period), dist_type(2,2), dist_type1(num_firm,2), dist_denom(2,2)
REAL(DP), allocatable:: size_e(:,:),coeff_size_e(:), ste_size_e(:)
INTEGER num_size_e, rank_reg_s
integer, parameter:: constreg=1

REAL(DP) denom
real(dp):: stats(5)

REAL(DP) value_health(num_health), ex_transit, ex_transit1, ex_transit2


!simulate behaviors
DO t=1,num_period-1 ! period



DO i=1, num_sim


grid_exp=(exp_sim(i,t)-1)/num_wage_rank+1

! devide by education status and time

IF (ed_sim(i)==1 .and. t<=0) THEN

    
    
    
wage_sim(i, t)=0.0d0
emp_sim(i, t+1)=0
health_sim(i, t+1)=health_sim(i, t)
exp_sim(i,t+1)=exp_sim(i,t)
firm_sim(i,t+1)=firm_sim(i,t)
hi_sim(i,t+1)=hi_sim(i,t)
med_care_sim(i,t)=0
ELSE




IF (emp_sim(i,t)<0 ) THEN
print*, i, t, 'imputation error'
stop 
END IF

IF (emp_sim(i, t)==1) THEN !employed 
!obtain optimal medical decision first

IF (firm_sim(i,t)<=0) THEN
stop
END IF

exp_next=min(exp_sim(i,t)+1,num_exp)
exp_sim(i,t+1)=exp_next





        income=exp(alpha_w_1(ind_type_sim(i))+alpha_w_1_ed(ed_sim(i)) &
       +(alpha_w_4(ind_type_sim(i))+alpha_w_4_ed(ed_sim(i)))*(exp_sim(i,t)-1) &
       +(alpha_w_5(ind_type_sim(i))+alpha_w_5_ed(ed_sim(i)))*((exp_sim(i,t)-1)**2.0d0) )

income=income*(hi_sim(i,t)-1.0d0)*z_1(firm_sim(i, t),ed_sim(i),grid_exp) &
       +income*(2.0d0-hi_sim(i,t))*z_0(firm_sim(i, t),ed_sim(i),grid_exp) 

wage_sim(i, t)=income


     
IF (income>0) THEN

income=-ltax0/30000.0d0+(ltax1*(income*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0
END IF


! assign initial ii status
     IF (ii_shock(i,t)>choice_ii(ind_type_sim(i),ed_sim(i), health_sim(i,t), firm_sim(i,t),exp_sim(i,t), t)   ) THEN
         ii_sim(i,t)=1         
     ELSE
         ii_sim(i,t)=0
         END IF


! FIRST CALCULATE THE VALUE FROM MEETING THE JOB
!calculate next period's choice specific value
DO next_health=1, num_health
next_value7=0.0d0


        v_current=value_emp(ind_type_sim(i),ed_sim(i),next_health, hi_sim(i,t),firm_sim(i,t),exp_next, t+1)
        v_ump=value_unemp(ind_type_sim(i),ed_sim(i),next_health,exp_next,t+1)

!LAYOFF
        next_value1=v_ump 
        next_value7=next_value7+delta(ed_sim(i))*(1.0d0-lambda_e(ind_type_sim(i),ed_sim(i)))*next_value1

        ! MEETING 
        DO new_firm_index=1, num_firm  

        


        !use following variables for simplifying the notation

        v_hi_new=value_emp(ind_type_sim(i),ed_sim(i),next_health,2,new_firm_index,exp_next,t+1)
        v_nhi_new=value_emp(ind_type_sim(i),ed_sim(i),next_health,1,new_firm_index,exp_next,t+1)



! next_value 2 & 3 are MEETING WITHOUT LAYOFF 

next_value2=dmax1(v_hi_new, v_current)
IF (((-next_value2+v_ump)/pref_scale)>4.9d0 ) THEN
ex_transit1=0.0001d0
ELSE IF ((-next_value2+v_ump)/pref_scale<-4.9d0 ) THEN
ex_transit1=0.9999d0
ELSE
ex_transit1=NORMCDF((next_value2-v_ump)/pref_scale, 0.0d0, 1.0d0) 
END IF
next_value2=ex_transit1*next_value2+ (1.0d0-ex_transit1)*v_ump+pref_scale*NORMPDF((next_value2-v_ump)/pref_scale, 0.0d0, 1.0d0)


next_value3=dmax1(v_nhi_new, v_current)
IF (  (-next_value3+v_ump)/pref_scale>4.9d0 ) THEN
ex_transit2=0.0001d0
ELSE IF ( (-next_value3+v_ump)/pref_scale<-4.9d0 ) THEN
ex_transit2=0.9999d0
ELSE
ex_transit2=NORMCDF((next_value3-v_ump)/pref_scale, 0.0d0, 1.0d0) 
END IF

next_value3=ex_transit2*next_value3+ (1.0d0-ex_transit2)*v_ump+pref_scale*NORMPDF((next_value3-v_ump)/pref_scale, 0.0d0, 1.0d0)


v_new=ehi_offer(new_firm_index)*next_value2+(1.0d0-ehi_offer(new_firm_index))*next_value3
next_value7=next_value7+(1.0d0-delta(ed_sim(i)))*lambda_e(ind_type_sim(i),ed_sim(i))*prob_meet(new_firm_index)*v_new


! MEETING WITH LAYOFF

IF ( ((-v_hi_new+v_ump)/pref_scale)>4.9d0 ) THEN
ex_transit=0.0001d0
ELSE IF ((-v_hi_new+v_ump)/pref_scale<-4.9d0 ) THEN
ex_transit=0.9999d0
ELSE
ex_transit=NORMCDF((v_hi_new-v_ump)/pref_scale, 0.0d0, 1.0d0) 
END IF


next_value4=ex_transit*v_hi_new+ (1.0d0-ex_transit)*v_ump+pref_scale*NORMPDF((v_hi_new-v_ump)/pref_scale, 0.0d0, 1.0d0)

IF (((-v_nhi_new+v_ump)/pref_scale)>4.9d0 ) THEN
ex_transit=0.0001d0
ELSE IF ((-v_nhi_new+v_ump)/pref_scale<-4.9d0 ) THEN
ex_transit=0.9999d0
ELSE
ex_transit=NORMCDF((v_nhi_new-v_ump)/pref_scale, 0.0d0, 1.0d0) 
END IF

next_value5=ex_transit*v_nhi_new+ (1.0d0-ex_transit)*v_ump+pref_scale*NORMPDF((v_nhi_new-v_ump)/pref_scale, 0.0d0, 1.0d0)
 

v_new=ehi_offer(new_firm_index)*next_value4+(1.0d0-ehi_offer(new_firm_index))*next_value5

next_value7=next_value7+delta(ed_sim(i))*lambda_e(ind_type_sim(i),ed_sim(i))*prob_meet(new_firm_index)*v_new


!sum up all utility
END DO !new_firm_index


! next value 6: STAY AT THE CURRENT JOB
IF (((-v_current+v_ump)/pref_scale)>4.9d0 ) THEN
ex_transit=0.0001d0
ELSE IF ((-v_current+v_ump)/pref_scale<-4.9d0 ) THEN
ex_transit=0.9999d0
ELSE
ex_transit=NORMCDF((v_current-v_ump)/pref_scale, 0.0d0, 1.0d0) 
END IF

next_value6=ex_transit*v_current+ (1.0d0-ex_transit)*v_ump+pref_scale*NORMPDF((v_current-v_ump)/pref_scale, 0.0d0, 1.0d0)

next_value7=next_value7+(1.0d0-delta(ed_sim(i)))*(1.0d0-lambda_e(ind_type_sim(i),ed_sim(i)))*next_value6

value_health(next_health)=next_value7



END DO !next_health

!print*, value_health(1),value_health(2), 'value_health' 

!!!!!!!!!!!!!!!!!!  solve medical care decisions !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!




        !calculate the expected health transition 
        DO med_care=0, 1
        
        value_next(med_care+1)=0.0d0
        med_shock=dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,t))+beta_m(health_sim(i,t))*t+gamma_m(health_sim(i,t))*(t**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,t))*health_draw_sim(i,t))-kappa(health_sim(i,t)),0.0d0)
IF (med_shock>0.0d0) THEN
med_pos_dummy=1
ELSE
med_pos_dummy=0
END IF


        !oop !simply fully insured or not right now
 IF (hi_sim(i,t)==2) THEN
    IF (med_shock<deduc) THEN
        oop=med_care*med_shock 
    ELSE
        oop=med_care*(deduc+(med_shock-deduc)*coins)
    END IF
 ELSE IF (hi_sim(i,t)==1) THEN
     IF (ii_sim(i,t)==0) THEN
        oop=med_care*med_shock
     ELSE 
         IF (med_shock<deduc_ii) THEN
            oop=med_care*med_shock 
        ELSE
            oop=med_care*(deduc_ii+(med_shock-deduc_ii)*coins_ii)
        END IF
    END IF
        !oop=med_shock
        END IF
        
IF (ii_sim(i,t)==1) THEN
    cons=income-oop-p_ii(t, health_sim(i,t))
ELSE
    cons=dmax1(income-oop,cons_floor)
END IF
        utility(med_care+1)=-exp(-gamma(ind_type_sim(i))*cons)/gamma(ind_type_sim(i))-dmax1(t-age_dis,0.0d0)*eta-dmax1(t-age_dis,0.0d0)*eta_u*(health_sim(i,t)-1.0d0)-theta(health_sim(i,t),ind_type_sim(i))

        
        DO next_health=1, num_health


        !calculate the probability that the next period health is next_health

 
 prob_health_next=exp(alpha_1_k(next_health, health_sim(i,t))+alpha_2_k(next_health, health_sim(i,t))*med_care*med_pos_dummy+alpha_3_k(next_health, health_sim(i,t))*med_shock &
+alpha_4_k(next_health, health_sim(i,t))*t+alpha_5_k(next_health, ind_type_sim(i))+alpha_6_k(next_health, health_sim(i,t))*med_care*med_shock   ) &
/(exp(alpha_1_k(1, health_sim(i,t))+alpha_2_k(1, health_sim(i,t))*med_care*med_pos_dummy+alpha_3_k(1, health_sim(i,t))*med_shock &
+alpha_4_k(1, health_sim(i,t))*t+alpha_5_k(1, ind_type_sim(i))+alpha_6_k(1, health_sim(i,t))*med_care*med_shock ) &
+exp(alpha_1_k(2, health_sim(i,t))+alpha_2_k(2, health_sim(i,t))*med_care*med_pos_dummy+alpha_3_k(2, health_sim(i,t))*med_shock &
+alpha_4_k(2, health_sim(i,t))*t+alpha_5_k(2, ind_type_sim(i))+alpha_6_k(2, health_sim(i,t))*med_care*med_shock    ) )

 
 
        
        value_next(med_care+1)=value_next(med_care+1)+value_health(next_health)*prob_health_next

        END DO !next_health

    !multiply discount factor

    value_next(med_care+1)=beta*value_next(med_care+1)

        END DO !medicare care

!evaluate maximum over medical care decision
IF (utility(2)+value_next(2)>utility(1)+value_next(1)) THEN
med_care_sim(i,t)=1
ELSE
med_care_sim(i,t)=0
END IF



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
next_health=1
! simulate next period health status
! create variables 
 prob_health_next1=exp(alpha_1_k(next_health, health_sim(i,t))+alpha_2_k(next_health, health_sim(i,t))*med_care_sim(i,t)*med_pos_dummy+alpha_3_k(next_health, health_sim(i,t))*med_shock &
+alpha_4_k(next_health, health_sim(i,t))*t+alpha_5_k(next_health, ind_type_sim(i))+alpha_6_k(next_health, health_sim(i,t))*med_care_sim(i,t)*med_shock   ) &
/(exp(alpha_1_k(1, health_sim(i,t))+alpha_2_k(1, health_sim(i,t))*med_care_sim(i,t)*med_pos_dummy+alpha_3_k(1, health_sim(i,t))*med_shock &
+alpha_4_k(1, health_sim(i,t))*t+alpha_5_k(1, ind_type_sim(i))+alpha_6_k(1, health_sim(i,t))*med_care_sim(i,t)*med_shock ) &
+exp(alpha_1_k(2, health_sim(i,t))+alpha_2_k(2, health_sim(i,t))*med_care_sim(i,t)*med_pos_dummy+alpha_3_k(2, health_sim(i,t))*med_shock &
+alpha_4_k(2, health_sim(i,t))*t+alpha_5_k(2, ind_type_sim(i))+alpha_6_k(2, health_sim(i,t))*med_care_sim(i,t)*med_shock    ) )




IF (prob_health_change(i,t)<=prob_health_next1) THEN
health_sim(i,t+1)=1
ELSE 
health_sim(i,t+1)=2
END IF


! simulate next period employment contract

        
        v_current=value_emp(ind_type_sim(i),ed_sim(i),health_sim(i,t+1),hi_sim(i,t),firm_sim(i, t),exp_next, t+1)

        v_ump=value_unemp(ind_type_sim(i),ed_sim(i),health_sim(i,t+1),exp_next,t+1)

! consider the insurance offer if meet a new opportunity
            IF (  prob_hi_offer(i,t)<ehi_offer(offer_firm_sim(i, t))) THEN                
                hi_sim(i,t+1)=2
            ELSE
                hi_sim(i,t+1)=1
            END IF
! note; if offer is rejected nor arrived, then other insurance status will be assigned.

v_new=value_emp(ind_type_sim(i),ed_sim(i),health_sim(i,t+1),hi_sim(i,t+1),offer_firm_sim(i, t),exp_next,t+1)

IF (layoff_sim(i,t)==1) THEN
    !meeting with layoff
    IF (offer_e_sim(i,t)==1) THEN
     IF (pref_work(i,t)<NORMCDF((v_new-v_ump)/pref_scale, 0.0d0, 1.0d0)   ) THEN
                emp_sim(i, t+1)=1                
                firm_sim(i,t+1)=offer_firm_sim(i, t)      
     ELSE                 
                emp_sim(i, t+1)=0
                hi_sim(i,t+1)=1
                firm_sim(i,t+1)=0                       
     END IF          
    ELSE IF (offer_e_sim(i,t)==0) THEN
    emp_sim(i,t+1)=0 !unemployed
            hi_sim(i,t+1)=1
            firm_sim(i,t+1)=0
    END IF !whether ot not receiving offer after layoff shock


ELSE IF (layoff_sim(i,t)==0 .and. offer_e_sim(i,t)==1) THEN



        !again devide the case by insurance offering by new employers 
            !insurance offering status        
                IF (v_new>=v_current .and. pref_work(i,t)<NORMCDF((v_new-v_ump)/pref_scale, 0.0d0, 1.0d0) ) THEN
                emp_sim(i, t+1)=1
                firm_sim(i,t+1)=offer_firm_sim(i, t)
                ELSE IF (v_new<v_current .and. pref_work(i,t)<NORMCDF((v_current-v_ump)/pref_scale, 0.0d0, 1.0d0) ) THEN
                emp_sim(i, t+1)=1
                firm_sim(i,t+1)=firm_sim(i,t)
                hi_sim(i,t+1)=hi_sim(i,t)
                ELSE 
                emp_sim(i, t+1)=0
                hi_sim(i,t+1)=1
                firm_sim(i,t+1)=0
                END IF




! not hit by layoff shock, not meet any people
ELSE IF (layoff_sim(i,t)==0 .and. offer_e_sim(i,t)==0) THEN
            IF (pref_work(i,t)<1.0d0/NORMCDF((v_current-v_ump)/pref_scale, 0.0d0, 1.0d0) ) THEN
            emp_sim(i,t+1)=1
            firm_sim(i,t+1)=firm_sim(i,t)
            hi_sim(i,t+1)=hi_sim(i,t)
            ELSE 
            emp_sim(i,t+1)=0
            hi_sim(i,t+1)=1
            firm_sim(i,t+1)=0
            END IF

IF (emp_sim(i,t+1)<0) THEN
print*, '399'
stop
END IF

END IF !about next period event


!!!!!!!!!!!!!!!!!!!!!! UNEMPLOYED!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
ELSE IF (emp_sim(i, t)==0) THEN !unemployed 

     IF (ii_shock(i,t)>choice_ii_u(ind_type_sim(i),ed_sim(i), health_sim(i,t), exp_sim(i,t), t)   ) THEN
         ii_sim(i,t)=1         
     ELSE
         ii_sim(i,t)=0
         END IF    
    
    

exp_next=exp_sim(i,t)
exp_sim(i,t+1)=exp_sim(i,t)

! draw health shock
! MEDICAL CARE CHOICE

!income
income=ump_flow

wage_sim(i, t)=0.0d0

!subtract insurance premium: ii

!!!!!!!!!!!!!!! calculate the value from meeting fast
DO next_health=1, num_health
value_health(next_health)=0.0d0
next_value7=0.0d0
! NEXT PERIOD EVENT

exp_next=min(work_exp+1, num_exp)

!use following variables for simplifying the notation
v_ump=value_unemp(ind_type_sim(i),ed_sim(i),next_health,exp_sim(i,t),t+1)


!NOT MEET
next_value1=v_ump
next_value7=(1.0d0-lambda_u(ind_type_sim(i),ed_sim(i)))*next_value1


! MEETING 
DO new_firm_index=1, num_firm  

! next_value 2 is MEETING WITHOUT LAYOFF and MEET job with HI


!use following variables for simplifying the notation

v_hi_new=value_emp(ind_type_sim(i),ed_sim(i),next_health,2,new_firm_index,exp_next,t+1)
v_nhi_new=value_emp(ind_type_sim(i),ed_sim(i),next_health,1,new_firm_index,exp_next,t+1)


! next_value 2 & 3 are MEET job

IF ( ((-v_hi_new+v_ump)/pref_scale)>4.9d0 ) THEN
ex_transit=0.0001d0
ELSE IF ((-v_hi_new+v_ump)/pref_scale<-4.9d0 ) THEN
ex_transit=0.9999d0
ELSE
ex_transit=NORMCDF((v_hi_new-v_ump)/pref_scale, 0.0d0, 1.0d0)
END IF

next_value2=ex_transit*v_hi_new+ (1.0d0-ex_transit)*v_ump+pref_scale*NORMPDF((v_hi_new-v_ump)/pref_scale, 0.0d0, 1.0d0)

IF (((-v_nhi_new+v_ump)/pref_scale)>4.9d0 ) THEN
ex_transit=0.0001d0
ELSE IF ((-v_nhi_new+v_ump)/pref_scale<-4.9d0 ) THEN
ex_transit=0.9999d0
ELSE
ex_transit=NORMCDF((v_nhi_new-v_ump)/pref_scale, 0.0d0, 1.0d0) 
END IF
next_value3=ex_transit*v_nhi_new+ (1.0d0-ex_transit)*v_ump+pref_scale*NORMPDF((v_nhi_new-v_ump)/pref_scale, 0.0d0, 1.0d0)



v_new=ehi_offer(new_firm_index)*next_value2+(1.0d0-ehi_offer(new_firm_index))*next_value3

next_value7=next_value7+lambda_u(ind_type_sim(i),ed_sim(i))*prob_meet(new_firm_index)*v_new


END DO !new_firm_index

value_health(next_health)=next_value7

END DO ! HEALTH STATUS



DO med_care=0,1

value_next(med_care+1)=0.0d0

!oop !simply fully insured or not right now
med_shock=dmax1(exp(eta1_m(ind_type_sim(i))+alpha_m(health_sim(i,t))+beta_m(health_sim(i,t))*t+gamma_m(health_sim(i,t))*(t**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,t))*health_draw_sim(i,t))-kappa(health_sim(i,t)),0.0d0)
IF (med_shock>0.0d0) THEN
med_pos_dummy=1
ELSE
med_pos_dummy=0
END IF



IF (ii_sim(i,t)==0 ) THEN
oop=med_care*med_shock

ELSE
    IF (med_shock<deduc_ii) THEN
oop=med_care*med_shock 
    ELSE
        oop=med_care*(deduc_ii+(med_shock-deduc_ii)*coins_ii)
    END IF
END IF

IF (ii_sim(i,t)==0 ) THEN
cons=dmax1(income-oop,cons_floor)
ELSE

cons=income-oop-p_ii(t, health_sim(i,t))
END IF
        !utility from today 




utility(med_care+1)=-exp(-gamma(ind_type_sim(i))*cons)/gamma(ind_type_sim(i))-theta(health_sim(i,t),ind_type_sim(i))


! calculate the value from meeting
! NEXT PERIOD HEALTH
DO next_health=1, num_health


!calculate the probability that the next period health is next_health
 prob_health_next=exp(alpha_1_k(next_health, health_sim(i,t))+alpha_2_k(next_health, health_sim(i,t))*med_care*med_pos_dummy+alpha_3_k(next_health, health_sim(i,t))*med_shock &
+alpha_4_k(next_health, health_sim(i,t))*t+alpha_5_k(next_health, ind_type_sim(i))+alpha_6_k(next_health, health_sim(i,t))*med_care*med_shock   ) &
/(exp(alpha_1_k(1, health_sim(i,t))+alpha_2_k(1, health_sim(i,t))*med_care*med_pos_dummy+alpha_3_k(1, health_sim(i,t))*med_shock &
+alpha_4_k(1, health_sim(i,t))*t+alpha_5_k(1, ind_type_sim(i))+alpha_6_k(1, health_sim(i,t))*med_care*med_shock ) &
+exp(alpha_1_k(2, health_sim(i,t))+alpha_2_k(2, health_sim(i,t))*med_care*med_pos_dummy+alpha_3_k(2, health_sim(i,t))*med_shock &
+alpha_4_k(2, health_sim(i,t))*t+alpha_5_k(2, ind_type_sim(i))+alpha_6_k(2, health_sim(i,t))*med_care*med_shock    ) )


! NEXT PERIOD EVENT

!use following variables for simplifying the notation


value_next(med_care+1)=value_next(med_care+1)+value_health(next_health)*prob_health_next

END DO ! HEALTH STATUS

!multiply by discount factor
value_next(med_care+1)=beta*value_next(med_care+1)

END DO !medicare care

!evaluate maximum over medical care decision
IF (utility(2)+value_next(2)>utility(1)+value_next(1)) THEN
med_care_sim(i,t)=1
ELSE
med_care_sim(i,t)=0
END IF


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! simulate health and next period employment status
! health
!create a summy variable

next_health=1
            
 prob_health_next1=exp(alpha_1_k(next_health, health_sim(i,t))+alpha_2_k(next_health, health_sim(i,t))*med_care_sim(i,t)*med_pos_dummy+alpha_3_k(next_health, health_sim(i,t))*med_shock &
+alpha_4_k(next_health, health_sim(i,t))*t+alpha_5_k(next_health, ind_type_sim(i))+alpha_6_k(next_health, health_sim(i,t))*med_care_sim(i,t)*med_shock   ) &
/(exp(alpha_1_k(1, health_sim(i,t))+alpha_2_k(1, health_sim(i,t))*med_care_sim(i,t)*med_pos_dummy+alpha_3_k(1, health_sim(i,t))*med_shock &
+alpha_4_k(1, health_sim(i,t))*t+alpha_5_k(1, ind_type_sim(i))+alpha_6_k(1, health_sim(i,t))*med_care_sim(i,t)*med_shock ) &
+exp(alpha_1_k(2, health_sim(i,t))+alpha_2_k(2, health_sim(i,t))*med_care_sim(i,t)*med_pos_dummy+alpha_3_k(2, health_sim(i,t))*med_shock &
+alpha_4_k(2, health_sim(i,t))*t+alpha_5_k(2, ind_type_sim(i))+alpha_6_k(2, health_sim(i,t))*med_care_sim(i,t)*med_shock    ) )


IF (prob_health_change(i,t)<=prob_health_next1) THEN
health_sim(i,t+1)=1
ELSE 
health_sim(i,t+1)=2
END IF

! employment status
IF (offer_u_sim(i,t)==1) THEN
!draw firm's insurance status


    v_ump=value_unemp(ind_type_sim(i),ed_sim(i),health_sim(i, t+1),exp_next,t+1)

! new insurance status if offer is accepted
                IF (  prob_hi_offer(i,t)<ehi_offer(offer_firm_sim(i, t))) THEN
                hi_sim(i,t+1)=2
                ELSE
                hi_sim(i,t+1)=1
                END IF
! note; if offer is rejected nor arrived, then other insurance status will be assigned.       
         v_new=value_emp(ind_type_sim(i),ed_sim(i),health_sim(i, t+1),hi_sim(i,t+1),offer_firm_sim(i, t),exp_next,t+1)

        IF (pref_work(i,t)<NORMCDF((v_new-v_ump)/pref_scale, 0.0d0, 1.0d0) ) THEN 
            emp_sim(i,t+1)=1
            firm_sim(i,t+1)=offer_firm_sim(i, t)
        ELSE ! IF (v_ump==dmax1(v_new,v_ump )) THEN
            emp_sim(i,t+1)=0
            hi_sim(i,t+1)=1
            firm_sim(i,t+1)=0
        END IF


ELSE IF (offer_u_sim(i,t)==0) THEN
    emp_sim(i,t+1)=0
! insurance status
            hi_sim(i,t+1)=1
            firm_sim(i,t+1)=0
END IF !whether receiving offer


IF (emp_sim(i,t+1)<0) THEN
print*, v_ump,v_hi_new,hi_sim(i,t+1), offer_u_sim(i,t),hi_offer_sim(i,t),health_sim(i,t+1), '566'
stop
END IF

END IF !whether employed or not


END IF !whether it is pre 22 or not


END DO !individual



END DO !period

!!!!!!!!! simulate the last period decision
! no one has an incentive to take a medical care. Thus, the decision is irrelevant.

t=num_period

DO i=1, num_sim

grid_exp=(exp_sim(i,t)-1)/num_wage_rank+1

IF (emp_sim(i, t)==1) THEN !employed 
!obtain optimal medical decision first

     IF (ii_shock(i,t)>choice_ii(ind_type_sim(i),ed_sim(i), health_sim(i,t), firm_sim(i,t),exp_sim(i,t), t)   ) THEN
         ii_sim(i,t)=1         
     ELSE
         ii_sim(i,t)=0
     END IF
     

       income=exp(alpha_w_1(ind_type_sim(i))+alpha_w_1_ed(ed_sim(i)) &
       +(alpha_w_4(ind_type_sim(i))+alpha_w_4_ed(ed_sim(i)))*(exp_sim(i,t)-1) &
       +(alpha_w_5(ind_type_sim(i))+alpha_w_5_ed(ed_sim(i)))*((exp_sim(i,t)-1)**2.0d0) )




income=income*(hi_sim(i,t)-1.0d0)*z_1(firm_sim(i, t),ed_sim(i),grid_exp) &
       +income*(2.0d0-hi_sim(i,t))*z_0(firm_sim(i, t),ed_sim(i),grid_exp) 

wage_sim(i, t)=income
     

IF (income>0) THEN

income=-ltax0/30000.0d0+(ltax1*(income*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0
END IF



        !calculate the expected health transition 
        DO med_care=0, 1
        
        value_next(med_care+1)=0.0d0
        med_shock=dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,t))+beta_m(health_sim(i,t))*t+gamma_m(health_sim(i,t))*(t**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,t))*health_draw_sim(i,t))-kappa(health_sim(i,t)),0.0d0)
        IF (med_shock>0.0d0) THEN
med_pos_dummy=1
ELSE
med_pos_dummy=0
END IF
        !oop !simply fully insured or not right now
 IF (hi_sim(i,t)==2) THEN
    IF (med_shock<deduc) THEN
        oop=med_care*med_shock 
    ELSE
        oop=med_care*(deduc+(med_shock-deduc)*coins)
    END IF
 ELSE IF (hi_sim(i,t)==1) THEN
     IF (ii_sim(i,t)==0) THEN
        oop=med_care*med_shock
     ELSE 
         IF (med_shock<deduc_ii) THEN
            oop=med_care*med_shock 
        ELSE
            oop=med_care*(deduc_ii+(med_shock-deduc_ii)*coins_ii)
        END IF
    END IF
        !oop=med_shock
        END IF
        
IF (ii_sim(i,t)==1) THEN

    cons=income-oop-p_ii(t, health_sim(i,t))
ELSE
    cons=dmax1(income-oop,cons_floor)
END IF

utility(med_care+1)=-exp(-gamma(ind_type_sim(i))*cons)/gamma(ind_type_sim(i))-dmax1(t-age_dis,0.0d0)*eta-t*eta_u*(health_sim(i,t)-1.0d0) -theta(health_sim(i,t),ind_type_sim(i))        
        DO next_health=1, num_health

            next_value7=0.0d0

        !calculate the probability that the next period health is next_health
 prob_health_next=exp(alpha_1_k(next_health, health_sim(i,t))+alpha_2_k(next_health, health_sim(i,t))*med_care*med_pos_dummy+alpha_3_k(next_health, health_sim(i,t))*med_shock &
+alpha_4_k(next_health, health_sim(i,t))*t+alpha_5_k(next_health, ind_type_sim(i))+alpha_6_k(next_health, health_sim(i,t))*med_care*med_shock   ) &
/(exp(alpha_1_k(1, health_sim(i,t))+alpha_2_k(1, health_sim(i,t))*med_care*med_pos_dummy+alpha_3_k(1, health_sim(i,t))*med_shock &
+alpha_4_k(1, health_sim(i,t))*t+alpha_5_k(1, ind_type_sim(i))+alpha_6_k(1, health_sim(i,t))*med_care*med_shock ) &
+exp(alpha_1_k(2, health_sim(i,t))+alpha_2_k(2, health_sim(i,t))*med_care*med_pos_dummy+alpha_3_k(2, health_sim(i,t))*med_shock &
+alpha_4_k(2, health_sim(i,t))*t+alpha_5_k(2, ind_type_sim(i))+alpha_6_k(2, health_sim(i,t))*med_care*med_shock    ) )


        next_value7=term_health(next_health)    

        next_value7=next_value7*prob_health_next

        value_next(med_care+1)=value_next(med_care+1)+beta*next_value7


        END DO !next_health

        END DO !medicare care

!evaluate maximum over medical care decision
IF (utility(2)+value_next(2)>utility(1)+value_next(1)) THEN
med_care_sim(i,t)=1
ELSE
med_care_sim(i,t)=0
END IF



ELSE IF (emp_sim(i, t)==0) THEN !unemployed 

     IF (ii_shock(i,t)>choice_ii_u(ind_type_sim(i),ed_sim(i), health_sim(i,t), exp_sim(i,t), t)   ) THEN
         ii_sim(i,t)=1         
     ELSE
         ii_sim(i,t)=0
         END IF    
    
    
    
wage_sim(i, t)=0.0d0

!income
income=ump_flow
!subtract insurance premium: ii

DO med_care=0,1

value_next(med_care+1)=0.0d0

!oop !simply fully insured or not right now
med_shock=dmax1(exp(eta1_m(ind_type_sim(i))+ alpha_m(health_sim(i,t))+beta_m(health_sim(i,t))*t+gamma_m(health_sim(i,t))*(t**2.0d0)+eta2_m(ind_type_sim(i))*sigma_m(health_sim(i,t))*health_draw_sim(i,t))-kappa(health_sim(i,t)),0.0d0)



IF (ii_sim(i,t)==0 ) THEN
oop=med_care*med_shock

ELSE
    IF (med_shock<deduc_ii) THEN
oop=med_care*med_shock 
    ELSE
        oop=med_care*(deduc_ii+(med_shock-deduc_ii)*coins_ii)
    END IF
END IF

IF (ii_sim(i,t)==0 ) THEN
cons=dmax1(income-oop,cons_floor)
ELSE
cons=income-oop-p_ii(t, health_sim(i,t))
END IF

        !utility from today 
        utility(med_care+1)=-exp(-gamma(ind_type_sim(i))*cons)/gamma(ind_type_sim(i))-theta(health_sim(i,t),ind_type_sim(i))



! calculate the value from meeting
! NEXT PERIOD HEALTH
DO next_health=1, num_health


!calculate the probability that the next period health is next_health
 prob_health_next=exp(alpha_1_k(next_health, health_sim(i,t))+alpha_2_k(next_health, health_sim(i,t))*med_care*med_pos_dummy+alpha_3_k(next_health, health_sim(i,t))*med_shock &
+alpha_4_k(next_health, health_sim(i,t))*t+alpha_5_k(next_health, ind_type_sim(i))+alpha_6_k(next_health, health_sim(i,t))*med_care*med_shock   ) &
/(exp(alpha_1_k(1, health_sim(i,t))+alpha_2_k(1, health_sim(i,t))*med_care*med_pos_dummy+alpha_3_k(1, health_sim(i,t))*med_shock &
+alpha_4_k(1, health_sim(i,t))*t+alpha_5_k(1, ind_type_sim(i))+alpha_6_k(1, health_sim(i,t))*med_care*med_shock ) &
+exp(alpha_1_k(2, health_sim(i,t))+alpha_2_k(2, health_sim(i,t))*med_care*med_pos_dummy+alpha_3_k(2, health_sim(i,t))*med_shock &
+alpha_4_k(2, health_sim(i,t))*t+alpha_5_k(2, ind_type_sim(i))+alpha_6_k(2, health_sim(i,t))*med_care*med_shock    ) )


! NEXT PERIOD EVENT

next_value7=term_health(next_health)

next_value7=prob_health_next*next_value7

value_next(med_care+1)=value_next(med_care+1)+next_value7

END DO ! HEALTH STATUS

!multiply by discount factor
value_next(med_care+1)=beta*value_next(med_care+1)

END DO !medicare care

!evaluate maximum over medical care decision
IF (utility(2)+value_next(2)>utility(1)+value_next(1)) THEN
med_care_sim(i,t)=1
ELSE
med_care_sim(i,t)=0
END IF


END IF !employment status



END DO !individual simulation


! check insurance status
DO m=1, 2
dist_type(m,1)=0.0d0
dist_type(m,2)=0.0d0
dist_denom(m,1)=0.0d0
dist_denom(m,2)=0.0d0
DO n=1, num_firm
dist_type(m,1)=dist_type(m,1)+sum(emp_dist(1,m,:,1,n,:, :))*prob_meet(n)*(1.0d0-ehi_offer(n))
dist_type(m,2)=dist_type(m,2)+sum(emp_dist(1,m,:,2,n,:, :))*prob_meet(n)*ehi_offer(n)
dist_denom(m,1)=dist_denom(m,1)+sum(emp_dist(:,m,:,1,n,:, :))*prob_meet(n)*(1.0d0-ehi_offer(n))
dist_denom(m,2)=dist_denom(m,2)+sum(emp_dist(:,m,:,2,n,:, :))*prob_meet(n)*ehi_offer(n)

END DO

dist_type(m,1)=dist_type(m,1)/dist_denom(m,1)
dist_type(m,2)=dist_type(m,2)/dist_denom(m,2)
 

END DO

!OPEN(100, file="dist_type.txt")
!DO n=1, 2
! write(100, *) dist_type(n,1), dist_type(n,2)
!END DO
!CLOSE (100)
!
DO n=1, num_firm
dist_type1(n,1)=sum(emp_dist(:,:,1,1,n,:, :))/sum(emp_dist(:,:,:,1,n,:, :))
dist_type1(n,2)=sum(emp_dist(:,:,1,2,n,:, :))/sum(emp_dist(:,:,:,2,n,:, :))
END DO
!
!OPEN(100, file="dist_type.txt")
!DO n=1, 2
! write(100, *) dist_type(n,1), dist_type(n,2)
!END DO
!CLOSE (100)
!
!OPEN(100, file="dist_type_firm.txt")
!DO n=1, num_firm
! write(100, *) dist_type1(n,1), dist_type1(n,2)
!END DO
!CLOSE (100)
!


 
END SUBROUTINE