SUBROUTINE size_approximation

use params
use mod_dp
USE olsroutines
USE Emax_approximation

implicit none
LOGICAL ISNAN

INTEGER i,j, n,m
INTEGER ind_type, ed_type, health_type, ins_status, work_exp, period, skill_exp,grid_exp 
REAL(DP) value_z, value_a, value_b, value_u, weight
REAL(DP), allocatable:: size_e(:,:),coeff_size_e(:), ste_size_e(:)
INTEGER num_size_e, rank_reg_s
integer, parameter:: constreg=1
real(dp):: stats(5)

DO i=1, num_firm_sim
DO ed_type=1, num_ed
DO skill_exp=1, num_wage_exp

emp_dist_sim_1(i,1,ed_type,skill_exp)=0.0d0
emp_dist_sim_1(i,2,ed_type,skill_exp)=0.0d0
emp_dist_sim_2(i,1,ed_type,skill_exp)=0.0d0
emp_dist_sim_2(i,2,ed_type,skill_exp)=0.0d0
med_dist_sim_1(i,ed_type,skill_exp)=0.0d0


DO period=1, num_period
DO work_exp=1,period
DO ins_status=1, 2 
DO health_type=1, num_health

DO ind_type=1, num_type


value_z=value_emp_sim(ind_type, ed_type, health_type, ins_status, i, work_exp, period)

value_u=value_unemp(ind_type, ed_type, health_type, work_exp, period)


IF (value_emp(ind_type, ed_type, health_type, ins_status, 1, work_exp, period)>value_z .and. value_z>value_u) THEN

emp_dist_sim(ind_type, ed_type, health_type, ins_status, i,work_exp, period)= &
value_z/value_emp(ind_type, ed_type, health_type, ins_status, 1, work_exp, period)  * &
emp_dist(ind_type, ed_type, health_type, ins_status, 1,work_exp, period)
 

ELSE IF (value_z>=value_emp(ind_type, ed_type, health_type, ins_status, num_firm, work_exp, period)) THEN

emp_dist_sim(ind_type, ed_type, health_type, ins_status, i,work_exp, period)= &
emp_dist(ind_type, ed_type, health_type, ins_status, num_firm,work_exp, period)*(1.0d0+ &
abs((value_z-value_emp(ind_type, ed_type, health_type, ins_status, num_firm, work_exp, period)))/ &
abs(value_emp(ind_type, ed_type, health_type, ins_status, num_firm, work_exp, period)) )


ELSE
DO j=1, num_firm-1
value_a=value_emp(ind_type, ed_type, health_type, ins_status, j, work_exp, period)
value_b=value_emp(ind_type, ed_type, health_type, ins_status, j+1, work_exp, period)
IF (value_z>=value_a .and. value_z<value_b) THEN
weight=(value_b-value_z)/(value_b-value_a)

emp_dist_sim(ind_type, ed_type, health_type, ins_status, i,work_exp, period)= & 
weight*emp_dist(ind_type, ed_type, health_type, ins_status, j,work_exp, period) &
+(1.0d0-weight)*emp_dist(ind_type, ed_type, health_type, ins_status, j+1,work_exp, period)


EXIT
END IF
END DO
END IF

grid_exp=(work_exp-1)/num_wage_rank+1

IF (grid_exp==skill_exp) THEN

IF (ins_status==1) THEN
emp_dist_sim_1(i, 1,ed_type,skill_exp)=emp_dist_sim_1(i,1,ed_type,skill_exp)+emp_dist_sim(ind_type, ed_type, health_type, 1, i,work_exp, period) &
                *exp( alpha_w_1(ind_type)  +alpha_w_1_ed(ed_type) &
       +(alpha_w_4(ind_type)+alpha_w_4_ed(ed_type))*(work_exp-1) &
       +(alpha_w_5(ind_type)+alpha_w_5_ed(ed_type))*((work_exp-1)**2.0) & 
       +alpha_w_6(health_type) )
       
emp_dist_sim_2(i, 1,ed_type,skill_exp)=emp_dist_sim_2(i,1,ed_type,skill_exp)+emp_dist_sim(ind_type, ed_type, health_type, 1, i,work_exp, period) &
                *exp( alpha_w_1(ind_type)  +alpha_w_1_ed(ed_type) &
       +(alpha_w_4(ind_type)+alpha_w_4_ed(ed_type))*(work_exp-1) &
       +(alpha_w_5(ind_type)+alpha_w_5_ed(ed_type))*((work_exp-1)**2.0)  )


       
ELSE IF (ins_status==2) THEN
emp_dist_sim_1(i, 2,ed_type,skill_exp)=emp_dist_sim_1(i,2,ed_type,skill_exp)+emp_dist_sim(ind_type, ed_type, health_type, 2, i,work_exp, period) &
                *exp( alpha_w_1(ind_type)  +alpha_w_1_ed(ed_type) &
       +(alpha_w_4(ind_type)+alpha_w_4_ed(ed_type))*(work_exp-1) &
       +(alpha_w_5(ind_type)+alpha_w_5_ed(ed_type))*((work_exp-1)**2.0) & 
       +alpha_w_6(health_type) )
       
emp_dist_sim_2(i, 2,ed_type,skill_exp)=emp_dist_sim_2(i,2,ed_type,skill_exp)+emp_dist_sim(ind_type, ed_type, health_type, 2, i,work_exp, period) &
                *exp( alpha_w_1(ind_type)  +alpha_w_1_ed(ed_type) &
       +(alpha_w_4(ind_type)+alpha_w_4_ed(ed_type))*(work_exp-1) &
       +(alpha_w_5(ind_type)+alpha_w_5_ed(ed_type))*((work_exp-1)**2.0)  )       
       
       
med_dist_sim_1(i,ed_type,skill_exp)=med_dist_sim_1(i,ed_type,skill_exp)+emp_dist_sim(ind_type, ed_type, health_type, 2, i,work_exp, period) &
       *ex_med_sim_f(ind_type, ed_type, health_type, 2, i,work_exp, period)

END IF

END IF

END DO
END DO
END DO
END DO
END DO


END DO
END DO



END DO




!OPEN(100, file="emp_dist_app.txt")
!DO i=1, num_firm_sim
! write(100, *) sum(emp_dist_sim(:, :, :, :, i,:, :)), sum(value_emp_sim(:, :, :, :, i,:, :))
!! print*, ehi_premium_new(i), ehi_premium(i)
!END DO 
!CLOSE (100)
!
!OPEN(100, file="emp_dist_all.txt")
!DO i=1, num_firm
! write(100, *) sum(emp_dist(:, :, :, :, i,:, :)), sum(value_emp(:, :, :, :, i,:, :))
!! print*, ehi_premium_new(i), ehi_premium(i)
!END DO 
!CLOSE (100)



END SUBROUTINE