SUBROUTINE solve_eq

use params
use mod_dp
 

implicit none
  
LOGICAL ISNAN 

INTEGER ind_type, ed_type, health_type, hi_type, firm_index, hi_firm_index, age, period, health_shock, ins_status, new_firm_index, work_exp
integer:: i,j,k,n,m,t, tt, count !index
integer t1, t2, t_rate, t_max, diff, skill_exp
real(dp) criteria, weight, uninsured, unemp_rate, eshi_emp, unins_emp, ii_all, ii_emp
real(dp), parameter:: tol=0.05d0
! simulation of the model
! (1) given parameter values, calculate value functions
! (2) given value function, simulate individual problem for 100 people
! the probability factors such as delta and match specific productivity are generated from uniform number draw

!start counting the time
call system_clock(t1)



!initial guess
DO i=1, num_firm
ehi_premium(i)=0.01d0
!ehi_premium(i)=0.0d0
ehi_offer(i)=0.50d0
ehi_premium_new(i)=0.05d0
!ehi_premium_new(i)=0.0d0
ehi_offer_new(i)=0.50d0
DO j=1, 2
DO k=1, num_wage_exp
alpha_rate_0(i,j,k)=0.80d0
alpha_rate_1(i,j,k)=0.80d0
alpha_rate_0_new(i,j,k)=0.80d0
alpha_rate_1_new(i,j,k)=0.80d0
END DO 
END DO
END DO 

weight=0.05d0



!OPEN(1, file="z_read.txt")
!DO i=1, num_firm
! READ(1,fmt=*) z_0_new(i,1),z_0_new(i,2), z_1_new(i,1),z_1_new(i,2)
!END DO 
!CLOSE (1)
!
!OPEN(1, file="ehi_offer_read.txt")
!DO i=1, num_firm
! READ(1,fmt=*) ehi_offer(i)
!END DO 
!CLOSE (1)
!
!
!DO i=1, num_firm
!DO j=1, num_ed
!alpha_rate_0(i,j)=z_0_new(i,j)/firm_prod(i)
!alpha_rate_1(i,j)=z_1_new(i,j)/firm_prod(i)
!END DO
!END DO
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!assign sampling probnaility and draw random number




count=0


! SOLVE THE EQUILIBRIUM
criteria=1.0d0
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! start iteration in equilibrium model
do while (criteria .gt. tol .and. count<20 )
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



! generate z function
DO i=1, num_firm
DO j=1, 2
DO k=1, num_wage_exp
z_0(i,j,k)=firm_prod(i)*alpha_rate_0(i,j,k)
z_1(i,j,k)=firm_prod(i)*alpha_rate_1(i,j,k)
END DO
END DO
END DO


!write (10,*) 'reach 0'
! (1) solve the value function backward
! (a) last period
call value_calculation_last

call value_calculation



call value_simulation_last
call value_simulation


call system_clock(t2, t_rate, t_max)
if (t2< t1) then 
diff =t_max-t1+t2
else 
diff=t2-t1
endif
! print "(A, F10.3)", "time it took was (vf):", diff/dble(t_rate)



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! generate steady state distribution
call E_emp_dist


call system_clock(t2, t_rate, t_max)
if (t2< t1) then 
diff =t_max-t1+t2
else 
diff=t2-t1
endif
! print "(A, F10.3)", "time it took was (sim):", diff/dble(t_rate)


call size_approximation

call system_clock(t2, t_rate, t_max)
if (t2< t1) then 
diff =t_max-t1+t2
else 
diff=t2-t1
endif
!print "(A, F10.3)", "time it took was (size-app):", diff/dble(t_rate)

!calculate insurance premium
call insurance_offer

call system_clock(t2, t_rate, t_max)
if (t2< t1) then 
diff =t_max-t1+t2
else 
diff=t2-t1
endif
!print "(A, F10.3)", "time it took was (solve firm):", diff/dble(t_rate)


criteria=0.0d0
do i=1, num_firm
DO j=1, 2
DO k=1, num_wage_exp
alpha_rate_0_new(i,j,k)=z_0_new(i,j,k)/firm_prod(i)
alpha_rate_1_new(i,j,k)=z_1_new(i,j,k)/firm_prod(i)
criteria=criteria+abs(alpha_rate_0(i,j,k)-alpha_rate_0_new(i,j,k))/num_firm
criteria=criteria+abs(alpha_rate_1(i,j,k)-alpha_rate_1_new(i,j,k))/num_firm
END DO
END DO
criteria=criteria+abs(ehi_offer(i)-ehi_offer_new(i))/num_firm
end do


count=count+1

! print*, count,  criteria

!DO i=1, num_firm
!print*, abs(alpha_rate_0_new(i)-alpha_rate_0(i)), abs(alpha_rate_1_new(i)-alpha_rate_1(i)),abs(ehi_offer_new(i)-ehi_offer(i))
!END DO 

call system_clock(t2, t_rate, t_max)
if (t2< t1) then 
diff =t_max-t1+t2
else 
diff=t2-t1
endif
!print "(A, F10.3)", "time it took was:", diff/dble(t_rate)

IF (data_mode==2) THEN
OPEN(100, file="ehi_offer_comparison.txt")
DO i=1, num_firm
! write(100, *) ehi_offer_new(i)
write(100, *) ehi_offer_new(i), ehi_offer(i)
END DO 
CLOSE (100)
END IF

!update premium and offer rate across employers

DO i=1, num_firm
ehi_offer(i)=weight*ehi_offer(i)+(1.0d0-weight)*ehi_offer_new(i)
ehi_premium(i)=weight*ehi_premium(i)+(1.0d0-weight)*ehi_premium_new(i)
DO j=1, 2
DO k=1, num_wage_exp
alpha_rate_0(i,j,k)=weight*alpha_rate_0(i,j,k)+(1.0d0-weight)*alpha_rate_0_new(i,j,k)
alpha_rate_1(i,j,k)=weight*alpha_rate_1(i,j,k)+(1.0d0-weight)*alpha_rate_1_new(i,j,k)
END DO
END DO
END DO

!print*, eq_premium
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!IF (count>=2) THEN
!stop
!END IF




IF (count>=20) THEN
non_converge=1
END IF

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

uninsured=0.0d0
ii_all=0.0d0
eshi_emp=0.0d0
unins_emp=0.0d0
ii_emp=0.0d0
DO period=19, num_period-6
!DO period=1, num_period
DO work_exp=1, period
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
uninsured=uninsured+unemp_dist(ind_type,ed_type,health_type,work_exp, period)*choice_ii_u(ind_type,ed_type,health_type,work_exp, period) 
ii_all=ii_all+unemp_dist(ind_type,ed_type,health_type,work_exp, period)*(1.0d0-choice_ii_u(ind_type,ed_type,health_type,work_exp, period) )
END DO
END DO
END DO
END DO
END DO


 

unemp_rate=sum(unemp_dist(:, :, :, :,  19:num_period-6) )  !/sum(cohort_weight(num_period,num_ed))


DO firm_index=1, num_firm
eshi_emp=eshi_emp+sum(emp_dist(:, :, :, 2, firm_index,:, 19:num_period-6))*ehi_offer(firm_index)*prob_meet(firm_index)
!eshi_emp=eshi_emp+sum(emp_dist(:, :, :, 2, firm_index,:, :))*ehi_offer(firm_index)*prob_meet(firm_index)
DO period=19, num_period-6
!DO period=1, num_period

DO work_exp=1, period
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
uninsured=uninsured+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, period)*choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, period)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
unins_emp=unins_emp+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, period)*choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, period)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
ii_emp=ii_emp+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, period)*(1.0d0-choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, period))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
ii_all=ii_all+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, period)*(1.0d0-choice_ii(ind_type, ed_type, health_type, firm_index,work_exp, period))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
END DO
END DO
END DO
END DO
END DO
END DO


OPEN(100, file="totl_uninsured.txt")
write(100, *) uninsured/(unemp_rate+eshi_emp+unins_emp+ii_emp), 'unins'
write(100, *) unemp_rate/(unemp_rate+eshi_emp+unins_emp+ii_emp), 'unemp'
write(100, *) eshi_emp/(unemp_rate+eshi_emp+unins_emp+ii_emp), 'eshi_emp'
write(100, *) unins_emp/(unemp_rate+eshi_emp+unins_emp+ii_emp), 'unins_emp'
write(100, *) ii_emp/(unemp_rate+eshi_emp+unins_emp+ii_emp), 'ii_emp'
write(100, *) ii_all/(unemp_rate+eshi_emp+unins_emp+ii_emp), 'ii_all'
CLOSE (100)


IF (data_mode==2) THEN
    
OPEN(100, file="ehi_offer.txt")
DO i=1, num_firm
write(100, *) ehi_offer_new(i)
END DO
CLOSE (100)

OPEN(100, file="alpha_0.txt")
DO i=1, num_firm
DO skill_exp=1, num_wage_exp
write(100, *) alpha_rate_0_new(i,1,skill_exp), alpha_rate_0_new(i,2,skill_exp)
END DO
END DO
CLOSE (100)

OPEN(100, file="alpha_1.txt")
DO i=1, num_firm
DO skill_exp=1, num_wage_exp
write(100, *) alpha_rate_1_new(i,1,skill_exp), alpha_rate_1_new(i,2,skill_exp)
END DO
END DO
CLOSE (100)


OPEN(1, file="z_read.txt")
DO i=1, num_firm
DO skill_exp=1, num_wage_exp
 write(1, *) z_0_new(i,1,skill_exp),z_0_new(i,2,skill_exp), z_1_new(i,1,skill_exp),z_1_new(i,2,skill_exp)
END DO
 END DO 
CLOSE (1)

OPEN(1, file="ehi_offer_read.txt")
DO i=1, num_firm
 write(1, *) ehi_offer_new(i)
END DO 
CLOSE (1)

END IF

end do !complete iteration

call system_clock(t2, t_rate, t_max)
if (t2< t1) then 
diff =t_max-t1+t2
else 
diff=t2-t1
endif
! print "(A, F10.3)", "time it took for iteration:", diff/dble(t_rate)

END SUBROUTINE