SUBROUTINE std_eval_firm(moment_firm)

! ESTIMATE FIRM PRODUCTIVITY DISTRIBUTION TO FIT EMPLOYER SIDE MOMENTS

use params
use mod_dp



!REAL(DP) moments_all()

implicit none

LOGICAL ISNAN
!REAL(DP), INTENT(IN):: param_est1(:)
!REAL(DP), INTENT(OUT):: obj_value
REAL(DP) obj_value, moment_firm(num_moment3)
REAL(DP) mom_number, denom, denom_hi, denom_nhi, denom_hi_s, denom_hi_l, moment_value(13) !, obj_value
integer:: i,j,k,n,m,t,l, tt, count !index
INTEGER period, ind_type, ed_type, health_type, hi_type, firm_index, work_exp, grid_exp
REAL(DP) denom_wage_hi, denom_wage_nhi, firm_mean_wage_m(num_firm, 2), worker_s, worker_l , worker_hi, worker_nhi

! step 2: calculate firm size distribution



!caluclate statistics
!mean firm size
mean_offer_rate=0.0d0
m_mean_size=0.0d0
m_hioffer_s=0.0d0
m_hioffer_l=0.0d0
m_size_hi=0.0d0 
m_size_nhi=0.0d0
denom=0.0d0
denom_hi=0.0d0
denom_nhi=0.0d0
size_frac_50=0.0d0
firm_mean_wage_all=0.0d0
firm_mean_wage_hi=0.0d0
firm_mean_wage_nhi=0.0d0
firm_std_wage_all=0.0d0
firm_std_wage_hi=0.0d0
firm_std_wage_nhi=0.0d0
denom_wage_hi=0.0d0
denom_wage_nhi=0.0d0
emp_mean_wage_all=0.0d0
emp_mean_wage_hi=0.0d0
emp_mean_wage_nhi=0.0d0
emp_std_wage_all=0.0d0
emp_std_wage_hi=0.0d0
emp_std_wage_nhi=0.0d0
emp_age_s=0.0d0
emp_age_l=0.0d0
worker_s=0.0d0
worker_l=0.0d0
emp_age_hi=0.0d0
emp_age_nhi=0.0d0
worker_hi=0.0d0
worker_nhi=0.0d0


DO i=1, num_firm
firm_mean_wage_m(i,1)=0.0d0
firm_mean_wage_m(i,2)=0.0d0
eq_size_hi(i,1)=eq_size_hi(i,1)*worker_size1
eq_size_hi(i,2)=eq_size_hi(i,2)*worker_size1
eq_size_nhi(i,1)=eq_size_nhi(i,1)*worker_size1
eq_size_nhi(i,2)=eq_size_nhi(i,2)*worker_size1

DO period=1, num_period
DO work_exp=1, num_exp

grid_exp=(work_exp-1)/num_wage_rank+1

DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
firm_mean_wage_m(i,2)=firm_mean_wage_m(i,2)+ &
emp_dist(ind_type,ed_type,health_type,2,i,work_exp, period)* &
exp(alpha_w_1(ind_type)+alpha_w_1_ed(ed_type) &
       +(alpha_w_4(ind_type)+alpha_w_4_ed(ed_type))*(work_exp-1) &
       +(alpha_w_5(ind_type)+alpha_w_5_ed(ed_type))*((work_exp-1)**2.0) & 
       +alpha_w_6(health_type) )*z_1(i,ed_type,grid_exp) 



firm_mean_wage_m(i,1)=firm_mean_wage_m(i,1)+ &
emp_dist(ind_type,ed_type,health_type,1,i,work_exp, period)*  &
exp(alpha_w_1(ind_type)+alpha_w_1_ed(ed_type) &
       +(alpha_w_4(ind_type)+alpha_w_4_ed(ed_type))*(work_exp-1) &
       +(alpha_w_5(ind_type)+alpha_w_5_ed(ed_type))*((work_exp-1)**2.0) & 
       +alpha_w_6(health_type) )*z_0(i,ed_type,grid_exp) 
       
END DO
END DO
END DO
END DO
END DO

firm_mean_wage_m(i,2)=firm_mean_wage_m(i,2)/ sum(emp_dist(:,:,:,2,i,:, :))*ehi_offer_new(i)*prob_meet(i)
firm_mean_wage_m(i,1)=firm_mean_wage_m(i,1)/ sum(emp_dist(:,:,:,1,i,:, :))*(1.0d0-ehi_offer_new(i))*prob_meet(i)


denom_hi=denom_hi+ehi_offer_new(i)*prob_meet(i)
denom_nhi=denom_nhi+(1.0d0-ehi_offer_new(i))*prob_meet(i)

m_size_hi=m_size_hi+(eq_size_hi(i,1)+eq_size_hi(i,2))*ehi_offer_new(i)*prob_meet(i)
m_size_nhi=m_size_nhi+(eq_size_nhi(i,1)+eq_size_nhi(i,2))*(1.0d0-ehi_offer_new(i))*prob_meet(i)

IF ((eq_size_hi(i,1)+eq_size_hi(i,2))<=size_50 ) THEN
denom_hi_s=denom_hi_s+prob_meet(i)*ehi_offer_new(i)
m_hioffer_s=m_hioffer_s+prob_meet(i)*ehi_offer_new(i)
END IF
IF ((eq_size_nhi(i,1)+eq_size_nhi(i,2))<=size_50 ) THEN
denom_hi_s=denom_hi_s+prob_meet(i)*(1.0d0-ehi_offer_new(i) )
END IF

IF ((eq_size_hi(i,1)+eq_size_hi(i,2))>size_50 ) THEN
denom_hi_l=denom_hi_l+prob_meet(i)*ehi_offer_new(i)
m_hioffer_l=m_hioffer_l+prob_meet(i)*ehi_offer_new(i)
END IF
IF ((eq_size_nhi(i,1)+eq_size_nhi(i,2))>size_50 ) THEN
denom_hi_l=denom_hi_l+prob_meet(i)*(1.0d0-ehi_offer_new(i) )
END IF


IF ((eq_size_hi(i,1)+eq_size_hi(i,2))<=size_50 ) THEN
DO period=1, num_period
DO work_exp=1, num_exp
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
worker_s=worker_s+emp_dist(ind_type,ed_type,health_type,2,i,work_exp, period)*ehi_offer_new(i)*prob_meet(i)
emp_age_s=emp_age_s+(18.0d0+period/3)*emp_dist(ind_type,ed_type,health_type,2,i,work_exp, period)*ehi_offer_new(i)*prob_meet(i)
END DO
END DO
END DO
END DO
END DO
END IF
IF ((eq_size_nhi(i,1)+eq_size_nhi(i,2))<=size_50 ) THEN
DO period=1, num_period
DO work_exp=1, num_exp
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
worker_s=worker_s+emp_dist(ind_type,ed_type,health_type,1,i,work_exp, period)*(1.0d0-ehi_offer_new(i))*prob_meet(i)
emp_age_s=emp_age_s+(18.0d0+period/3)*emp_dist(ind_type,ed_type,health_type,1,i,work_exp, period)*(1.0d0-ehi_offer_new(i))*prob_meet(i)
END DO
END DO
END DO
END DO
END DO
END IF

IF ((eq_size_hi(i,1)+eq_size_hi(i,2))>size_50 ) THEN
DO period=1, num_period
DO work_exp=1, num_exp
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
worker_l=worker_l+emp_dist(ind_type,ed_type,health_type,2,i,work_exp, period)*ehi_offer_new(i)*prob_meet(i)
emp_age_l=emp_age_l+(18.0d0+period/3)*emp_dist(ind_type,ed_type,health_type,2,i,work_exp, period)*ehi_offer_new(i)*prob_meet(i)
END DO
END DO
END DO
END DO
END DO
END IF
IF ((eq_size_nhi(i,1)+eq_size_nhi(i,2))>size_50 ) THEN
DO period=1, num_period
DO work_exp=1, num_exp
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
worker_l=worker_l+emp_dist(ind_type,ed_type,health_type,1,i,work_exp, period)*(1.0d0-ehi_offer_new(i))*prob_meet(i)
emp_age_l=emp_age_l+(18.0d0+period/3)*emp_dist(ind_type,ed_type,health_type,1,i,work_exp, period)*(1.0d0-ehi_offer_new(i))*prob_meet(i)
END DO
END DO
END DO
END DO
END DO
END IF


DO period=1, num_period
DO work_exp=1, num_exp
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
worker_hi=worker_hi+emp_dist(ind_type,ed_type,health_type,2,i,work_exp, period)*ehi_offer_new(i)*prob_meet(i)
emp_age_hi=emp_age_hi+(18.0d0+period/3)*emp_dist(ind_type,ed_type,health_type,2,i,work_exp, period)*ehi_offer_new(i)*prob_meet(i)

worker_nhi=worker_nhi+emp_dist(ind_type,ed_type,health_type,1,i,work_exp, period)*(1.0d0-ehi_offer_new(i))*prob_meet(i)
emp_age_nhi=emp_age_nhi+(18.0d0+period/3)*emp_dist(ind_type,ed_type,health_type,1,i,work_exp, period)*(1.0d0-ehi_offer_new(i))*prob_meet(i)


END DO
END DO
END DO
END DO
END DO

END DO ! i firm

emp_age_l=emp_age_l/worker_l
emp_age_s=emp_age_s/worker_s
emp_age_hi=emp_age_hi/worker_hi
emp_age_nhi=emp_age_nhi/worker_nhi


firm_mean_wage_all=sum(firm_mean_wage_m(:,:))/(denom_hi+denom_nhi)
firm_mean_wage_hi=sum(firm_mean_wage_m(:,2))/denom_hi
firm_mean_wage_nhi=sum(firm_mean_wage_m(:,1))/denom_nhi
mean_offer_rate=denom_hi/(denom_hi+denom_nhi)
!calculate standard deviation of firm wage
DO i=1, num_firm
firm_std_wage_hi=firm_std_wage_hi+((firm_mean_wage_m(i,2)-firm_mean_wage_hi)**2.0d0)*ehi_offer_new(i)*prob_meet(i)
firm_std_wage_nhi=firm_std_wage_nhi+((firm_mean_wage_m(i,1)-firm_mean_wage_nhi)**2.0d0)*(1.0d0-ehi_offer_new(i))*prob_meet(i)
END DO
firm_std_wage_hi=(firm_std_wage_hi/denom_hi)**0.50d0
firm_std_wage_nhi=(firm_std_wage_nhi/denom_nhi)**0.50d0
firm_std_wage_all=((firm_std_wage_nhi+firm_std_wage_hi)/(denom_hi+denom_nhi))**0.50d0

m_mean_size=(m_size_hi+m_size_nhi)/(denom_hi+denom_nhi)
m_size_hi=m_size_hi/denom_hi
m_size_nhi=m_size_nhi/denom_nhi
m_hioffer_s=m_hioffer_s/denom_hi_s
m_hioffer_l=m_hioffer_l/denom_hi_l
size_frac_50=denom_hi_s

!EVALUATE MOMENTS BY MINIMUM DISTANCE ESTIMATOR
moment_value(1)=m_mean_size-emp_size_mean_data
moment_value(2)=size_frac_50-sample_frac_small_firm 
moment_value(3)=m_size_hi-sample_firm_size_hi
moment_value(4)=m_size_nhi-sample_firm_size_nhi
moment_value(5)=m_hioffer_s-sample_ehi_small
moment_value(6)=m_hioffer_l-sample_ehi_large
moment_value(7)=mean_offer_rate-sample_mean_offer_rate



DO j=1, num_moment3
moment_firm(j)=moment_value(j)
END DO


IF (data_mode==2) THEN 


OPEN(100, file="firm_statistics_fit.txt")
write(100, *) m_mean_size, emp_size_mean_data
write(100, *) size_frac_50, sample_frac_small_firm 
write(100, *) m_size_hi, sample_firm_size_hi
write(100, *) m_size_nhi, sample_firm_size_nhi
write(100, *) m_hioffer_s, sample_ehi_small
write(100, *) m_hioffer_l, sample_ehi_large
write(100, *) firm_mean_wage_hi, sample_firm_mean_wage_hi
write(100, *) firm_mean_wage_nhi, sample_firm_mean_wage_nhi
write(100, *) firm_std_wage_hi, sample_firm_std_wage_hi
write(100, *) firm_std_wage_nhi, sample_firm_std_wage_nhi
write(100, *) mean_offer_rate, sample_mean_offer_rate
write(100, *) emp_age_hi, sample_emp_age_hi
write(100, *) emp_age_nhi, sample_emp_age_nhi
CLOSE (100)

END IF


END SUBROUTINE