subroutine welfare

use params
use mod_dp



implicit none

LOGICAL ISNAN

!integer num_param
REAL(DP) objective_value, obj_value, income_tax_revenue, im_revenue, premium_exp, income(2), ind_tax, ind_subsidy, utility(3), g_bb, utility_u(2)
INTEGER ind_type, ed_type, health_type, hi_type, firm_index, hi_firm_index, age, period, health_shock, ins_status, new_firm_index
integer i, t, work_exp, j, grid_exp
REAL(DP) emp_mandate, em_revenue, social_welfare, productivity, gdp, emp_denom, av_wage, wage_hi, wage_nhi, medical_exp, emp_denom_hi, emp_denom_nhi
REAL(DP) firm_prod_eq_dist(num_firm, 2), pop_health, prod_half, prod_half_age(104), pop_health_emp, denom, unins_age(104), prod_half_ed(104, num_type)
REAL(DP) unins_age_ed(104, num_ed), denom_ed(num_ed), pop_health_unins, denom_health_unins, eshi_age_ed(104, num_ed), denom_eshi_ed(num_ed), eshi_age(104)
REAL(DP) pop_denom



productivity=0.0d0
gdp=0.0d0
emp_denom=0.0d0
av_wage=0.0d0
wage_hi=0.0d0
wage_nhi=0.0d0
medical_exp=0.0d0
emp_denom_hi=0.0d0
emp_denom_nhi=0.0d0
pop_denom=0.0d0


DO firm_index=1, num_firm
firm_prod_eq_dist(firm_index, 1)=0.0d0
firm_prod_eq_dist(firm_index, 2)=0.0d0
END DO

pop_health=0.0d0
pop_health_unins=0.0d0
social_welfare=0.0d0
income_tax_revenue=0.0d0

!evaluate welfare and government budget balance
!DO t=1, num_period 
DO t=19, num_period-6
DO work_exp=1, t

grid_exp=(work_exp-1)/num_wage_rank+1

DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type



!evaluate utility in consumption equivalent value
DO firm_index=1, num_firm
 

!! income tax, subsidies, and penalty 
income(1)=exp(alpha_w_1(ind_type)+alpha_w_1_ed(ed_type) &
       +(alpha_w_4(ind_type)+alpha_w_4_ed(ed_type))*(work_exp-1) &
       +(alpha_w_5(ind_type)+alpha_w_5_ed(ed_type))*((work_exp-1)**2.0)  )
income(2)=income(1)





wage_nhi=wage_nhi+income(1)*z_0_new(firm_index, ed_type,grid_exp)*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) *(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)

wage_hi=wage_hi+income(1)*z_1_new(firm_index, ed_type,grid_exp)*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)

emp_denom_hi=emp_denom_hi+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)
emp_denom_nhi=emp_denom_nhi+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)

pop_denom=pop_denom+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)
pop_denom=pop_denom+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)


av_wage=av_wage+income(1)*z_0_new(firm_index, ed_type,grid_exp)*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
av_wage=av_wage+income(1)*z_1_new(firm_index, ed_type,grid_exp)*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)

gdp=gdp+income(1)*firm_prod(firm_index)*exp(alpha_w_6(health_type))*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
gdp=gdp+income(2)*firm_prod(firm_index)*exp(alpha_w_6(health_type))*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)

emp_denom=emp_denom+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
emp_denom=emp_denom+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)

medical_exp=medical_exp+ex_med(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
medical_exp=medical_exp+ex_med(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)
medical_exp=medical_exp+ex_med_f(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)

firm_prod_eq_dist(firm_index, 1)=firm_prod_eq_dist(firm_index, 1)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) &
*income(1)*firm_prod(firm_index)*exp(alpha_w_6(health_type))
firm_prod_eq_dist(firm_index, 2)=firm_prod_eq_dist(firm_index, 2)+(emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)) &
*income(2)*firm_prod(firm_index)*exp(alpha_w_6(health_type))




income(1)=income(1)*z_0_new(firm_index, ed_type,grid_exp)
income(2)=income(2)*z_1_new(firm_index, ed_type,grid_exp)

income_tax_revenue=income_tax_revenue+(income(1)-(-ltax0/30000.0d0+(ltax1*(income(1)*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0)  ) &
* (emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) )*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
income_tax_revenue=income_tax_revenue+(income(2)-(-ltax0/30000.0d0+(ltax1*(income(2)*30000.0d0)**(ltax2+1.0d0)/(ltax2+1.0d0))/30000.0d0)  ) &
* emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)

income_tax_revenue=income_tax_revenue+income(1)*tax_f*(emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t) )*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
income_tax_revenue=income_tax_revenue+income(2)*tax_f*emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)
END DO
END DO
END DO
END DO
END DO
END DO


DO firm_index=1, num_firm
firm_prod_eq_dist(firm_index, 1)=firm_prod_eq_dist(firm_index, 1)/(sum(emp_dist(:,:,:,1, firm_index,:, 19:num_period-6)) )
firm_prod_eq_dist(firm_index, 2)=firm_prod_eq_dist(firm_index, 2)/(sum(emp_dist(:,:,:,2, firm_index,:, 19:num_period-6)))
END DO



DO t=19, num_period-6
DO work_exp=1, t
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type

medical_exp=medical_exp+ex_med_u(ind_type, ed_type, health_type, work_exp, t)*unemp_dist(ind_type, ed_type, health_type, work_exp, t)*choice_ii_u(ind_type, ed_type, health_type, work_exp, t)

END DO
END DO
END DO
END DO
END DO



!social_welfare=social_welfare


 
!expenditure
g_bb=income_tax_revenue/pop_denom
medical_exp=medical_exp/pop_denom

social_welfare=frac_college*prob_type1(1)*value_unemp(1, 1, 1, 1, 1) &
+frac_college*(1.0d0-prob_type1(1))*value_unemp(2, 1, 1, 1, 1) &
+(1.0d0-frac_college)*prob_type1(2)*value_unemp(1, 2, 1, 1, 1) &
+(1.0d0-frac_college)*(1.0d0-prob_type1(2))*value_unemp(2, 2, 1, 1, 1)


productivity=gdp/emp_denom

pop_health_unins=0.0d0
denom_health_unins=0.0d0
pop_health=0.0d0


pop_health=sum(unemp_dist(:, :, 2, :, 19:num_period-6))

DO firm_index=1, num_firm
pop_health=pop_health+sum(emp_dist(:, :, 2, 1, firm_index,:, 19:num_period-6)) *(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
pop_health=pop_health+sum(emp_dist(:, :, 2, 2, firm_index,:, 19:num_period-6))*ehi_offer(firm_index)*prob_meet(firm_index)
END DO


!DO t=1, num_period 
DO t=19, num_period-6
DO work_exp=1, t
DO ed_type=1, num_ed
DO ind_type=1, num_type
pop_health_unins=pop_health_unins+unemp_dist(ind_type, ed_type, 2, work_exp, t)*choice_ii_u(ind_type, ed_type, 2, work_exp, t)
DO j=1, num_health
denom_health_unins=denom_health_unins+unemp_dist(ind_type, ed_type, j, work_exp, t)*choice_ii_u(ind_type, ed_type, j, work_exp, t)
END DO
DO firm_index=1, num_firm
pop_health_unins=pop_health_unins+emp_dist(ind_type, ed_type, 2, 1, firm_index,work_exp, t)*choice_ii(ind_type, ed_type, 2, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
DO j=1, num_health
denom_health_unins=denom_health_unins+emp_dist(ind_type, ed_type, j, 1, firm_index,work_exp, t)*choice_ii(ind_type, ed_type, j, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
END DO
END DO

END DO
END DO
END DO
END DO



pop_health_emp=pop_health/emp_denom

pop_health_unins=pop_health_unins/denom_health_unins

pop_health=pop_health/pop_denom


av_wage=av_wage/emp_denom
wage_hi=wage_hi/emp_denom_hi
wage_nhi=wage_nhi/emp_denom_nhi

prod_half=0.0d0
DO t=19, num_period-6
DO work_exp=1, t 
DO firm_index=num_firm/2, num_firm
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
prod_half=prod_half+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, t)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
prod_half=prod_half+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, t)*ehi_offer(firm_index)*prob_meet(firm_index)
END DO
END DO
END DO
END DO
END DO
END DO



prod_half=prod_half/emp_denom

DO i=1, 104
prod_half_age(i)=0.0d0
DO ed_type=1, 2
unins_age_ed(i, ed_type)=0.0d0!sum(unemp_dist(:, ed_type, :, :, i+18))
eshi_age_ed(i, ed_type)=0.0d0
denom_eshi_ed(ed_type)=0.0d0
denom_ed(ed_type)=0.0d0
END DO
unins_age(i)=0.0d0 !sum(unemp_dist(:, :, :, :, i+18))
denom=0.0d0
eshi_age(i)=0.0d0
DO firm_index=1, num_firm
DO ed_type=1, 2 
    eshi_age_ed(i, ed_type)=eshi_age_ed(i, ed_type)+sum(emp_dist(:, ed_type, :, 2, firm_index,:, i+18))*ehi_offer(firm_index)*prob_meet(firm_index)
    denom_eshi_ed(ed_type)=denom_eshi_ed(ed_type)+sum(emp_dist(:,ed_type, :, 1, firm_index,:, i+18))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index) & 
+sum(emp_dist(:, ed_type, :, 2, firm_index,:, i+18))*ehi_offer(firm_index)*prob_meet(firm_index)
unins_age_ed(i, ed_type)=unins_age_ed(i, ed_type)+sum(emp_dist(:, ed_type, :, 1, firm_index,:, i+18))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
denom_ed(ed_type)=denom_ed(ed_type)+sum(emp_dist(:, ed_type, :, 1, firm_index,:, i+18))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index) & 
+sum(emp_dist(:, ed_type, :, 2, firm_index,:, i+18))*ehi_offer(firm_index)*prob_meet(firm_index)
END DO

eshi_age(i)=eshi_age(i)+sum(emp_dist(:, :, :, 2, firm_index,:, i+18))*ehi_offer(firm_index)*prob_meet(firm_index)

unins_age(i)=unins_age(i)+sum(emp_dist(:, :, :, 1, firm_index,:, i+18))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
denom=denom+sum(emp_dist(:, :, :, 1, firm_index,:, i+18))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index) & 
+sum(emp_dist(:, :, :, 2, firm_index,:, i+18))*ehi_offer(firm_index)*prob_meet(firm_index)
END DO
!unins_age(i)=unins_age(i)+sum(unemp_dist(:, :, :, 1, :, i+18))
!denom=denom+sum(unemp_dist(:, :, :, :, :, i+18))
unins_age(i)=unins_age(i)/denom !(denom+sum(unemp_dist(:, :, :, :, i+18)))
eshi_age(i)=eshi_age(i)/denom


DO ed_type=1, 2
    eshi_age_ed(i, ed_type)=eshi_age_ed(i, ed_type)/denom_eshi_ed(ed_type)
unins_age_ed(i, ed_type)=unins_age_ed(i, ed_type)/denom_ed(ed_type) !(denom_ed(ed_type)+sum(unemp_dist(:, ed_type, :, :, i+18)))
END DO 
 

DO work_exp=1, i
DO firm_index=num_firm/2, num_firm
DO health_type=1, num_health
DO ed_type=1, num_ed
DO ind_type=1, num_type
prod_half_age(i)=prod_half_age(i)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, i+18)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
prod_half_age(i)=prod_half_age(i)+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, i+18)*ehi_offer(firm_index)*prob_meet(firm_index)
END DO
END DO
END DO
END DO
END DO

!denom=denom-sum(unemp_dist(:, :, :, :, :, i+18))

prod_half_age(i)=prod_half_age(i)/denom

! by education
DO ind_type=1, num_type
prod_half_ed(i, ind_type)=0.0d0 
denom=0.0d0
DO firm_index=1, num_firm
denom=denom+sum(emp_dist(ind_type, :, :, 1, firm_index,:, i+18))*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index) & 
+sum(emp_dist(ind_type, :, :, 2, firm_index,:, i+18))*ehi_offer(firm_index)*prob_meet(firm_index)
END DO

DO work_exp=1, i 
DO firm_index=num_firm/2, num_firm
DO health_type=1, num_health
DO ed_type=1, num_ed
prod_half_ed(i, ind_type)=prod_half_ed(i, ind_type)+emp_dist(ind_type, ed_type, health_type, 1, firm_index,work_exp, i)*(1.0d0-ehi_offer(firm_index))*prob_meet(firm_index)
prod_half_ed(i, ind_type)=prod_half_ed(i, ind_type)+emp_dist(ind_type, ed_type, health_type, 2, firm_index,work_exp, i)*ehi_offer(firm_index)*prob_meet(firm_index)
END DO
END DO
END DO
END DO

prod_half_ed(i, ind_type)=prod_half_ed(i, ind_type)/denom

END DO !ed


END DO



OPEN(100, file="eshi_age.txt")
DO i=1, 104
write(100, *) eshi_age(i)
END DO
CLOSE (100)
 
OPEN(100, file="unins_age.txt")
DO i=1, 104
write(100, *) unins_age(i)
END DO
CLOSE (100)
   
OPEN(100, file="unins_age_ed.txt")
DO i=1, 104
write(100, *) unins_age_ed(i,1), unins_age_ed(i,2)
END DO
CLOSE (100) 

OPEN(100, file="eshi_age_ed.txt")
DO i=1, 104
write(100, *) eshi_age_ed(i,1), eshi_age_ed(i,2)
END DO
CLOSE (100) 


IF (data_mode==2) THEN 

OPEN(100, file="prod_age.txt")
DO i=1, 104
write(100, *) prod_half_age(i)
END DO
CLOSE (100)

OPEN(100, file="prod_college.txt")
DO i=1, 104
write(100, *) prod_half_ed(i,1)
END DO
CLOSE (100)

OPEN(100, file="prod_noncollege.txt")
DO i=1, 104
write(100, *) prod_half_ed(i,2)
END DO
CLOSE (100)

OPEN(100, file="firm_prod_eq_dist.txt")
DO i=1, num_firm
write(100, *) firm_prod_eq_dist(i,1), firm_prod_eq_dist(i,2)
END DO
CLOSE (100)
  



OPEN(100, file="summary_result.txt")
write(100, *) social_welfare, 'social welfare' 
write(100, *) g_bb, 'total expendiure'
write(100, *) productivity, 'productivity'
write(100, *) gdp, 'gdp'
write(100, *) prod_half, 'prod_half'
write(100, *) pop_health, 'pop_health'
write(100, *) pop_health_emp, 'pop_health_emp'
write(100, *) pop_health_unins, 'pop_health_unins'
write(100, *) av_wage, 'av_wage'
write(100, *) wage_hi, 'wage_hi'
write(100, *) wage_nhi, 'wage_nhi'
write(100, *) medical_exp, 'medical_exp'
CLOSE (100) 

OPEN(100, file="welfare.txt") 
write(100, *) social_welfare
CLOSE (100)
 
OPEN(100, file="budget.txt")
write(100, *) g_bb/worker_size1
CLOSE (100)

END IF

!print*, social_welfare, g_bb



end subroutine