
clear matrix
clear 
set more off
set memory 1G

use C:\DATA_HEALTH\KAISER\data\health_benefits_04.dta, clear 

* sample selection
* keep if private sector
drop if industry==9

gen year=2004
 

gen insure=0 if a6==2
replace insure=1 if a6==1


rename totalemp firm_size

rename  pctlowin income_20
* the percentage of workers less than 20000 annually
* rename  pcthighin income_50
* the percentage of workers more than 50000 annually

rename  singest ind_est

count
sum insure [aw=empwt]
sum firm_size [aw=empwt]
bys insure: sum firm_size [aw=empwt]
bys insure: sum ind_est [aw=empwt]

keep id insure firm_size ind_est income_20 empwt year

save C:\DATA_HEALTH\KAISER\data\2004_JMP.dta, replace

clear

use C:\DATA_HEALTH\KAISER\data\health_benefits_05.dta, clear 

* sample selection
* keep if private sector
drop if industry==9

gen year=2005
 

gen insure=0 if a6==2
replace insure=1 if a6==1


rename totalemp firm_size

rename  pctlowin income_20
* the percentage of workers less than 20000 annually
* rename  pcthighin income_50
* the percentage of workers more than 50000 annually

rename  singest ind_est

count
sum insure [aw=empwt]
sum firm_size [aw=empwt]
bys insure: sum firm_size [aw=empwt]
bys insure: sum ind_est [aw=empwt]

keep id insure firm_size ind_est income_20 empwt year

save C:\DATA_HEALTH\KAISER\data\2005_JMP.dta, replace

clear

use C:\DATA_HEALTH\KAISER\data\health_benefits_06.dta, clear 

* sample selection
* keep if private sector
drop if industry==9

gen year=2006
 

gen insure=0 if a6==2
replace insure=1 if a6==1


rename totalemp firm_size

rename  pctlowin income_20
* the percentage of workers less than 20000 annually
* rename  pcthighin income_50
* the percentage of workers more than 50000 annually


rename  singest ind_est

count
sum insure [aw=empwt]
sum firm_size [aw=empwt]
bys insure: sum firm_size [aw=empwt]
bys insure: sum ind_est [aw=empwt]

keep id insure firm_size ind_est income_20 empwt year

save C:\DATA_HEALTH\KAISER\data\2006_JMP.dta, replace

clear

use C:\DATA_HEALTH\KAISER\data\health_benefits_07.dta, clear 

* sample selection
* keep if private sector
drop if industry==9

gen year=2007
 

gen insure=0 if a6==2
replace insure=1 if a6==1


rename totalemp firm_size

rename  pctlowin income_21
* the percentage of workers less than 21000 annually
rename  pcthihin income_50
* the percentage of workers more than 50000 annually

rename  pctage26  age_26

rename  singest ind_est

count
sum insure [aw=empwt]
sum firm_size [aw=empwt]
bys insure: sum firm_size [aw=empwt]
bys insure: sum ind_est [aw=empwt]

keep id insure firm_size ind_est income_21 empwt year income_50 age_26

save C:\DATA_HEALTH\KAISER\data\2007_JMP.dta, replace

clear

* merge data

use C:\DATA_HEALTH\KAISER\data\2004_JMP.dta, clear


append using C:\DATA_HEALTH\KAISER\data\2005_JMP.dta
append using C:\DATA_HEALTH\KAISER\data\2006_JMP.dta
append using C:\DATA_HEALTH\KAISER\data\2007_JMP.dta


save C:\DATA_HEALTH\KAISER\data\Aizawa_JMP.dta, replace


outsheet id insure firm_size age_26 ind_est income_20 income_50 empwt using "C:\DATA_HEALTH\KAISER\KAISER_all_04.csv", comma replace noname

gen size_50=1 if firm_size>=50
replace size_50=0 if firm_size<50

gen size_100=1 if firm_size>=100
replace size_100=0 if firm_size<100


**** SUMARRY STATISTICS IN THE DRAFT
drop if age_26>100 & age_26<.

sum insure [aw=empwt]
sum firm_size [aw=empwt]
bys insure: sum firm_size [aw=empwt]
* bys insure: sum age_50 [aw=empwt]
bys insure: sum age_26 [aw=empwt]
bys insure: sum ind_est [aw=empwt]
sum size_50 [aw=empwt]
bys size_50: sum insure [aw=empwt]
* bys size_50: sum age_50 [aw=empwt]
bys size_50: sum age_26 [aw=empwt]
* bys size_100: sum age_50 [aw=empwt]
bys size_100: sum age_26 [aw=empwt]
* bys insure: sum average_age [aw=empwt]



