
clear matrix
clear 
set more off
set memory 1G
** unit is normalized at 2007 inflation rate
use C:\DATA_HEALTH\MEPS\MEPS_SAS\2004.dta, clear 

* sample selection
* keep if age is between 23-54
drop if   AGE31X>=60 
drop if    AGE31X<25



* drop if self employed
drop if SELFCM31==1
* drop female
drop if sex==2
* not in school, public sector, military service, any welare program
* drop if in school
drop if FTSTU04X==1 | FTSTU04X==2
* drop if in militally service or public sector job
drop if INDCAT31==13 | INDCAT31==14 | INDCAT42==13 | INDCAT42==14 | INDCAT53==13 | INDCAT53==14  
* drop if in any welfare program
drop if AFDC04==1 | FOODST04==1
* drop if covered by other sources



drop if MCDJA04==1 | MCDFE04==1 | MCDMA04==1 | MCDAP04==1 | MCDMY04==1 | MCDJU04==1 | MCDJL04==1 | MCDAU04==1 | MCDSE04==1 | MCDOC04==1 | MCDNO04==1 | MCDDE04==1
drop if OPBJA04==1 | OPBFE04==1 | OPBMA04==1 | OPBAP04==1 | OPBMY04==1 | OPBJU04==1 | OPBJL04==1 | OPBAU04==1 | OPBSE04==1 | OPBOC04==1 | OPBNO04==1 | OPBDE04==1
drop if STAJA04==1 | STAFE04==1 | STAMA04==1 | STAAP04==1 | STAMY04==1 | STAJU04==1 | STAJL04==1 | STAAU04==1 | STASE04==1 | STAOC04==1 | STANO04==1 | STADE04==1
drop if PUBJA04==1 | PUBFE04==1 | PUBMA04==1 | PUBAP04==1 | PUBMY04==1 | PUBJU04==1 | PUBJL04==1 | PUBAU04==1 | PUBSE04==1 | PUBOC04==1 | PUBNO04==1 | PUBDE04==1
drop if PNGJA04==1 | PNGFE04==1 | PNGMA04==1 | PNGAP04==1 | PNGMY04==1 | PNGJU04==1 | PNGJL04==1 | PNGAU04==1 | PNGSE04==1 | PNGOC04==1 | PNGNO04==1 | PNGDE04==1
drop if PDKJA04==1 | PDKFE04==1 | PDKMA04==1 | PDKAP04==1 | PDKMY04==1 | PDKJU04==1 | PDKJL04==1 | PDKAU04==1 | PDKSE04==1 | PDKOC04==1 | PDKNO04==1 | PDKDE04==1
drop if POGJA04==1 | POGFE04==1 | POGMA04==1 | POGAP04==1 | POGMY04==1 | POGJU04==1 | POGJL04==1 | POGAU04==1 | POGSE04==1 | POGOC04==1 | POGNO04==1 | POGDE04==1
drop if PRSJA04==1 | PRSFE04==1 | PRSMA04==1 | PRSAP04==1 | PRSMY04==1 | PRSJU04==1 | PRSJL04==1 | PRSAU04==1 | PRSSE04==1 | PRSOC04==1 | PRSNO04==1 | PRSDE04==1 
drop if POUJA04==1 | POUFE04==1 | POUMA04==1 | POUAP04==1 | POUMY04==1 | POUJU04==1 | POUJL04==1 | POUAU04==1 | POUSE04==1 | POUOC04==1 | POUNO04==1 | POUDE04==1


* 1

gen ed=-09
replace ed=2 if educyear>=0 &  educyear<=12
replace ed=1 if educyear>12 &  educyear<.

keep if ed>=0


gen age2= AGE31X^2
rename  AGE31X age


gen health31=-09
gen health42=-09
gen health53=-09

replace health31=1 if RTHLTH31==1 | RTHLTH31==2 | RTHLTH31==3
replace health31=2 if RTHLTH31==4 | RTHLTH31==5 

replace health42=1 if RTHLTH42==1 | RTHLTH42==2 | RTHLTH42==3
replace health42=2 if RTHLTH42==4 | RTHLTH42==5 

replace health53=1 if RTHLTH53==1 | RTHLTH53==2 | RTHLTH53==3
replace health53=2 if RTHLTH53==4 | RTHLTH53==5 

gen health04=-09
replace health04=1 if health31==1 & health42==1 & health53==1
replace health04=2 if health31==2 & health42==2 & health53==2

gen hi04=-09

replace hi04=1 if HELD31X==1 & HELD42X==1 & HELD53X==1
replace hi04=0 if UNINS04==1

rename health04 health_annual 
rename hi04 hi_annual

gen hi_emp31=.
gen hi_emp42=.
gen hi_emp53=.
replace hi_emp31=1 if EMPST31==1 & HELD31X==1
replace hi_emp42=1 if EMPST42==1 & HELD42X==1
replace hi_emp53=1 if EMPST53==1 & HELD53X==1
replace hi_emp31=0 if EMPST31==1 & HELD31X==2
replace hi_emp42=0 if EMPST42==1 & HELD42X==2
replace hi_emp53=0 if EMPST53==1 & HELD53X==2

 



* adjust monetary value
replace TOTEXP04=TOTEXP04/0.88334
replace TOTEXP04=TOTEXP04/10000

rename TOTEXP04 medexp
rename  PERWT04F weight
keep pid HELD31X HELD42X HELD53X health31 health42 health53 medexp weight hi_annual health_annual hi_emp31 hi_emp42 hi_emp53 EMPST31 age ed HRWG31X HRWG42X HRWG53X


save C:\DATA_HEALTH\MEPS\MEPS_SAS\2004_data_1_jmp.dta, replace

clear


use C:\DATA_HEALTH\MEPS\MEPS_SAS\2005.dta, clear 

* sample selection
* keep if age is between 23-54
drop if   AGE31X>=60 
drop if    AGE31X<25



* drop if self employed
drop if SELFCM31==1
* drop female
drop if sex==2
* not in school, public sector, military service, any welare program
* drop if in school
drop if FTSTU05X==1 | FTSTU05X==2
* drop if in militally service or public sector job
drop if INDCAT31==13 | INDCAT31==14 | INDCAT42==13 | INDCAT42==14 | INDCAT53==13 | INDCAT53==14  
* drop if in any welfare program
drop if AFDC05==1 | FOODST05==1
* drop if covered by other sources



drop if MCDJA05==1 | MCDFE05==1 | MCDMA05==1 | MCDAP05==1 | MCDMY05==1 | MCDJU05==1 | MCDJL05==1 | MCDAU05==1 | MCDSE05==1 | MCDOC05==1 | MCDNO05==1 | MCDDE05==1
drop if OPBJA05==1 | OPBFE05==1 | OPBMA05==1 | OPBAP05==1 | OPBMY05==1 | OPBJU05==1 | OPBJL05==1 | OPBAU05==1 | OPBSE05==1 | OPBOC05==1 | OPBNO05==1 | OPBDE05==1
drop if STAJA05==1 | STAFE05==1 | STAMA05==1 | STAAP05==1 | STAMY05==1 | STAJU05==1 | STAJL05==1 | STAAU05==1 | STASE05==1 | STAOC05==1 | STANO05==1 | STADE05==1
drop if PUBJA05==1 | PUBFE05==1 | PUBMA05==1 | PUBAP05==1 | PUBMY05==1 | PUBJU05==1 | PUBJL05==1 | PUBAU05==1 | PUBSE05==1 | PUBOC05==1 | PUBNO05==1 | PUBDE05==1
drop if PNGJA05==1 | PNGFE05==1 | PNGMA05==1 | PNGAP05==1 | PNGMY05==1 | PNGJU05==1 | PNGJL05==1 | PNGAU05==1 | PNGSE05==1 | PNGOC05==1 | PNGNO05==1 | PNGDE05==1
drop if PDKJA05==1 | PDKFE05==1 | PDKMA05==1 | PDKAP05==1 | PDKMY05==1 | PDKJU05==1 | PDKJL05==1 | PDKAU05==1 | PDKSE05==1 | PDKOC05==1 | PDKNO05==1 | PDKDE05==1
drop if POGJA05==1 | POGFE05==1 | POGMA05==1 | POGAP05==1 | POGMY05==1 | POGJU05==1 | POGJL05==1 | POGAU05==1 | POGSE05==1 | POGOC05==1 | POGNO05==1 | POGDE05==1
drop if PRSJA05==1 | PRSFE05==1 | PRSMA05==1 | PRSAP05==1 | PRSMY05==1 | PRSJU05==1 | PRSJL05==1 | PRSAU05==1 | PRSSE05==1 | PRSOC05==1 | PRSNO05==1 | PRSDE05==1 
drop if POUJA05==1 | POUFE05==1 | POUMA05==1 | POUAP05==1 | POUMY05==1 | POUJU05==1 | POUJL05==1 | POUAU05==1 | POUSE05==1 | POUOC05==1 | POUNO05==1 | POUDE05==1


* 1

gen ed=-09
replace ed=2 if educyr>=0 & educyr<=12
replace ed=1 if educyr>12 & educyr<.

keep if ed>=0


gen age2= AGE31X^2
rename  AGE31X age


gen health31=-09
gen health42=-09
gen health53=-09

replace health31=1 if RTHLTH31==1 | RTHLTH31==2 | RTHLTH31==3
replace health31=2 if RTHLTH31==4 | RTHLTH31==5 

replace health42=1 if RTHLTH42==1 | RTHLTH42==2 | RTHLTH42==3
replace health42=2 if RTHLTH42==4 | RTHLTH42==5 

replace health53=1 if RTHLTH53==1 | RTHLTH53==2 | RTHLTH53==3
replace health53=2 if RTHLTH53==4 | RTHLTH53==5 

gen health05=-09
replace health05=1 if health31==1 & health42==1 & health53==1
replace health05=2 if health31==2 & health42==2 & health53==2

gen hi05=-09

replace hi05=1 if HELD31X==1 & HELD42X==1 & HELD53X==1
replace hi05=0 if UNINS05==1

rename health05 health_annual 
rename hi05 hi_annual

gen hi_emp31=.
gen hi_emp42=.
gen hi_emp53=.
replace hi_emp31=1 if EMPST31==1 & HELD31X==1
replace hi_emp42=1 if EMPST42==1 & HELD42X==1
replace hi_emp53=1 if EMPST53==1 & HELD53X==1
replace hi_emp31=0 if EMPST31==1 & HELD31X==2
replace hi_emp42=0 if EMPST42==1 & HELD42X==2
replace hi_emp53=0 if EMPST53==1 & HELD53X==2

 



* adjust monetary value
replace TOTEXP05=TOTEXP05/0.92066
replace TOTEXP05=TOTEXP05/10000

rename TOTEXP05 medexp
rename  PERWT05F weight
keep pid HELD31X HELD42X HELD53X health31 health42 health53 medexp weight hi_annual health_annual hi_emp31 hi_emp42 hi_emp53 EMPST31 age ed  HRWG31X HRWG42X HRWG53X


save C:\DATA_HEALTH\MEPS\MEPS_SAS\2005_data_1_jmp.dta, replace

clear

use C:\DATA_HEALTH\MEPS\MEPS_SAS\2006.dta, clear 

* sample selection
* keep if age is between 23-54
drop if   AGE31X>=60 
drop if    AGE31X<25



* drop if self employed
drop if SELFCM31==1
* drop female
drop if sex==2
* not in school, public sector, military service, any welare program
* drop if in school
drop if FTSTU06X==1 | FTSTU06X==2
* drop if in militally service or public sector job
drop if INDCAT31==13 | INDCAT31==14 | INDCAT42==13 | INDCAT42==14 | INDCAT53==13 | INDCAT53==14  
* drop if in any welfare program
drop if AFDC06==1 | FOODST06==1
* drop if covered by other sources



drop if MCDJA06==1 | MCDFE06==1 | MCDMA06==1 | MCDAP06==1 | MCDMY06==1 | MCDJU06==1 | MCDJL06==1 | MCDAU06==1 | MCDSE06==1 | MCDOC06==1 | MCDNO06==1 | MCDDE06==1
drop if OPBJA06==1 | OPBFE06==1 | OPBMA06==1 | OPBAP06==1 | OPBMY06==1 | OPBJU06==1 | OPBJL06==1 | OPBAU06==1 | OPBSE06==1 | OPBOC06==1 | OPBNO06==1 | OPBDE06==1
drop if STAJA06==1 | STAFE06==1 | STAMA06==1 | STAAP06==1 | STAMY06==1 | STAJU06==1 | STAJL06==1 | STAAU06==1 | STASE06==1 | STAOC06==1 | STANO06==1 | STADE06==1
drop if PUBJA06==1 | PUBFE06==1 | PUBMA06==1 | PUBAP06==1 | PUBMY06==1 | PUBJU06==1 | PUBJL06==1 | PUBAU06==1 | PUBSE06==1 | PUBOC06==1 | PUBNO06==1 | PUBDE06==1
drop if PNGJA06==1 | PNGFE06==1 | PNGMA06==1 | PNGAP06==1 | PNGMY06==1 | PNGJU06==1 | PNGJL06==1 | PNGAU06==1 | PNGSE06==1 | PNGOC06==1 | PNGNO06==1 | PNGDE06==1
drop if PDKJA06==1 | PDKFE06==1 | PDKMA06==1 | PDKAP06==1 | PDKMY06==1 | PDKJU06==1 | PDKJL06==1 | PDKAU06==1 | PDKSE06==1 | PDKOC06==1 | PDKNO06==1 | PDKDE06==1
drop if POGJA06==1 | POGFE06==1 | POGMA06==1 | POGAP06==1 | POGMY06==1 | POGJU06==1 | POGJL06==1 | POGAU06==1 | POGSE06==1 | POGOC06==1 | POGNO06==1 | POGDE06==1
drop if PRSJA06==1 | PRSFE06==1 | PRSMA06==1 | PRSAP06==1 | PRSMY06==1 | PRSJU06==1 | PRSJL06==1 | PRSAU06==1 | PRSSE06==1 | PRSOC06==1 | PRSNO06==1 | PRSDE06==1 
drop if POUJA06==1 | POUFE06==1 | POUMA06==1 | POUAP06==1 | POUMY06==1 | POUJU06==1 | POUJL06==1 | POUAU06==1 | POUSE06==1 | POUOC06==1 | POUNO06==1 | POUDE06==1


* 1

gen ed=-09
replace ed=2 if educyr>=0 & educyr<=12
replace ed=1 if educyr>12 & educyr<.

keep if ed>=0


gen age2= AGE31X^2
rename  AGE31X age


gen health31=-09
gen health42=-09
gen health53=-09

replace health31=1 if RTHLTH31==1 | RTHLTH31==2 | RTHLTH31==3
replace health31=2 if RTHLTH31==4 | RTHLTH31==5 

replace health42=1 if RTHLTH42==1 | RTHLTH42==2 | RTHLTH42==3
replace health42=2 if RTHLTH42==4 | RTHLTH42==5 

replace health53=1 if RTHLTH53==1 | RTHLTH53==2 | RTHLTH53==3
replace health53=2 if RTHLTH53==4 | RTHLTH53==5 

gen health06=-09
replace health06=1 if health31==1 & health42==1 & health53==1
replace health06=2 if health31==2 & health42==2 & health53==2

gen hi06=-09

replace hi06=1 if HELD31X==1 & HELD42X==1 & HELD53X==1
replace hi06=0 if UNINS06==1

rename health06 health_annual 
rename hi06 hi_annual

gen hi_emp31=.
gen hi_emp42=.
gen hi_emp53=.
replace hi_emp31=1 if EMPST31==1 & HELD31X==1
replace hi_emp42=1 if EMPST42==1 & HELD42X==1
replace hi_emp53=1 if EMPST53==1 & HELD53X==1
replace hi_emp31=0 if EMPST31==1 & HELD31X==2
replace hi_emp42=0 if EMPST42==1 & HELD42X==2
replace hi_emp53=0 if EMPST53==1 & HELD53X==2

 



* adjust monetary value
replace TOTEXP06=TOTEXP06/0.95769
replace TOTEXP06=TOTEXP06/10000

rename TOTEXP06 medexp
rename  PERWT06F weight
keep pid HELD31X HELD42X HELD53X health31 health42 health53 medexp weight hi_annual health_annual hi_emp31 hi_emp42 hi_emp53 EMPST31 age ed  HRWG31X HRWG42X HRWG53X


save C:\DATA_HEALTH\MEPS\MEPS_SAS\2006_data_1_jmp.dta, replace

clear

use C:\DATA_HEALTH\MEPS\MEPS_SAS\2007.dta, clear 

* sample selection
* keep if age is between 23-54
drop if   AGE31X>=60 
drop if    AGE31X<25



* drop if self employed
drop if SELFCM31==1
* drop female
drop if sex==2
* not in school, public sector, military service, any welare program
* drop if in school
drop if FTSTU07X==1 | FTSTU07X==2
* drop if in militally service or public sector job
drop if INDCAT31==13 | INDCAT31==14 | INDCAT42==13 | INDCAT42==14 | INDCAT53==13 | INDCAT53==14  
* drop if in any welfare program
drop if AFDC07==1 | FOODST07==1
* drop if covered by other sources



drop if MCDJA07==1 | MCDFE07==1 | MCDMA07==1 | MCDAP07==1 | MCDMY07==1 | MCDJU07==1 | MCDJL07==1 | MCDAU07==1 | MCDSE07==1 | MCDOC07==1 | MCDNO07==1 | MCDDE07==1
drop if OPBJA07==1 | OPBFE07==1 | OPBMA07==1 | OPBAP07==1 | OPBMY07==1 | OPBJU07==1 | OPBJL07==1 | OPBAU07==1 | OPBSE07==1 | OPBOC07==1 | OPBNO07==1 | OPBDE07==1
drop if STAJA07==1 | STAFE07==1 | STAMA07==1 | STAAP07==1 | STAMY07==1 | STAJU07==1 | STAJL07==1 | STAAU07==1 | STASE07==1 | STAOC07==1 | STANO07==1 | STADE07==1
drop if PUBJA07==1 | PUBFE07==1 | PUBMA07==1 | PUBAP07==1 | PUBMY07==1 | PUBJU07==1 | PUBJL07==1 | PUBAU07==1 | PUBSE07==1 | PUBOC07==1 | PUBNO07==1 | PUBDE07==1
drop if PNGJA07==1 | PNGFE07==1 | PNGMA07==1 | PNGAP07==1 | PNGMY07==1 | PNGJU07==1 | PNGJL07==1 | PNGAU07==1 | PNGSE07==1 | PNGOC07==1 | PNGNO07==1 | PNGDE07==1
drop if PDKJA07==1 | PDKFE07==1 | PDKMA07==1 | PDKAP07==1 | PDKMY07==1 | PDKJU07==1 | PDKJL07==1 | PDKAU07==1 | PDKSE07==1 | PDKOC07==1 | PDKNO07==1 | PDKDE07==1
drop if POGJA07==1 | POGFE07==1 | POGMA07==1 | POGAP07==1 | POGMY07==1 | POGJU07==1 | POGJL07==1 | POGAU07==1 | POGSE07==1 | POGOC07==1 | POGNO07==1 | POGDE07==1
drop if PRSJA07==1 | PRSFE07==1 | PRSMA07==1 | PRSAP07==1 | PRSMY07==1 | PRSJU07==1 | PRSJL07==1 | PRSAU07==1 | PRSSE07==1 | PRSOC07==1 | PRSNO07==1 | PRSDE07==1 
drop if POUJA07==1 | POUFE07==1 | POUMA07==1 | POUAP07==1 | POUMY07==1 | POUJU07==1 | POUJL07==1 | POUAU07==1 | POUSE07==1 | POUOC07==1 | POUNO07==1 | POUDE07==1


* 1

gen ed=-09
replace ed=2 if educyr>=0 & educyr<=12
replace ed=1 if educyr>12 & educyr<.

keep if ed>=0


gen age2= AGE31X^2
rename  AGE31X age


gen health31=-09
gen health42=-09
gen health53=-09

replace health31=1 if RTHLTH31==1 | RTHLTH31==2 | RTHLTH31==3
replace health31=2 if RTHLTH31==4 | RTHLTH31==5 

replace health42=1 if RTHLTH42==1 | RTHLTH42==2 | RTHLTH42==3
replace health42=2 if RTHLTH42==4 | RTHLTH42==5 

replace health53=1 if RTHLTH53==1 | RTHLTH53==2 | RTHLTH53==3
replace health53=2 if RTHLTH53==4 | RTHLTH53==5 

gen health07=-09
replace health07=1 if health31==1 & health42==1 & health53==1
replace health07=2 if health31==2 & health42==2 & health53==2

gen hi07=-09

replace hi07=1 if HELD31X==1 & HELD42X==1 & HELD53X==1
replace hi07=0 if UNINS07==1

rename health07 health_annual 
rename hi07 hi_annual

gen hi_emp31=.
gen hi_emp42=.
gen hi_emp53=.
replace hi_emp31=1 if EMPST31==1 & HELD31X==1
replace hi_emp42=1 if EMPST42==1 & HELD42X==1
replace hi_emp53=1 if EMPST53==1 & HELD53X==1
replace hi_emp31=0 if EMPST31==1 & HELD31X==2
replace hi_emp42=0 if EMPST42==1 & HELD42X==2
replace hi_emp53=0 if EMPST53==1 & HELD53X==2

 



* adjust monetary value
replace TOTEXP07=TOTEXP07/1.0
replace TOTEXP07=TOTEXP07/10000

rename TOTEXP07 medexp
rename  PERWT07F weight
keep pid HELD31X HELD42X HELD53X health31 health42 health53 medexp weight hi_annual health_annual hi_emp31 hi_emp42 hi_emp53 EMPST31 age ed  HRWG31X HRWG42X HRWG53X


save C:\DATA_HEALTH\MEPS\MEPS_SAS\2007_data_1_jmp.dta, replace

use C:\DATA_HEALTH\MEPS\MEPS_SAS\2004_data_1_jmp.dta, replace
append using C:\DATA_HEALTH\MEPS\MEPS_SAS\2005_data_1_jmp.dta
append using C:\DATA_HEALTH\MEPS\MEPS_SAS\2006_data_1_jmp.dta
append using C:\DATA_HEALTH\MEPS\MEPS_SAS\2007_data_1_jmp.dta


save C:\DATA_HEALTH\MEPS\MEPS_SAS\Aizawa_JMP_MEPS04.dta, replace

gen emp=1 if EMPST==1
replace emp=0 if EMPST31==4

outsheet medexp health_annual hi_annual hi_emp31 health31 emp age ed using "C:\DATA_HEALTH\AIZAWA_JMP\MEPS_all_04.csv", comma replace noname

replace health31=0 if health31==2
replace health42=0 if health42==2
replace health53=0 if health53==2

sum health31 if health31>=0 [aw=weight]
sum health42 if health42>=0 [aw=weight]
sum health53 if health53>=0 [aw=weight]

sum medexp if medexp>=0 [aw=weight]
bys health_annual hi_annual: sum medexp if medexp>=0 [aw=weight]
sum hi_emp31 if hi_emp31>=0 [aw=weight]
sum hi_emp42 if hi_emp42>=0 [aw=weight]
sum hi_emp53 if hi_emp53>=0 [aw=weight]

gen age_c=1 if age>=25 & age<=31
replace age_c=2 if age>=32 & age<=38
replace age_c=3 if age>=39 & age<=45
replace age_c=4 if age>=46 & age<=52
replace age_c=5 if age>=53 & age<=59

bys age_c health_annual: sum medexp, missing if age_c<. & health_annual<.

sum age [aw=weight]
gen college=1 if ed==1
replace college=0 if ed==2
sum college [aw=weight]

gen age_g=1 if age>=25 & age<=35
replace age_g=2 if age>=36 & age<=45
replace age_g=3 if age>=46 & age<=55

bys hi_emp31 health31 age_g: sum medexp  
bys hi_annual health_annual age_g: sum medexp  







