clear
set mem 4g

* This file ise used to merge core modules with topical modules. 

use "C:\SIPP\2004\sipp04w1.dta", clear

gen ins_reason=1 if ehirsn01==1
replace ins_reason=2 if ehirsn02==1
replace ins_reason=3 if ehirsn03==1
replace ins_reason=4 if ehirsn04==1
replace ins_reason=5 if ehirsn05==1
replace ins_reason=6 if ehirsn06==1
replace ins_reason=8 if ehirsn08==1


keep esex tage whfnwgt wpfinwgt rcutyp58 ehemply ehiowner tpmsum1 epayhr1 rprvhi  ssuseq  ssuid  swave  spanel   srotaton  srefmon  rhcalmn  tfipsst epppnum  erace ems eeducate ejbhrs1 rmesr rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5 rcutyp57 eeno1 efnp ebuscntr eclwrk1 eenrlm eafnow ehimth ins_reason ehimth er25 epatanf5 er27 tempall1 ecrmth essself 
 


rename ehimth ehi_month
rename eafnow army_status
rename eenrlm education_eonrollment
rename esex sex
rename tage age
rename whfnwgt weight_h
rename wpfinwgt weight_p
rename  rcutyp58 hi_unins
rename  rcutyp57 medicaid
rename ehemply hi_type
rename ehiowner hi_owner
rename  tpmsum1 wage_month
rename epayhr1 paid_hour_dummy
rename rprvhi hi_private
rename  tfipsst  state
rename  erace race
rename ems m_status
rename eeducate ed_status
rename  ejbhrs1 work_hour
rename rmesr emp_status
rename rwkesr1 emp_w1
rename rwkesr2 emp_w2
rename rwkesr3 emp_w3
rename rwkesr4 emp_w4
rename rwkesr5 emp_w5
rename eeno1 job_id
rename efnp family_size
rename tempall1 firm_size

gen self_dummy=.
replace self_dummy=1 if ebuscntr>=0 

gen gov_dummy=.
replace gov_dummy=1 if eclwrk1==3|eclwrk1==4|eclwrk1==5

gen emp_status_dummy=1 if emp_status>=1 & emp_status<=5
replace emp_status_dummy=0 if emp_status> 5

bys ssuid  epppnum: egen emp_4_status=sum(emp_status_dummy)


gen hi_status=.
replace hi_status=0 if  hi_unins==2 
replace hi_status=1 if hi_private==1 & (hi_owner==1| hi_owner==3)
replace hi_status=2 if hi_private==2 & (hi_owner==1| hi_owner==3)
replace hi_status=3 if medicaid==1

* note: statistics almost similar even if hi_unins is replaced by ehi_month

gen year=2004



save "C:\SIPP\2004\adjusted_data_file\sippl04puw1.dta", replace

clear

use "C:\SIPP\2004\sipp04w2.dta", clear

gen ins_reason=1 if ehirsn01==1
replace ins_reason=2 if ehirsn02==1
replace ins_reason=3 if ehirsn03==1
replace ins_reason=4 if ehirsn04==1
replace ins_reason=5 if ehirsn05==1
replace ins_reason=6 if ehirsn06==1
replace ins_reason=8 if ehirsn08==1


keep esex tage whfnwgt wpfinwgt rcutyp58 ehemply ehiowner tpmsum1 epayhr1 rprvhi  ssuseq  ssuid  swave  spanel   srotaton  srefmon  rhcalmn  tfipsst epppnum  erace ems eeducate ejbhrs1 rmesr rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5 rcutyp57 eeno1 efnp ebuscntr eclwrk1 eenrlm eafnow ehimth ins_reason ehimth er25 epatanf5 er27 tempall1 ecrmth essself 
 

rename ehimth ehi_month
rename eafnow army_status
rename eenrlm education_eonrollment
rename esex sex
rename tage age
rename whfnwgt weight_h
rename wpfinwgt weight_p
rename  rcutyp58 hi_unins
rename  rcutyp57 medicaid
rename ehemply hi_type
rename ehiowner hi_owner
rename  tpmsum1 wage_month
rename epayhr1 paid_hour_dummy
rename rprvhi hi_private
rename  tfipsst  state
rename  erace race
rename ems m_status
rename eeducate ed_status
rename  ejbhrs1 work_hour
rename rmesr emp_status
rename rwkesr1 emp_w1
rename rwkesr2 emp_w2
rename rwkesr3 emp_w3
rename rwkesr4 emp_w4
rename rwkesr5 emp_w5
rename eeno1 job_id
rename efnp family_size
rename tempall1 firm_size

gen self_dummy=.
replace self_dummy=1 if ebuscntr>=0 

gen gov_dummy=.
replace gov_dummy=1 if eclwrk1==3|eclwrk1==4|eclwrk1==5

gen emp_status_dummy=1 if emp_status>=1 & emp_status<=5
replace emp_status_dummy=0 if emp_status> 5

bys ssuid  epppnum: egen emp_4_status=sum(emp_status_dummy)

* generate yearly employment spell information

gen hi_status=.
replace hi_status=0 if hi_unins==2 
replace hi_status=1 if hi_private==1 & (hi_owner==1| hi_owner==3)
replace hi_status=2 if hi_private==2 & (hi_owner==1| hi_owner==3)
replace hi_status=3 if medicaid==1


gen year=2004


save "C:\SIPP\2004\adjusted_data_file\sippl04puw2.dta", replace

clear

use "C:\SIPP\2004\sipp04w3.dta", clear

gen ins_reason=1 if ehirsn01==1
replace ins_reason=2 if ehirsn02==1
replace ins_reason=3 if ehirsn03==1
replace ins_reason=4 if ehirsn04==1
replace ins_reason=5 if ehirsn05==1
replace ins_reason=6 if ehirsn06==1
replace ins_reason=8 if ehirsn08==1


keep esex tage whfnwgt wpfinwgt rcutyp58 ehemply ehiowner tpmsum1 epayhr1 rprvhi  ssuseq  ssuid  swave  spanel   srotaton  srefmon  rhcalmn  tfipsst epppnum  erace ems eeducate ejbhrs1 rmesr rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5 rcutyp57 eeno1 efnp ebuscntr eclwrk1 eenrlm eafnow ehimth ins_reason ehimth er25 epatanf5 er27 tempall1 ecrmth essself 

rename ehimth ehi_month
rename eafnow army_status
rename eenrlm education_eonrollment
rename esex sex
rename tage age
rename whfnwgt weight_h
rename wpfinwgt weight_p
rename  rcutyp58 hi_unins
rename  rcutyp57 medicaid
rename ehemply hi_type
rename ehiowner hi_owner
rename  tpmsum1 wage_month
rename epayhr1 paid_hour_dummy
rename rprvhi hi_private
rename  tfipsst  state
rename  erace race
rename ems m_status
rename eeducate ed_status
rename  ejbhrs1 work_hour
rename rmesr emp_status
rename rwkesr1 emp_w1
rename rwkesr2 emp_w2
rename rwkesr3 emp_w3
rename rwkesr4 emp_w4
rename rwkesr5 emp_w5
rename eeno1 job_id
rename efnp family_size
rename tempall1 firm_size

gen self_dummy=.
replace self_dummy=1 if ebuscntr>=0 

gen gov_dummy=.
replace gov_dummy=1 if eclwrk1==3|eclwrk1==4|eclwrk1==5

gen emp_status_dummy=1 if emp_status>=1 & emp_status<=5
replace emp_status_dummy=0 if emp_status> 5

bys ssuid  epppnum: egen emp_4_status=sum(emp_status_dummy)

gen hi_status=.
replace hi_status=0 if hi_unins==2 
replace hi_status=1 if hi_private==1 & (hi_owner==1| hi_owner==3)
replace hi_status=2 if hi_private==2 & (hi_owner==1| hi_owner==3)
replace hi_status=3 if medicaid==1

gen year=2004

save "C:\SIPP\2004\adjusted_data_file\sippl04puw3.dta", replace

clear

use "C:\SIPP\2004\sipp04w4.dta", clear

* drop if working as army
drop if eafnow==1

gen ins_reason=1 if ehirsn01==1
replace ins_reason=2 if ehirsn02==1
replace ins_reason=3 if ehirsn03==1
replace ins_reason=4 if ehirsn04==1
replace ins_reason=5 if ehirsn05==1
replace ins_reason=6 if ehirsn06==1
replace ins_reason=8 if ehirsn08==1


keep esex tage whfnwgt wpfinwgt rcutyp58 ehemply ehiowner tpmsum1 epayhr1 rprvhi  ssuseq  ssuid  swave  spanel   srotaton  srefmon  rhcalmn  tfipsst epppnum  erace ems eeducate ejbhrs1 rmesr rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5 rcutyp57 eeno1 efnp ebuscntr eclwrk1 eenrlm eafnow ehimth ins_reason ehimth er25 epatanf5 er27 tempall1 ecrmth essself 

rename ehimth ehi_month
rename eafnow army_status
rename eenrlm education_eonrollment
rename esex sex
rename tage age
rename whfnwgt weight_h
rename wpfinwgt weight_p
rename  rcutyp58 hi_unins
rename  rcutyp57 medicaid
rename ehemply hi_type
rename ehiowner hi_owner
rename  tpmsum1 wage_month
rename epayhr1 paid_hour_dummy
rename rprvhi hi_private
rename  tfipsst  state
rename  erace race
rename ems m_status
rename eeducate ed_status
rename  ejbhrs1 work_hour
rename rmesr emp_status
rename rwkesr1 emp_w1
rename rwkesr2 emp_w2
rename rwkesr3 emp_w3
rename rwkesr4 emp_w4
rename rwkesr5 emp_w5
rename eeno1 job_id
rename efnp family_size
rename tempall1 firm_size

gen self_dummy=.
replace self_dummy=1 if ebuscntr>=0 

gen gov_dummy=.
replace gov_dummy=1 if eclwrk1==3|eclwrk1==4|eclwrk1==5

gen emp_status_dummy=1 if emp_status>=1 & emp_status<=5
replace emp_status_dummy=0 if emp_status> 5

bys ssuid  epppnum: egen emp_4_status=sum(emp_status_dummy)

gen hi_status=.
replace hi_status=0 if hi_unins==2 
replace hi_status=1 if hi_private==1 & (hi_owner==1| hi_owner==3)
replace hi_status=2 if hi_private==2 & (hi_owner==1| hi_owner==3)
replace hi_status=3 if medicaid==1

gen year=2005

save "C:\SIPP\2004\adjusted_data_file\sippl04puw4.dta", replace

clear

use "C:\SIPP\2004\sipp04w5.dta", clear

gen ins_reason=1 if ehirsn01==1
replace ins_reason=2 if ehirsn02==1
replace ins_reason=3 if ehirsn03==1
replace ins_reason=4 if ehirsn04==1
replace ins_reason=5 if ehirsn05==1
replace ins_reason=6 if ehirsn06==1
replace ins_reason=8 if ehirsn08==1

keep esex tage whfnwgt wpfinwgt rcutyp58 ehemply ehiowner tpmsum1 epayhr1 rprvhi  ssuseq  ssuid  swave  spanel   srotaton  srefmon  rhcalmn  tfipsst epppnum  erace ems eeducate ejbhrs1 rmesr rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5 rcutyp57 eeno1 efnp ebuscntr eclwrk1 eenrlm eafnow ehimth ins_reason ehimth er25 epatanf5 er27 tempall1 ecrmth essself 

rename ehimth ehi_month
rename eafnow army_status
rename eenrlm education_eonrollment
rename esex sex
rename tage age
rename whfnwgt weight_h
rename wpfinwgt weight_p
rename  rcutyp58 hi_unins
rename  rcutyp57 medicaid
rename ehemply hi_type
rename ehiowner hi_owner
rename  tpmsum1 wage_month
rename epayhr1 paid_hour_dummy
rename rprvhi hi_private
rename  tfipsst  state
rename  erace race
rename ems m_status
rename eeducate ed_status
rename  ejbhrs1 work_hour
rename rmesr emp_status
rename rwkesr1 emp_w1
rename rwkesr2 emp_w2
rename rwkesr3 emp_w3
rename rwkesr4 emp_w4
rename rwkesr5 emp_w5
rename eeno1 job_id
rename efnp family_size
rename tempall1 firm_size

gen self_dummy=.
replace self_dummy=1 if ebuscntr>=0 

gen gov_dummy=.
replace gov_dummy=1 if eclwrk1==3|eclwrk1==4|eclwrk1==5

gen emp_status_dummy=1 if emp_status>=1 & emp_status<=5
replace emp_status_dummy=0 if emp_status> 5

bys ssuid  epppnum: egen emp_4_status=sum(emp_status_dummy)


gen hi_status=.
replace hi_status=0 if hi_unins==2 
replace hi_status=1 if hi_private==1 & (hi_owner==1| hi_owner==3)
replace hi_status=2 if hi_private==2 & (hi_owner==1| hi_owner==3)
replace hi_status=3 if medicaid==1

gen year=2005


save "C:\SIPP\2004\adjusted_data_file\sippl04puw5.dta", replace


clear

use "C:\SIPP\2004\sipp04w6.dta", clear

* drop if working as army
drop if eafnow==1

gen ins_reason=1 if ehirsn01==1
replace ins_reason=2 if ehirsn02==1
replace ins_reason=3 if ehirsn03==1
replace ins_reason=4 if ehirsn04==1
replace ins_reason=5 if ehirsn05==1
replace ins_reason=6 if ehirsn06==1
replace ins_reason=8 if ehirsn08==1


keep esex tage whfnwgt wpfinwgt rcutyp58 ehemply ehiowner tpmsum1 epayhr1 rprvhi  ssuseq  ssuid  swave  spanel   srotaton  srefmon  rhcalmn  tfipsst epppnum  erace ems eeducate ejbhrs1 rmesr rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5 rcutyp57 eeno1 efnp ebuscntr eclwrk1 eenrlm eafnow ehimth ins_reason ehimth er25 epatanf5 er27 tempall1 ecrmth essself 

rename ehimth ehi_month
rename eafnow army_status
rename eenrlm education_eonrollment
rename esex sex
rename tage age
rename whfnwgt weight_h
rename wpfinwgt weight_p
rename  rcutyp58 hi_unins
rename  rcutyp57 medicaid
rename ehemply hi_type
rename ehiowner hi_owner
rename  tpmsum1 wage_month
rename epayhr1 paid_hour_dummy
rename rprvhi hi_private
rename  tfipsst  state
rename  erace race
rename ems m_status
rename eeducate ed_status
rename  ejbhrs1 work_hour
rename rmesr emp_status
rename rwkesr1 emp_w1
rename rwkesr2 emp_w2
rename rwkesr3 emp_w3
rename rwkesr4 emp_w4
rename rwkesr5 emp_w5
rename eeno1 job_id
rename efnp family_size
rename tempall1 firm_size

gen self_dummy=.
replace self_dummy=1 if ebuscntr>=0 

gen gov_dummy=.
replace gov_dummy=1 if eclwrk1==3|eclwrk1==4|eclwrk1==5

gen emp_status_dummy=1 if emp_status>=1 & emp_status<=5
replace emp_status_dummy=0 if emp_status> 5

bys ssuid  epppnum: egen emp_4_status=sum(emp_status_dummy)

gen hi_status=.
replace hi_status=0 if hi_unins==2 
replace hi_status=1 if hi_private==1 & (hi_owner==1| hi_owner==3)
replace hi_status=2 if hi_private==2 & (hi_owner==1| hi_owner==3)
replace hi_status=3 if medicaid==1


gen year=2005


save "C:\SIPP\2004\adjusted_data_file\sippl04puw6.dta", replace

clear

use "C:\SIPP\2004\sipp04w7.dta", clear

gen ins_reason=1 if ehirsn01==1
replace ins_reason=2 if ehirsn02==1
replace ins_reason=3 if ehirsn03==1
replace ins_reason=4 if ehirsn04==1
replace ins_reason=5 if ehirsn05==1
replace ins_reason=6 if ehirsn06==1
replace ins_reason=8 if ehirsn08==1


keep esex tage whfnwgt wpfinwgt rcutyp58 ehemply ehiowner tpmsum1 epayhr1 rprvhi  ssuseq  ssuid  swave  spanel   srotaton  srefmon  rhcalmn  tfipsst epppnum  erace ems eeducate ejbhrs1 rmesr rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5 rcutyp57 eeno1 efnp ebuscntr eclwrk1 eenrlm eafnow ehimth ins_reason ehimth er25 epatanf5 er27 tempall1 ecrmth essself 

rename ehimth ehi_month
rename eafnow army_status
rename eenrlm education_eonrollment
rename esex sex
rename tage age
rename whfnwgt weight_h
rename wpfinwgt weight_p
rename  rcutyp58 hi_unins
rename  rcutyp57 medicaid
rename ehemply hi_type
rename ehiowner hi_owner
rename  tpmsum1 wage_month
rename epayhr1 paid_hour_dummy
rename rprvhi hi_private
rename  tfipsst  state
rename  erace race
rename ems m_status
rename eeducate ed_status
rename  ejbhrs1 work_hour
rename rmesr emp_status
rename rwkesr1 emp_w1
rename rwkesr2 emp_w2
rename rwkesr3 emp_w3
rename rwkesr4 emp_w4
rename rwkesr5 emp_w5
rename eeno1 job_id
rename efnp family_size
rename tempall1 firm_size

gen self_dummy=.
replace self_dummy=1 if ebuscntr>=0 

gen gov_dummy=.
replace gov_dummy=1 if eclwrk1==3|eclwrk1==4|eclwrk1==5

gen emp_status_dummy=1 if emp_status>=1 & emp_status<=5
replace emp_status_dummy=0 if emp_status> 5

bys ssuid  epppnum: egen emp_4_status=sum(emp_status_dummy)

gen hi_status=.
replace hi_status=0 if hi_unins==2 
replace hi_status=1 if hi_private==1 & (hi_owner==1| hi_owner==3)
replace hi_status=2 if hi_private==2 & (hi_owner==1| hi_owner==3)
replace hi_status=3 if medicaid==1

gen year=2006

save "C:\SIPP\2004\adjusted_data_file\sippl04puw7.dta", replace


clear

use "C:\SIPP\2004\sipp04w8.dta", clear

* drop if working as army
drop if eafnow==1

gen ins_reason=1 if ehirsn01==1
replace ins_reason=2 if ehirsn02==1
replace ins_reason=3 if ehirsn03==1
replace ins_reason=4 if ehirsn04==1
replace ins_reason=5 if ehirsn05==1
replace ins_reason=6 if ehirsn06==1
replace ins_reason=8 if ehirsn08==1


keep esex tage whfnwgt wpfinwgt rcutyp58 ehemply ehiowner tpmsum1 epayhr1 rprvhi  ssuseq  ssuid  swave  spanel   srotaton  srefmon  rhcalmn  tfipsst epppnum  erace ems eeducate ejbhrs1 rmesr rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5 rcutyp57 eeno1 efnp ebuscntr eclwrk1 eenrlm eafnow ehimth ins_reason ehimth er25 epatanf5 er27 tempall1 ecrmth essself 

rename ehimth ehi_month
rename eafnow army_status
rename eenrlm education_eonrollment
rename esex sex
rename tage age
rename whfnwgt weight_h
rename wpfinwgt weight_p
rename  rcutyp58 hi_unins
rename  rcutyp57 medicaid
rename ehemply hi_type
rename ehiowner hi_owner
rename  tpmsum1 wage_month
rename epayhr1 paid_hour_dummy
rename rprvhi hi_private
rename  tfipsst  state
rename  erace race
rename ems m_status
rename eeducate ed_status
rename  ejbhrs1 work_hour
rename rmesr emp_status
rename rwkesr1 emp_w1
rename rwkesr2 emp_w2
rename rwkesr3 emp_w3
rename rwkesr4 emp_w4
rename rwkesr5 emp_w5
rename eeno1 job_id
rename efnp family_size
rename tempall1 firm_size

gen self_dummy=.
replace self_dummy=1 if ebuscntr>=0 

gen gov_dummy=.
replace gov_dummy=1 if eclwrk1==3|eclwrk1==4|eclwrk1==5

gen emp_status_dummy=1 if emp_status>=1 & emp_status<=5
replace emp_status_dummy=0 if emp_status> 5

bys ssuid  epppnum: egen emp_4_status=sum(emp_status_dummy)

gen hi_status=.
replace hi_status=0 if hi_unins==2 
replace hi_status=1 if hi_private==1 & (hi_owner==1| hi_owner==3)
replace hi_status=2 if hi_private==2 & (hi_owner==1| hi_owner==3)
replace hi_status=3 if medicaid==1

gen year=2006

save "C:\SIPP\2004\adjusted_data_file\sippl04puw8.dta", replace

clear

use "C:\SIPP\2004\sipp04w9.dta", clear

* drop if working as army
drop if eafnow==1

gen ins_reason=1 if ehirsn01==1
replace ins_reason=2 if ehirsn02==1
replace ins_reason=3 if ehirsn03==1
replace ins_reason=4 if ehirsn04==1
replace ins_reason=5 if ehirsn05==1
replace ins_reason=6 if ehirsn06==1
replace ins_reason=8 if ehirsn08==1


keep esex tage whfnwgt wpfinwgt rcutyp58 ehemply ehiowner tpmsum1 epayhr1 rprvhi  ssuseq  ssuid  swave  spanel   srotaton  srefmon  rhcalmn  tfipsst epppnum  erace ems eeducate ejbhrs1 rmesr rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5 rcutyp57 eeno1 efnp ebuscntr eclwrk1 eenrlm eafnow ehimth ins_reason ehimth er25 epatanf5 er27 tempall1 ecrmth essself 

rename ehimth ehi_month
rename eafnow army_status
rename eenrlm education_eonrollment
rename esex sex
rename tage age
rename whfnwgt weight_h
rename wpfinwgt weight_p
rename  rcutyp58 hi_unins
rename  rcutyp57 medicaid
rename ehemply hi_type
rename ehiowner hi_owner
rename  tpmsum1 wage_month
rename epayhr1 paid_hour_dummy
rename rprvhi hi_private
rename  tfipsst  state
rename  erace race
rename ems m_status
rename eeducate ed_status
rename  ejbhrs1 work_hour
rename rmesr emp_status
rename rwkesr1 emp_w1
rename rwkesr2 emp_w2
rename rwkesr3 emp_w3
rename rwkesr4 emp_w4
rename rwkesr5 emp_w5
rename eeno1 job_id
rename efnp family_size
rename tempall1 firm_size

gen self_dummy=.
replace self_dummy=1 if ebuscntr>=0 

gen gov_dummy=.
replace gov_dummy=1 if eclwrk1==3|eclwrk1==4|eclwrk1==5

gen emp_status_dummy=1 if emp_status>=1 & emp_status<=5
replace emp_status_dummy=0 if emp_status> 5

bys ssuid  epppnum: egen emp_4_status=sum(emp_status_dummy)

gen hi_status=.
replace hi_status=0 if hi_unins==2 
replace hi_status=1 if hi_private==1 & (hi_owner==1| hi_owner==3)
replace hi_status=2 if hi_private==2 & (hi_owner==1| hi_owner==3)
replace hi_status=3 if medicaid==1

gen year=2006

save "C:\SIPP\2004\adjusted_data_file\sippl04puw9.dta", replace

clear

use "C:\SIPP\2004\sipp04w10.dta", clear

* drop if working as army
drop if eafnow==1

gen ins_reason=1 if ehirsn01==1
replace ins_reason=2 if ehirsn02==1
replace ins_reason=3 if ehirsn03==1
replace ins_reason=4 if ehirsn04==1
replace ins_reason=5 if ehirsn05==1
replace ins_reason=6 if ehirsn06==1
replace ins_reason=8 if ehirsn08==1


keep esex tage whfnwgt wpfinwgt rcutyp58 ehemply ehiowner tpmsum1 epayhr1 rprvhi  ssuseq  ssuid  swave  spanel   srotaton  srefmon  rhcalmn  tfipsst epppnum  erace ems eeducate ejbhrs1 rmesr rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5 rcutyp57 eeno1 efnp ebuscntr eclwrk1 eenrlm eafnow ehimth ins_reason ehimth er25 epatanf5 er27 tempall1 ecrmth essself 

rename ehimth ehi_month
rename eafnow army_status
rename eenrlm education_eonrollment
rename esex sex
rename tage age
rename whfnwgt weight_h
rename wpfinwgt weight_p
rename  rcutyp58 hi_unins
rename  rcutyp57 medicaid
rename ehemply hi_type
rename ehiowner hi_owner
rename  tpmsum1 wage_month
rename epayhr1 paid_hour_dummy
rename rprvhi hi_private
rename  tfipsst  state
rename  erace race
rename ems m_status
rename eeducate ed_status
rename  ejbhrs1 work_hour
rename rmesr emp_status
rename rwkesr1 emp_w1
rename rwkesr2 emp_w2
rename rwkesr3 emp_w3
rename rwkesr4 emp_w4
rename rwkesr5 emp_w5
rename eeno1 job_id
rename efnp family_size
rename tempall1 firm_size

gen self_dummy=.
replace self_dummy=1 if ebuscntr>=0 

gen gov_dummy=.
replace gov_dummy=1 if eclwrk1==3|eclwrk1==4|eclwrk1==5

gen emp_status_dummy=1 if emp_status>=1 & emp_status<=5
replace emp_status_dummy=0 if emp_status> 5

bys ssuid  epppnum: egen emp_4_status=sum(emp_status_dummy)

gen hi_status=.
replace hi_status=0 if hi_unins==2 
replace hi_status=1 if hi_private==1 & (hi_owner==1| hi_owner==3)
replace hi_status=2 if hi_private==2 & (hi_owner==1| hi_owner==3)
replace hi_status=3 if medicaid==1

gen year=2007

save "C:\SIPP\2004\adjusted_data_file\sippl04puw10.dta", replace

clear


use "C:\SIPP\2004\sipp04w11.dta", clear

* drop if working as army
drop if eafnow==1

gen ins_reason=1 if ehirsn01==1
replace ins_reason=2 if ehirsn02==1
replace ins_reason=3 if ehirsn03==1
replace ins_reason=4 if ehirsn04==1
replace ins_reason=5 if ehirsn05==1
replace ins_reason=6 if ehirsn06==1
replace ins_reason=8 if ehirsn08==1


keep esex tage whfnwgt wpfinwgt rcutyp58 ehemply ehiowner tpmsum1 epayhr1 rprvhi  ssuseq  ssuid  swave  spanel   srotaton  srefmon  rhcalmn  tfipsst epppnum  erace ems eeducate ejbhrs1 rmesr rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5 rcutyp57 eeno1 efnp ebuscntr eclwrk1 eenrlm eafnow ehimth ins_reason ehimth er25 epatanf5 er27 tempall1 ecrmth essself 

rename ehimth ehi_month
rename eafnow army_status
rename eenrlm education_eonrollment
rename esex sex
rename tage age
rename whfnwgt weight_h
rename wpfinwgt weight_p
rename  rcutyp58 hi_unins
rename  rcutyp57 medicaid
rename ehemply hi_type
rename ehiowner hi_owner
rename  tpmsum1 wage_month
rename epayhr1 paid_hour_dummy
rename rprvhi hi_private
rename  tfipsst  state
rename  erace race
rename ems m_status
rename eeducate ed_status
rename  ejbhrs1 work_hour
rename rmesr emp_status
rename rwkesr1 emp_w1
rename rwkesr2 emp_w2
rename rwkesr3 emp_w3
rename rwkesr4 emp_w4
rename rwkesr5 emp_w5
rename eeno1 job_id
rename efnp family_size
rename tempall1 firm_size

gen self_dummy=.
replace self_dummy=1 if ebuscntr>=0 

gen gov_dummy=.
replace gov_dummy=1 if eclwrk1==3|eclwrk1==4|eclwrk1==5

gen emp_status_dummy=1 if emp_status>=1 & emp_status<=5
replace emp_status_dummy=0 if emp_status> 5

bys ssuid  epppnum: egen emp_4_status=sum(emp_status_dummy)

gen hi_status=.
replace hi_status=0 if hi_unins==2 
replace hi_status=1 if hi_private==1 & (hi_owner==1| hi_owner==3)
replace hi_status=2 if hi_private==2 & (hi_owner==1| hi_owner==3)
replace hi_status=3 if medicaid==1

gen year=2007

save "C:\SIPP\2004\adjusted_data_file\sippl04puw11.dta", replace

clear


use "C:\SIPP\2004\sipp04w12.dta", clear

* drop if working as army
drop if eafnow==1

gen ins_reason=1 if ehirsn01==1
replace ins_reason=2 if ehirsn02==1
replace ins_reason=3 if ehirsn03==1
replace ins_reason=4 if ehirsn04==1
replace ins_reason=5 if ehirsn05==1
replace ins_reason=6 if ehirsn06==1
replace ins_reason=8 if ehirsn08==1


keep esex tage whfnwgt wpfinwgt rcutyp58 ehemply ehiowner tpmsum1 epayhr1 rprvhi  ssuseq  ssuid  swave  spanel   srotaton  srefmon  rhcalmn  tfipsst epppnum  erace ems eeducate ejbhrs1 rmesr rwkesr1 rwkesr2 rwkesr3 rwkesr4 rwkesr5 rcutyp57 eeno1 efnp ebuscntr eclwrk1 eenrlm eafnow ehimth ins_reason ehimth er25 epatanf5 er27 tempall1 ecrmth essself 

rename ehimth ehi_month
rename eafnow army_status
rename eenrlm education_eonrollment
rename esex sex
rename tage age
rename whfnwgt weight_h
rename wpfinwgt weight_p
rename  rcutyp58 hi_unins
rename  rcutyp57 medicaid
rename ehemply hi_type
rename ehiowner hi_owner
rename  tpmsum1 wage_month
rename epayhr1 paid_hour_dummy
rename rprvhi hi_private
rename  tfipsst  state
rename  erace race
rename ems m_status
rename eeducate ed_status
rename  ejbhrs1 work_hour
rename rmesr emp_status
rename rwkesr1 emp_w1
rename rwkesr2 emp_w2
rename rwkesr3 emp_w3
rename rwkesr4 emp_w4
rename rwkesr5 emp_w5
rename eeno1 job_id
rename efnp family_size
rename tempall1 firm_size

gen self_dummy=.
replace self_dummy=1 if ebuscntr>=0 

gen gov_dummy=.
replace gov_dummy=1 if eclwrk1==3|eclwrk1==4|eclwrk1==5

gen emp_status_dummy=1 if emp_status>=1 & emp_status<=5
replace emp_status_dummy=0 if emp_status> 5

bys ssuid  epppnum: egen emp_4_status=sum(emp_status_dummy)

gen hi_status=.
replace hi_status=0 if hi_unins==2 
replace hi_status=1 if hi_private==1 & (hi_owner==1| hi_owner==3)
replace hi_status=2 if hi_private==2 & (hi_owner==1| hi_owner==3)
replace hi_status=3 if medicaid==1

gen year=2007

save "C:\SIPP\2004\adjusted_data_file\sippl04puw12.dta", replace

clear




use "C:\SIPP\2004\adjusted_data_file\sippl04puw1.dta", clear

append using "C:\SIPP\2004\adjusted_data_file\sippl04puw2.dta"
append using "C:\SIPP\2004\adjusted_data_file\sippl04puw3.dta"
append using "C:\SIPP\2004\adjusted_data_file\sippl04puw4.dta"
append using "C:\SIPP\2004\adjusted_data_file\sippl04puw5.dta"
append using "C:\SIPP\2004\adjusted_data_file\sippl04puw6.dta"
append using "C:\SIPP\2004\adjusted_data_file\sippl04puw7.dta"
append using "C:\SIPP\2004\adjusted_data_file\sippl04puw8.dta"
append using "C:\SIPP\2004\adjusted_data_file\sippl04puw9.dta"
append using "C:\SIPP\2004\adjusted_data_file\sippl04puw10.dta"
append using "C:\SIPP\2004\adjusted_data_file\sippl04puw11.dta"
append using "C:\SIPP\2004\adjusted_data_file\sippl04puw12.dta"

* drop data based on sex and age

sort ssuseq  ssuid  swave  spanel   srotaton  

* drop if former job coverage is positive
sort ssuid epppnum year
save "C:\SIPP\2004\adjusted_data_file\master_core.dta", replace  



use "C:\SIPP\2004\adjusted_data_file\master_topical.dta", clear  
sort ssuid epppnum year
save "C:\SIPP\2004\adjusted_data_file\master_topical.dta", replace  
use "C:\SIPP\2004\adjusted_data_file\master_core.dta", clear  
merge ssuid epppnum year using "C:\SIPP\2004\adjusted_data_file\master_topical.dta"
save "C:\SIPP\2004\adjusted_data_file\full_panel.dta", replace  

* epppnum is recorded differently from others
destring epppnum, replace
* string epppnum, replace


* renmae job id to avoid confusion wrt not in universe
replace job_id=. if job_id==-1
drop if srefmon==.
drop if swave==.
* create month variable
gen month=1 if  (swave==1 &  srefmon==1) | (swave==4 &  srefmon==1) | (swave==7 &  srefmon==1) | (swave==10 &  srefmon==1)
replace month=2 if  (swave==1 &  srefmon==2) | (swave==4 &  srefmon==2) | (swave==7 &  srefmon==2) | (swave==10 &  srefmon==2)
replace month=3 if  (swave==1 &  srefmon==3) | (swave==4 &  srefmon==3) | (swave==7 &  srefmon==3) | (swave==10 &  srefmon==3)
replace month=4 if  (swave==1 &  srefmon==4) | (swave==4 &  srefmon==4) | (swave==7 &  srefmon==4) | (swave==10 &  srefmon==4)
replace month=5 if  (swave==2 &  srefmon==1) | (swave==5 &  srefmon==1) | (swave==8 &  srefmon==1) | (swave==11 &  srefmon==1)
replace month=6 if  (swave==2 &  srefmon==2) | (swave==5 &  srefmon==2) | (swave==8 &  srefmon==2) | (swave==11 &  srefmon==2)
replace month=7 if  (swave==2 &  srefmon==3) | (swave==5 &  srefmon==3) | (swave==8 &  srefmon==3) | (swave==11 &  srefmon==3)
replace month=8 if  (swave==2 &  srefmon==4) | (swave==5 &  srefmon==4) | (swave==8 &  srefmon==4) | (swave==11 &  srefmon==4) 
replace month=9 if  (swave==3 &  srefmon==1) | (swave==6 &  srefmon==1) | (swave==9 &  srefmon==1) | (swave==12 &  srefmon==1)
replace month=10 if  (swave==3 &  srefmon==2) | (swave==6 &  srefmon==2) | (swave==9 &  srefmon==2) | (swave==12 &  srefmon==2)
replace month=11 if  (swave==3 &  srefmon==3) | (swave==6 &  srefmon==3) | (swave==9 &  srefmon==3) | (swave==12 &  srefmon==3)
replace month=12 if  (swave==3 &  srefmon==4) | (swave==6 &  srefmon==4) | (swave==9 &  srefmon==4) | (swave==12 &  srefmon==4)
order month
sort  ssuid epppnum year month
drop if  srefmon==.
gen total_month=month
replace total_month=month+12 if swave==4 | swave==5 | swave==6 
replace total_month=month+24 if swave==7 | swave==8 | swave==9
replace total_month=month+36 if swave==10 | swave==11 | swave==12




sort  ssuid epppnum year total_month

egen id=concat( ssuid  epppnum)

* drop if workers experience either self-employed or public jobs
* bys id: egen self_sum=sum(self_dummy)
* bys id: egen gov_sum=sum(gov_dummy)

* drop if self_sum>0
* drop if gov_sum>0

drop weight_h swave spanel srotaton  srefmon  rhcalmn ssuseq  ssuid  emp_w2 emp_w3 emp_w4 emp_w5 _merge  hi_unins hi_private medicaid hi_owner epppnum ssuid medicaid year  paid_hour_dummy month eclwrk1 ebuscntr emp_status_dummy 



reshape wide race sex age wage_month weight_p hi_status state m_status ed_status work_hour emp_status emp_w1 tot_wealth home_equity business_equity vehicle_equity net_worth health_status oop hi_premium job_id family_size emp_4_status ehi_month ins_reason er25 epatanf5 er27 army_status education_eonrollment self_dummy gov_dummy hi_type ecrmth essself firm_size , i(id) j(total_month)
save "C:\SIPP\2004\adjusted_data_file\master_panel.dta", replace  


* keep id sex1 sex13 sex25 sex37 race1 race13 race25 race37 state1 state13 state25 state37 age1 age13 age25 age37 health_status1 health_status13 health_status25 health_status37 oop1 oop13 oop25 oop37 hi_premium1 hi_premium13 hi_premium25 hi_premium37 m_status1 m_status13 m_status25 m_status37 ed_status1 ed_status13 ed_status25 ed_status37 hi_status1 hi_status5 hi_status9 hi_status13 hi_status17 hi_status21 hi_status25 hi_status29 hi_status33 hi_status37 weight_p1 weight_p5 weight_p9 weight_p13 weight_p17 weight_p21 weight_p25 weight_p29 weight_p33 weight_p37 job_id1 job_id5 job_id9 job_id13 job_id17 job_id21 job_id25 job_id29 job_id33 job_id37 emp_status1 emp_status5 emp_status9 emp_status13 emp_status17 emp_status21 emp_status25 emp_status29 emp_status33 emp_status37 wage_month1 wage_month5 wage_month9 wage_month13 wage_month17 wage_month21 wage_month25 wage_month29 wage_month33 wage_month37 family_size1 family_size13 family_size25 family_size37 emp_4_status1 emp_4_status5 emp_4_status9 emp_4_status13 emp_4_status17 emp_4_status21 emp_4_status25 emp_4_status29 emp_4_status33 emp_4_status37 emp_status2 emp_status3 emp_status4 emp_status6 emp_status7 emp_status8 emp_status10 emp_status11 emp_status12 emp_status14 emp_status15 emp_status16 emp_status18 emp_status19 emp_status20 emp_status22 emp_status23 emp_status24 emp_status26 emp_status27 emp_status28 emp_status30 emp_status31 emp_status32 emp_status34 emp_status35 emp_status36 emp_status38 emp_status39 emp_status40 ins_reason1 ins_reason5 ins_reason9 ins_reason13 ins_reason17 ins_reason21 ins_reason25 ins_reason29 ins_reason33 ins_reason37 ehi_month1 ehi_month2 ehi_month3 ehi_month4 ehi_month5 ehi_month6 ehi_month7 ehi_month8 ehi_month9 ehi_month10 ehi_month11 ehi_month12 ehi_month13 ehi_month14 ehi_month15 ehi_month16 ehi_month17 ehi_month18 ehi_month19 ehi_month20 ehi_month21 ehi_month22 ehi_month23 ehi_month24 ehi_month25 ehi_month26 ehi_month27 ehi_month28 ehi_month29 ehi_month30 ehi_month31 ehi_month32 ehi_month33 ehi_month34 ehi_month35 ehi_month36 ehi_month37 ehi_month38 ehi_month39 ehi_month40 army_status1 army_status5 army_status9 army_status13 army_status17 army_status21 army_status25 army_status29 army_status33 army_status37 education_eonrollment1 education_eonrollment5 education_eonrollment9 education_eonrollment13 education_eonrollment17 education_eonrollment21 education_eonrollment25 education_eonrollment29 education_eonrollment33 education_eonrollment37 er251 er255 er259 er2513 er2517 er2521 er2525 er2529 er2533 er2537 er271 er275 er279 er2713 er2717 er2721 er2725 er2729 er2733 er2737 epatanf51 epatanf55 epatanf59 epatanf513 epatanf517 epatanf521 epatanf525 epatanf529 epatanf533 epatanf537 self_dummy1 self_dummy5 self_dummy9 self_dummy13 self_dummy17 self_dummy21 self_dummy25 self_dummy29 self_dummy33 self_dummy37 gov_dummy1 gov_dummy5 gov_dummy9 gov_dummy13 gov_dummy17 gov_dummy21 gov_dummy25 gov_dummy29 gov_dummy33 gov_dummy37 hi_type1 hi_type5 hi_type9 hi_type13 hi_type17 hi_type21 hi_type25 hi_type29 hi_type33 hi_type37 firm_size1 firm_size5 firm_size9 firm_size13 firm_size17 firm_size21 firm_size25 firm_size29 firm_size33 firm_size37

* sample selection (more restriction will be added in sip04_data_gen_jmp)


keep if sex1==1 | sex13==1 | sex25==1 | sex37==1   
count
keep if (age1>24 & age1<=65) | age1==.
keep if (age13>24 & age13<=65) | age13==.
keep if (age25>24 & age25<=65) | age25==.
keep if (age37>24 & age37<=65) | age37==.
count
drop if (army_status1==1 | army_status5==1 | army_status9==1 | army_status13==1 | army_status17==1 | army_status21==1 | army_status25==1 | army_status29==1 | army_status33==1 | army_status37==1 | army_status41==1 | army_status45==1 ) 
count
drop if (education_eonrollment1==1 | education_eonrollment5==1 | education_eonrollment9==1 | education_eonrollment13==1 | education_eonrollment17==1 | education_eonrollment21==1 | education_eonrollment25==1 | education_eonrollment29==1 | education_eonrollment33==1 | education_eonrollment37==1 | education_eonrollment41==1 | education_eonrollment45==1  ) 
count
drop if (er251==1 | er255==1 | er259==1 | er2513==1 | er2517==1 | er2521==1 | er2525==1 | er2529==1 | er2533==1 | er2537==1 | er2541==1  | er2545==1 ) 
count
drop if (er271==1 | er275==1 | er279==1 | er2713==1 | er2717==1 | er2721==1 | er2725==1 | er2729==1 | er2733==1 | er2737==1 | er2741==1 | er2745==1  ) 
count
drop if (epatanf51==1 | epatanf55==1 | epatanf59==1 | epatanf513==1 | epatanf517==1 | epatanf521==1 | epatanf525==1 | epatanf529==1 | epatanf533==1 | epatanf537==1 | epatanf541==1 | epatanf545==1 ) 
count
drop if (self_dummy1==1 | self_dummy5==1 | self_dummy9==1 | self_dummy13==1 | self_dummy17==1 | self_dummy21==1 | self_dummy25==1 | self_dummy29==1 | self_dummy33==1 | self_dummy37==1 | self_dummy41==1 | self_dummy45==1 ) 
count
drop if (gov_dummy1==1 | gov_dummy5==1 | gov_dummy9==1 | gov_dummy13==1 | gov_dummy17==1 | gov_dummy21==1 | gov_dummy25==1 | gov_dummy29==1 | gov_dummy33==1 | gov_dummy37==1 | gov_dummy41==1 | gov_dummy45==1 ) 
count
drop if (hi_type1==2 | hi_type5==2 | hi_type9==2 | hi_type13==2 | hi_type17==2 | hi_type21==2 | hi_type25==2 | hi_type29==2 | hi_type33==2 | hi_type37==2 | hi_type41==2 | hi_type45==2 ) 
count
 drop if ( hi_status1==3) | ( hi_status5==3) | (hi_status9==3) | ( hi_status13==3) | ( hi_status17==3) | (hi_status21==3) | ( hi_status25==3) | ( hi_status29==3) | (hi_status33==3) | ( hi_status37==3) | ( hi_status41==3) | ( hi_status45==3) 
count


* drop if medicare holder
drop if (ecrmth1==1 | ecrmth5==1 | ecrmth9==1 | ecrmth13==1 | ecrmth17==1 | ecrmth21==1 | ecrmth25==1 | ecrmth29==1 | ecrmth33==1 | ecrmth37==1 | ecrmth41==1 | ecrmth45==1 ) 

* drop if social security income is positive
drop if (essself1==1 | essself5==1 | essself9==1 | essself13==1 | essself17==1 | essself21==1 | essself25==1 | essself29==1 | essself33==1 | essself37==1 | essself41==1 | essself45==1 ) 


* drop army_status1 army_status5 army_status9 army_status13 army_status17 army_status21 army_status25 army_status29 army_status33 army_status37  education_eonrollment1 education_eonrollment5 education_eonrollment9 education_eonrollment13 education_eonrollment17 education_eonrollment21 education_eonrollment25 education_eonrollment29 education_eonrollment33 education_eonrollment37 er251 er255 er259 er2513 er2517 er2521 er2525 er2529 er2533 er2537 er271 er275 er279 er2713 er2717 er2721 er2725 er2729 er2733 er2737 epatanf51 epatanf55 epatanf59 epatanf513 epatanf517 epatanf521 epatanf525 epatanf529 epatanf533 epatanf537 self_dummy1 self_dummy5 self_dummy9 self_dummy13 self_dummy17 self_dummy21 self_dummy25 self_dummy29 self_dummy33 self_dummy37 gov_dummy1 gov_dummy5 gov_dummy9 gov_dummy13 gov_dummy17 gov_dummy21 gov_dummy25 gov_dummy29 gov_dummy33 gov_dummy37 hi_type1 hi_type5 hi_type9 hi_type13 hi_type17 hi_type21 hi_type25 hi_type29 hi_type33 hi_type37 


save "C:\SIPP\2004\adjusted_data_file\tabulation_data_jmp.dta", replace


